\\ Copyright 2017, 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
default(strictargs,1);
\\default(parisizemax,300*10^6);
read("alternate-defines.gp");

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

WparTerm_by_sum(w,h,x,y) = \
  sum(y2=0,h, sum(x2=-y2,w-y2, abs(x-x2)+abs(y-y2)));

Wpar_by_sum(w,h) = \
  1/2 * sum(y=0,h, sum(x=-y,w-y, WparTerm_by_sum(w,h,x,y)));

Wpar_by_sum=memoize(Wpar_by_sum);

\\                *--*            *--*--*       
\\                   |               |  |     
\\       *--*        *--*            *--*--*
\\          |           |               |  |  
\\ *---*    *---*       *---*           *--*--*

check_exact(Wpar_by_sum(1,0), 1);
check_exact(Wpar_by_sum(1,1), 1+2+3 + 1+2 + 1);
check_exact(Wpar_by_sum(1,2), Wpath(6));
check_exact(Wpar_by_sum(2,1), 1+2+2+3+4 + 1+1+2+3 + 1+2+2 + 1+2 + 1);


\\-----------------------------------------------------------------------------
Wrect(w,h) = 1/6 * w*h * (w+h) * (w*h - 1);


Wpar_by_Wrect(w,h) =
{
  my(m=min(w,h),M=max(w,h));
  if(w<=1, return(0));
  Wrect(w,h)
  +
  1/60*(
        +  5 * w*h * m * (2*h*(M-w) + m^2 )
        + 10 * w*h * h
        - 15 * w*h * m
        - (m-2)*(m-1)*m*(m+1)*(m+2)
       );
}
matrix(5,5,w,h, Wpar(w,h)) - \
matrix(5,5,w,h, Wpar_by_Wrect(w,h))
check_exact(matrix(15,15,w,h, Wpar(w,h)), \
            matrix(15,15,w,h, Wpar_by_Wrect(w,h)))
quit


Wpar_by_Wrect(w,h) =
{
  my(m=min(w,h),M=max(w,h));
  if(w<=1, return(0));
  Wrect(w,h)
  +
  1/60*(
        +  5 * w*h * m * ( (2*h-M)*M + (M-m)^2 )
        + 10 * w*h * h
        - 15 * w*h * m
        - (m-2)*(m-1)*m*(m+1)*(m+2)
       );
}
matrix(5,5,w,h, Wpar(w,h)) - \
matrix(5,5,w,h, Wpar_by_Wrect(w,h))
check_exact(matrix(15,15,w,h, Wpar(w,h)), \
            matrix(15,15,w,h, Wpar_by_Wrect(w,h)))
quit

Wpar_by_Wrect(w,h) =
{
  my(m=min(w,h),M=max(w,h));
  if(w<=1, return(0));
  Wrect(w,h)
  +
  1/60*(
        +  5 * w*h * m * ( h*(2*M-w) - m*(M-m) )
        + 10 * w*h * h
        - 15 * w*h * m
        - (m-2)*(m-1)*m*(m+1)*(m+2)
       );
}
matrix(5,5,w,h, Wpar(w,h)) - \
matrix(5,5,w,h, Wpar_by_Wrect(w,h))
matrix(5,15,w,h, Wpar(w,h)) - \
matrix(5,15,w,h, Wrect(w,h))
check_exact(matrix(15,15,w,h, Wpar(w,h)), \
            matrix(15,15,w,h, Wpar_by_Wrect(w,h)))
quit

Wpar_by_Wrect(w,h) =
{
  my(m=min(w,h),M=max(w,h));
  if(w<=1, return(0));
  Wrect(w,h)
  +
  1/60*(
        + 10 * w*h * w*h * ( M-w )        \\ M-w == h-m
        +  5 * w*h * m^2 * ( m )
        + 10 * w*h * h
        - 15 * w*h * m
        - (m-2)*(m-1)*m*(m+1)*(m+2)
       );
}
matrix(5,5,w,h, Wpar(w,h)) - \
matrix(5,5,w,h, Wpar_by_Wrect(w,h))
check_exact(matrix(15,15,w,h, Wpar(w,h)), \
            matrix(15,15,w,h, Wpar_by_Wrect(w,h)))
quit

\\ vector(20,m, (m-2)*(m-1)*m*(m+1)*(m+2))     \\ A052787
\\ vector(20,m, m^5 - (m-2)*(m-1)*m*(m+1)*(m+2))
\\ vector(20,m, - (m-2)*(m-1)*m*(m+1)*(m+2) > -m^5)
\\ factor( m^5 - (m-2)*(m-1)*m*(m+1)*(m+2))
\\ ( m^5 - (m-2)*(m-1)*m*(m+1)*(m+2)) == m*(5*m^2 - 4)
\\ quit



Wpar_by_Wrect(w,h) =
{
  my(m=min(w,h),M=max(w,h));
  if(w<=1, return(0));
  Wrect(w,h)
  +
  1/60*(
        - 10 * w*h * w*h  * (w)
        + 10 * w*h * w*h*( M )
        +  5 * w*h * m*( m^2 )
        + 10 * w*h * h
        - 15 * w*h * m
        - m*(m-1)*(m-2)*(m+1)*(m+2)
       );

  \\ 1/12 * w*h* (
  \\              + m *( m^2 + 2*M*(h-m) - 3 )
  \\              - 2*(2*w+h)
  \\             )
  \\ - 1/60*m*(m-1)*(m-2)*(m+1)*(m+2);
}
matrix(5,5,w,h, Wpar(w,h)) - \
matrix(5,5,w,h, Wpar_by_Wrect(w,h))

quit



\\-----------------------------------------------------------------------------
(  2*h*w^2 + (2*h^2 - 2*h - 2)*w + (h^3 - 2*h^2 - h + 2) ) \
  - ( (w-1)*(w+h)*(2*h) + h*(h-1)*(h+1) - 2*(w-1) )

(  2*h*w^2 + (2*h^2 - 2*h - 2)*w + (h^3 - 2*h^2 - h + 2) ) \
  - ( h*( 2*(w-1)*(w+h) + (h-1)*(h+1) ) - 2*(w-1) )

(  2*h*w^2 + (2*h^2 - 2*h - 2)*w + (h^3 - 2*h^2 - h + 2) ) \
  - ( (w-1)*(2*h*(w+h) - 2)  + h*(h-1)*(h+1) )



\\-----------------------------------------------------------------------------

Wpar(w,h) = 
{
  w++; h++;
  1/60 *
  if (w<=h,
      5*w^2*h*(w^2 + 4*h^2  - 5)
      - w*(w-1)*(w-2)*(w+1)*(w+2)
      ,
      5*h^2*w*(w^2 + (w+h)^2 - 5 ) - 10*w*h*(w-h)
      - h*(h-1)*(h-2)*(h+1)*(h+2)
     );
}
check_exact(matrix(15,15,w,h,w--;h--; Wpar_by_sum(w,h)), \
            matrix(15,15,w,h,w--;h--; Wpar(w,h)))

( 5*h^2*w*( h^2 + 2*w*h + 2*w^2 - 5 ) - 5*w*h*(2*w - 2*h) )-\
( 10*h^2*w^2*(w + h) - 10*w^2*h + 5*w*h^2*(h^2 - 3) )

Wpar(w,h) = 
{
  w++; h++;
  1/60 *
  if (w<=h,
      5*w^2*h*(4*h^2 + w^2 - 5)
      - w*(w-1)*(w-2)*(w+1)*(w+2)
      ,
      5*h^2*w*( h^2 + 2*w*h + 2*w^2 - 5 ) - 10*w*h*(w-h)
      - h*(h-1)*(h-2)*(h+1)*(h+2)
     );
}
check_exact(matrix(15,15,w,h,w--;h--; Wpar_by_sum(w,h)), \
            matrix(15,15,w,h,w--;h--; Wpar(w,h)))

{
(       5*h*(w+1)*( 2*(w+1)*(h+1)*(w + h - 3)  + h*(h-3)*(h-1) - 2*w^2 + 2*w + 8 )
      - (h-2)*(h-1)*h*(h+1)*(h+7)
 )-\
( 5*h^2*w*( h^2 + 2*w*h + 2*w^2 - 5 ) - 10*w*h*(w-h)
 -h^5 + 5*h^3 - 4*h )
}

( 5*h*(w+1)*( 2*(w+1)*(h+1)*(w + h - 3)  + h*(h-3)*(h-1) - 2*w^2 + 2*w + 8 ) )-\
( 5*h^2*w*( h^2 + 2*w*h + 2*w^2 - 5 ) - 5*w*h*(2*w+3*h) + 5*h^4 - 10*h^3 - 5*h^2 + 25*w*h^2 + 10*h  )

( 5*h*(w+1)*( 2*(w+1)*(h+1)*(w + h - 3)  + h*(h-3)*(h-1) - 2*w^2 + 2*w + 8 ) )-\
( 5*h^2*w*( h^2 + 2*w*h + 2*w^2 ) - 5*w*h*(2*w+3*h) + 5*h^4 - 10*h^3 - 5*h^2  + 10*h    )

Wpar(w,h) = 
{
  w++; h++;
  if (w>=h,
      5*h*(w+1)*( 2*(w+1)*(h+1)*(w + h - 3)  + h*(h-3)*(h-1) - 2*w^2 + 2*w + 8 )
      - (h-2)*(h-1)*h*(h+1)*(h+7)
      ,
      5*w^2*h*( 4*h*(h-1) + (w-1)*(w+1) + 4*h - 4 )
      - w^5 + 5*w^3 - 4*w
     )
  / 60;
}
check_exact(matrix(15,15,w,h,w--;h--; Wpar_by_sum(w,h)), \
            matrix(15,15,w,h,w--;h--; Wpar(w,h)))

( 5*w^2*(h+1)*( 4*h*(h-1) + (w-1)*(w+1) ) ) - \
( 5*w^2*h*( 4*h*(h-1) + (w-1)*(w+1) + 4*h - 4 ) + 5*w^2*(w+1)*(w-1) )


Wpar(w,h) = 
{
  w++; h++;
  if (w>=h,
      5*h*(w+1)*( 2*(w+1)*(h+1)*(w + h - 3)  + h*(h-3)*(h-1) - 2*w^2 + 2*w + 8 )
      - (h-2)*(h-1)*h*(h+1)*(h+7)
      ,
      5*w^2*(h+1)*( 4*h*(h-1) + (w-1)*(w+1) )
      - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )
  / 60;
}
check_exact(matrix(15,15,w,h,w--;h--; Wpar_by_sum(w,h)), \
            matrix(15,15,w,h,w--;h--; Wpar(w,h)))

Wpar(w,h) = 
{
  w++; h++;
  if (w>=h,
      5*h*(w+1)*( 2*(w+1)*h*(w + h - 2)  + h*(h-3)*(h-1) - 2*(w-1) )
      - (h-2)*(h-1)*h*(h+1)*(h+7)
      ,
      5*w^2*(h+1)*( 4*h*(h-1) + (w-1)*(w+1) )
      - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )
  / 60;
}
check_exact(matrix(15,15,w,h,w--;h--; Wpar_by_sum(w,h)), \
            matrix(15,15,w,h,w--;h--; Wpar(w,h)))

quit



\\-----------------------------------------------------------------------------

\\ when w>=h

v= vector(10,w,w+=14;  \
          polinterpolate(vector(10,h, Wpar_by_sum(w,h)),,'h))
p = polinterpolate(v,,'w)
p = subst(p,'w,'w-15)

p = subst(p,'h,'h-1);
p = subst(p,'w,'w-1);
print();
p
p*60

60*p - ( -h^5 + (5*w - 5)*h^4 + (10*w^2 - 20*w + 15)*h^3 + (10*w^3 - 30*w^2 + 15*w + 5)*h^2 + (-10*w^2 + 20*w - 14)*h )

60*p - ( (5*w)*h^4 + (10*w^2 - 20*w)*h^3 + (10*w^3 - 30*w^2 + 15*w)*h^2 + (-10*w^2 + 20*w)*h  - (h-2)*(h-1)*h*(h+1)*(h+7) )

60*p - ( 10*w^2*h^2*(h + w - 3) - 20*w*h*h^2 + 5*w*h^4  + 15*w*h^2 + (-10*w^2 + 20*w)*h  - (h-2)*(h-1)*h*(h+1)*(h+7) )

60*p - ( 10*w*h*w*h*(h + w - 3) + 5*w*h*(h^3 - 4*h^2 + 3*h - 2*w + 4 )  - (h-2)*(h-1)*h*(h+1)*(h+7) )

60*p - ( 5*w*h*(w*h*(2*h + 2*w - 6)  + h*(h-3)*(h-1)  - 2*(w-2) )  - (h-2)*(h-1)*h*(h+1)*(h+7) )

(w*h*(2*h + 2*w - 6)  + h*(h-3)*(h-1)  - 2*(w-2)) - \
( (w+h-2)*(w+h+1)*(2*h+2) )

60*p - ( 5*w*h*(w*h*2*(w + h - 3)  + h*(h-3)*(h-1) - 2*(w-2) )  - (h-2)*(h-1)*h*(h+1)*(h+7) )


Wpar(w,h) = 
{
  subst(subst(p,'w,w),'h,h);
}

(matrix(8,8,w,h,w+=10; Wpar_by_sum(w,h))) == \
(matrix(8,8,w,h,w+=10; Wpar(w+2,h+1)))

Wpar(w,h) = 
{
  w++; h++;
  ( 5*(w+1)*h*((w+1)*h*2*(w + h - 2)  + h*(h-3)*(h-1) - 2*(w-1) )
   - (h-2)*(h-1)*h*(h+1)*(h+7)
  ) / 60;
}

(matrix(8,8,w,h,w+=10; Wpar_by_sum(w,h))) == \
(matrix(8,8,w,h,w+=10; Wpar(w,h)))


quit
\\-----------------------------------------------------------------------------

\\ when h>=w

v= vector(10,h,h+=14;  \
          polinterpolate(vector(10,w, Wpar_by_sum(w,h)),,'w))
p = polinterpolate(v,,'h)
p = subst(p,'h,'h-15)

p = subst(p,'h,'h-1)
p = subst(p,'w,'w-1)
p*60

60*p - ( 20*h^3*w^2 - 60*h^2*w^2 + 35*h*w^2 + 5*w^2 - w^5 + 5*h*w^4 - 5*w^4 + 5*w^3 - 4*w )
60*p - ( 20*h^2*w^2*(h - 3)  + 5*w^2*h*(w^2 + 7) - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )

60*p - ( 5*w^2*h*(4*h*h - h*12  + w^2 + 7) - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )
60*p - ( 5*w^2*h*(4*h^2 + w^2 - 12*h + 7) - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )
60*p - ( 5*w^2*h*(4*(h-1)*(h-2) + (w-1)*(w+1)) - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )


Wpar(w,h) = 
{
  ( 5*w^2*h*(4*(h-1)*(h-2) + (w-1)*(w+1)) - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )
  / 60;
}
(matrix(8,8,w,h,h+=10; Wpar_by_sum(w,h))) == \
(matrix(8,8,w,h,h+=10; Wpar(w+1,h+2)))

Wpar(w,h) = 
{
  w++; h++;
  ( 5*w^2*(h+1)*( 4*h*(h-1) + (w-1)*(w+1) ) - w*(w-1)*(w+1)*(w^2 + 5*w - 4) )
  / 60;
}
(matrix(8,8,w,h,h+=10; Wpar_by_sum(w,h))) == \
(matrix(8,8,w,h,h+=10; Wpar(w,h)))

quit

\\-----------------------------------------------------------------------------

Wpar_each_side(w,h) = sum(x=0,w, sum(y=0,min(h,w-x), y));

\\ if h>w then full columns
Wpar_inc_h(w,h) =
{
  my(debug=0);
  if(debug,  print("within new ",Wpath(w+1)));
  Wpath(w+1) +
  sum(x=0,w,
        sum(y=1,h+1,
              my(xr=w-y,i=max(xr-x,0));
              if(debug,
                 print("x="x
                       " to y="y
                       " i="i
                       " xr="xr
                       "  up ",(w+1)*y,
                       " horiz ",if(x>=xr, x-xr)*(w+1),
                       " path "WpathTerm(w+1, i)
                       " = ", (w+1)*y + if(x>=xr, x-xr)*(w+1) + WpathTerm(w+1, i)));
              (w+1)*y
              + if(x>=xr, x-xr)*(w+1)
              + WpathTerm(w+1, i) 
        ));
}

my(w=2); vector(10,h,h--; Wpar_by_sum(w,h))
my(w=2); vector(10,h,h--; Wpar_by_sum(w,h+1) - Wpar_by_sum(w,h))
my(w=2); vector(10,h,h--; Wpar_inc_h(w,h))

check_exact(matrix(10,10,w,h, Wpar_inc_h(w,h)), \
            matrix(10,10,w,h, Wpar_by_sum(w,h+1) - Wpar_by_sum(w,h)));
quit



\\-----------------------------------------------------------------------------

maxpow = 4;
l=List([]);
seen=Map();
v_to_poly(v) = 'w^v[1] * 'h^v[2] * 'm^v[3];
{
  forvec(v=[[0,maxpow],[0,maxpow],[0,maxpow]], 
        my(p=v_to_poly(v)); 
        if(mapisdefined(seen,p), next());
        if(v[3], if(v[1]||v[2],next()));
        listput(l,v);
        mapput(seen,p,1));
}
l=Vec(l);
print("l size ",matsize(l));

func(w,h) = Wpar_by_sum(w,h);
rows=List([]);
values=List([]);
{
  for(w=0,8,
     for(h=0,8,
        my(m=min(w,h));
        my(row=apply(v->w^v[1]*h^v[2]*m^v[3], l)); \
        my(value=func(w,h)); 
        listput(rows,row); 
        listput(values,value); 
     ));
}
rows=Col(rows);
print("rows size "#rows);
m=Mat(rows);
values=Mat(values)~;
\\ print("m = "m);
print("m size "matsize(m));
print("values size "matsize(values));

\\ M*X = B
\\matsolve(m,values)

d=concat(m,-values);
c=lindep(d);

print("c = "c);
print("c size ",#c)
print("l size ",#l)
{
  for(i=1,#c,
     if(c[i],
        print(c[i]" * "v_to_poly(l[i]))));
}
print(c[#c]);
quit


\\-----------------------------------------------------------------------------
l=List([]);
seen=Map();
v_to_poly(v) = 'w^v[1] * 'h^v[2];
{
  forvec(v=[[0,1],[0,1]], 
        my(p=v_to_poly(v)); 
        if(mapisdefined(seen,p),next());
        listput(l,v);
        mapput(seen,p,1));
}
l=Vec(l)
print("l "l);

func(w,h) = w+h;
rows=List([]);
values=List([]);
{
  for(w=0,5,
     for(h=0,5,my(m=min(w,h)); \
        my(row=apply(v->w^v[1]*h^v[2], l)); \
        my(value=func(w,h)); 
        listput(rows,row); 
        listput(values,value); 
     ));
}
rows=Col(rows);
m=Mat(rows)
values=Mat(values)~
print("m = "m);
print(matsize(m));
print(matsize(values));

check_exact(m*[0;1;1;0], values)


\\ M*X = B
\\matsolve(m,values)

d=concat(m,values);
c=lindep(d);

print("c size ",#c)
print("l size ",#l)
{
  for(i=1,#l,
     if(c[i],
        print(c[i]" * "v_to_poly(l[i]))));
}
print(c[#c]);
quit


