\\ Copyright 2016, 2017, 2018, 2019, 2020 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ THIS IS A GENERATED FILE
\\ Extracted from alternate.tex by gp-inline.
\\
\\ These are Pari/GP functions and definitions used in alternate.tex for
\\ various self-tests and formula checking there.  Names and styles are
\\ highly specific to the calculations there, and many things will change or
\\ disappear, etc, but some of the functions might be useful for
\\ experimenting or testing.


/* ------------------------------------------------------------------------- */
/* gp-inline test boilerplate begin */
gp_inline__location = "";
gp_inline__good = 0;
gp_inline__bad = 0;
gp_inline__check(location,bool) =
{
  gp_inline__location = location;
  check(bool);
}
/* this is thinking about a check() for use in loops or "GP-Inline ..."
   testing, but it's not settled so don't rely on it */
check(bool) =
{
  /* use "===" so that a vector like [1] or float 1.0 not reckoned success */
  if(bool===1, gp_inline__good++,
     bool===0, gp_inline__bad++;
               print(gp_inline__location": gp-inline fail"),
     gp_inline__bad++;
     print(gp_inline__location": gp-inline expected result 0 or 1, got ",
           bool));
}
/* gp-inline test boilerplate end */
/* ------------------------------------------------------------------------- */

gp_inline__location="../alternate.tex:234";
 default(strictargs,1);

gp_inline__location="../alternate.tex:238";
 \\ my http://user42.tuxfamily.org/pari-geom/index.html
 iferr(read("tools/geom.gp"),   e,read("../tools/geom.gp"));

gp_inline__location="../alternate.tex:241";
 \\ my http://user42.tuxfamily.org/pari-memoize/index.html
 iferr(read("tools/memoize.gp"),e,read("../tools/memoize.gp"));

gp_inline__location="../alternate.tex:244";
 \\ my http://user42.tuxfamily.org/pari-vpar/index.html
 iferr(read("tools/vpar.gp"),      e,read("../tools/vpar.gp"));

gp_inline__location="../alternate.tex:247";
 iferr(read("tools/vecper.gp"),e, \
    read("../tools/vecper.gp"));

gp_inline__location="../alternate.tex:250";
 iferr(read("tools/alternate-oeis-samples.gp"),e, \
    read("../tools/alternate-oeis-samples.gp"));

gp_inline__location="../alternate.tex:253";
 nearly_equal_epsilon = 1e-15;
 nearly_equal(x,y, epsilon=nearly_equal_epsilon) = {
   \\ print(type(x)," ",type(y)," ",x," ",y);
   my(d=x-y); \\ ensure compatible types
   if(type(x)=="t_MAT",x=Vec(x);y=Vec(y));
   if(type(x)=="t_VEC" || type(x)=="t_COL",
        sum(i=1,max(#x,#y), !nearly_equal(x[i],y[i],epsilon)) == 0,
      type(x)=="t_QUAD" || type(x)=="t_COMPLEX",
           nearly_equal(real(x-y),0,epsilon)
        && nearly_equal(imag(x-y),0,epsilon),
      abs(d) < epsilon);
 }

gp_inline__location="../alternate.tex:266";
 sqrt2  = geom_sqrt_as_quad(2);
 sqrt2i = geom_sqrt_as_quad(-2);

gp_inline__location="../alternate.tex:271";
 is_integer(x) = (x==floor(x));

gp_inline__location="../alternate.tex:273";
 \\ Return 1 if x is an integer power of 2, so 2^0, 2^1, etc.
 \\ Return 0 if not.
 is_power_of_2(x) = is_integer(x) && x>=1 && x==2^valuation(x,2);

gp_inline__location="../alternate.tex:284";
 bitlength(n) = if(n, logint(n,2)+1, 0);

gp_inline__location="../alternate.tex:291";
 highbit(n) = {
   n>=1 || error("highbit() is for n>=1");
   1<<logint(n,2);
 }

gp_inline__location="../alternate.tex:298";
 vector_mean(v) = vecsum(v)/#v;
 vector_modulo(v,i) = v[(i% #v)+1];

gp_inline__location="../alternate.tex:301";
 vector_differences(v) = if(#v==0,[], vector(#v-1,i,v[i+1]-v[i]));

gp_inline__location="../alternate.tex:306";
 vector_cumulative(v) = for(i=2,#v,v[i]+=v[i-1]); v;

gp_inline__location="../alternate.tex:312";
 vector_contains(v,elem) = for(i=1,#v,if(v[i]==elem,return(1))); 0;

gp_inline__location="../alternate.tex:314";
 \\ Return v shortened to its first n elements.
 \\ If n==0 then return an empty vector.
 vector_shorten_to(v,n) = if(n,v[1..n],[]);

gp_inline__location="../alternate.tex:318";
 \\ sub and super are Set()s.
 \\ Return 1 if sub is a subset or equal to super.
 set_is_subset(sub,super) = {
   if(!(setisset(sub) && setisset(super)), error("not a Set"));
   setintersect(sub,super) == sub;
 }

gp_inline__location="../alternate.tex:328";
 \\ v is a vector of bits [1,0,1,0,1,1,0] high to low.
 \\ Return them as an integer.
 \\ This uses subst() so bits can be negatives and other unusual
 \\ values, not just 0 and 1.
 from_binary_vector(v) = subst(Pol(v),'x,2);

gp_inline__location="../alternate.tex:338";
 \\ n is an integer with decimal digits representing bits.
 \\ Return the value of those bits.
 from_binary(n) = fromdigits(digits(n),2);

gp_inline__location="../alternate.tex:344";
 \\ n is an integer.  Return an integer whose decimal digits
 \\ are the bits of n.
 to_binary(n)=fromdigits(binary(n));

gp_inline__location="../alternate.tex:350";
 \\ n is an integer.  Return an integer whose decimal digits
 \\ are the bits of n.
 to_base4(n)=fromdigits(digits(n,4));

gp_inline__location="../alternate.tex:358";
 \\ n is an integer with decimal digits representing bits.
 \\ Return the value of those bits.
 from_base4(n) = fromdigits(digits(n),4);

gp_inline__location="../alternate.tex:367";
 \\ Return integer whose decimal digits are the ternary digits of n.
 to_ternary(n) = fromdigits(digits(n,3),10);

gp_inline__location="../alternate.tex:373";
 \\ v is a vector of fractional decimal digits high to low.
 \\ Eg. [1,2,3] is 123/1000 = 0.123
 \\ Return them as a rational like 12981/10^5.
 \\ If v is longer than the current floating point
 \\ precision() then use only that much of v.
 \\ "point" is how many digits before the decimal point.
 \\ "add" is an amount to add at the low end of the digits.
 fromdigits_to_precision(v,point=0, add=0) = {
   my(p = precision(1.0) - 4);
   if(#v>p, v = v[1..p]);
   (fromdigits(v)+add) / 10^(#v-point);
 }

gp_inline__location="../alternate.tex:389";
 \\ n is an integer.  Return is bits as a vector high to low
 \\ padded out with high 0s to make k many bits.
 \\ n must fit within k bits, ie. 0 <= n < 2^k.
 binary_padded(n,k) = {
   my(v = binary(n));
   if(#v>k, error("binary_padded() n=",n," is bigger than k=",k," bits"));
   concat(vector(max(0,k-#v)),v);
 }

gp_inline__location="../alternate.tex:401";
 \\ Like digits() but pad with high 0s to make k many digits.
 \\ Must have n < base^k.
 digits_padded(n,k,base=10) = {
   my(v = digits(n,base));
   if(#v>k, error("digits_padded() n=",n," is bigger than k=",k," digits"));
   concat(vector(max(0,k-#v)),v);
 }

gp_inline__location="../alternate.tex:413";
 \\ Like fromdigits(), but accepting any base, not just integers.
 \\ Would probably like the actual fromdigits() to be this way.
 \\ Terms must not use symbol 'x.
 fromdigits_any(v,base=10) = subst(Pol(v),'x,base);

gp_inline__location="../alternate.tex:420";
 CountOneBits(n) = hammingweight(n);

gp_inline__location="../alternate.tex:424";
 \\ vector_midpoints(v) looks at the elements of vector v
 \\ and returns a new vector which is their successive
 \\ midpoints, ie. the arithmetic mean of adjacent
 \\ v[i] and v[i+1].
 vector_midpoints(v) = if(#v==0,return([])); \
   vector(#v-1,i,(v[i+1]+v[i])/2);

gp_inline__location="../alternate.tex:434";
 \\ Return a vector of the first n coefficients of
 \\ generating function g, starting from term x^0.
 \\ g is normally a polynomial fraction (type t_RFRAC)
 \\ but a plain polynomial is accepted too and returns
 \\ its lowest n coefficients.
 gf_terms(g,n) = \
   my(x = variable(g), \
      zeros = min(n,valuation(g,x)), \
      v = Vec(g + O(x^n))); \
   if(zeros>=0, concat(vector(zeros,i,0), v), \
                v[-zeros+1 .. #v]);

gp_inline__location="../alternate.tex:453";
 gf_term(g,n) = gf_terms(g,n+1)[n+1];

gp_inline__location="../alternate.tex:455";
 \\ select_first_n(f,n) returns a vector of length n which are the
 \\ indices i for which function f(i) is true.
 \\ Indices checked start from 0 so i=0,1,2,...
 select_first_n(f,n) = {
   my(l=List([]), i=0);
   while(#l<n, if(f(i),listput(l,i)); i++);
   Vec(l);
 }

gp_inline__location="../alternate.tex:464";
 \\ Return a vector which is vector v repeated n times.
 \\ n=0 is an empty vector.
 concat_repeat(v,n) = concat(vector(n+1,i,if(i==1,[],v)));

gp_inline__location="../alternate.tex:470";
 \\ m is a map.  Return its value at key, or 0 if no such entry.
 mapget_or_zero(m,key) = if(mapisdefined(m,key), mapget(m,key), 0);

gp_inline__location="../alternate.tex:473";
 \\ table is a matrix where each row is state transitions.
 \\ So table[state,digit] = new_state.
 \\ Return a vector where v[state] = generating function for how
 \\ many digit strings are in state after k steps.
 \\ initial is the starting state.  The k=0 terms of the gfs are
 \\ 1 in v[initial] and 0 everywhere else.
 state_table_to_gfs(table,initial=1) = {
   my(m=state_table_to_matrix(table), l=matsize(m)[1]);
   Vec(matsolve(matid(l)-m*x,vectorv(l,i,i==initial)));
 }
 state_table_to_matrix(table) = {
   my(l=matsize(table)[1], w=matsize(table)[2], m=matrix(l,l));
   for(i=1,l, for(digit=1,w, m[table[i,digit],i]++));
   m;
 }

gp_inline__location="../alternate.tex:489";
 n_odd_part(n) = while(n!=0 && n%2==0, n /= 2); n;

gp_inline__location="../alternate.tex:491";
 \\ return the number of bit runs, either 0s or 1s, of n in binary
 CountBitRuns(n) = {
   my(v=concat(0,binary(n)));
   sum(i=1,#v-1, v[i]==0&&v[i+1]==1);
 }

gp_inline__location="../alternate.tex:497";
 \\ v is a vector of continued fraction terms, as per contfrac().
 \\ Return the fraction it represents.
 \\ Eg. v=[9,8,7,6] gives 9 + 1/(8 + 1/(7 + 1/6))
 contfrac_to_rational(v) = my(m=contfracpnqn(v)); m[1,1]/m[2,1];

gp_inline__location="../alternate.tex:506";
 \\ Return a vector of those n in the range n_lo <= n <= n_hi where
 \\ func(n) is a maximum.
 \\ If there are multiple n with equal maximum then the vector has
 \\ all of them, if not then it is a vector of a single n.
 func_max_n_list_in_range(func,n_lo,n_hi) = {
   my(max_value=func(n_lo),l=List([n_lo]));
   for(n=n_lo+1,n_hi,
       my(value=func(n));
       if(value>max_value,max_value=value;l=List([]));
       if(value==max_value,listput(l,n)));
   Vec(l);
 }

gp_inline__location="../alternate.tex:521";
 \\ Return a vector of those n in the range n_lo <= n <= n_hi where
 \\ func(n) is a minimum.
 \\ If there are multiple n with equal minimum then the vector has
 \\ all of them, if not then it is a vector of a single n.
 func_min_n_list_in_range(func,n_lo,n_hi) = {
   my(min_value=func(n_lo),l=List([n_lo]));
   for(n=n_lo+1,n_hi,
       my(value=func(n));
       if(value<min_value,min_value=value;l=List([]));
       if(value==min_value,listput(l,n)));
   Vec(l);
 }

gp_inline__location="../alternate.tex:536";
 \\ CountLowZeros
 A007814(n) = {
   type(n)=="t_INT" || error();  \\ no valuation() of other things
   n>=1 || error("A007814() is for n>=1");
   valuation(n,2);
 }

gp_inline__location="../alternate.tex:545";
 \\ CountLowZeros + 1
 A001511(n) = {
   n>=1 || error("A001511() is for n>=1");
   valuation(n,2)+1;
 }

gp_inline__location="../alternate.tex:555";
 \\ bivariate generating function for Sum binomial(n,k)*x^n*y^k
 g2binomial(x,y) = 1/(1 - x - x*y);

gp_inline__location="../alternate.tex:562";
 gbinomial_C(k,x) = x^k / (1-x)^(k+1);

gp_inline__location="../alternate.tex:569";
 \\ triangular numbers T(n)
 A000217(n) = 1/2*n*(n+1);

gp_inline__location="../alternate.tex:574";
 A007583(n) = (2*4^n + 1)/3;

gp_inline__location="../alternate.tex:582";
 b = 1+I;

gp_inline__location="../alternate.tex:584";
 \\ Return a vector which is the vertices of alternate paperfolding
 \\ curve level k.  The vector has 2^k+1 integer complex numbers
 \\ (Gaussian integers).
 alternate_points(k) = {
   if(k<0,error("alternate_points() is for k>=0"));
   my(v=[0,1],f=-I);
   for(i=1,k,
       my(end=(1-f)*v[#v]);
       v = concat(v, apply(z->(end+f*z), Vecrev(v[^-1])));
       f=-f);
   v;
 }

gp_inline__location="../alternate.tex:600";
 \\ Return a vector which is the midpoints of the alternate
 \\ curve segments in level k.  There are 2^k segments so
 \\ the vector has 2^k complex number values.
 \\ The first point is at 1/2, being the midpoint of the
 \\ first segment 0 to 1.
 alternate_midpoints(k) = {
   if(k<0,error("alternate_midpoints() is for k>=0"));
   my(v=[1/2], end=1, f=-I);
   for(i=1,k,
       end *= 1-f;
       v = concat(v, apply(z->(end + f*z), Vecrev(v)));
       f=-f);
   v;
 }

gp_inline__location="../alternate.tex:620";
 \\ v is a vector [ bit,bit, ..., bit, [ bit,bit, ... ] ]
 \\ which are bits interpreted as fractional binary.
 \\     f = 0.aaaaa (ppppp)repeat
 \\
 \\ Return a similar vector suitably mangled for an alternate
 \\ paperfolding curve point when taken in powers End(k) by
 \\ vecper_frac_fromdigits().
 \\
 \\ The mangling looks for bit pairs 11 and negates to -1 all the
 \\ 1-bits below, until another 11 flips back to +1 again.  The 11
 \\ bit pairs may overlap.
 \\ This is applied through both fixed and periodic parts.
 \\ The periodic part might increase in length to allow the
 \\ negations to be periodic.
 \\
 vecper_binary_to_alternate(v) = {
   vecper_apply_state((bit,state)->
                      my(prev_bit=state[1],
                         s=state[2]);
                      [ bit*s,      \\ bit with sign
                        [ bit,      \\ new prev_bit
                          s * if(prev_bit==1 && bit==1,
                                 -1, 1)
                      ]],
                      v,
                      [0,    \\ high 0-bit above binary point
                       1]);   \\ initial sign +1
 }

gp_inline__location="../alternate.tex:661";
 alternate_base4_digit_vector = [0,1,1+I,2+I,2];
 alternate_base4_digit(d) = alternate_base4_digit_vector[d+1];
 vecper_base4_to_alternate(v) = {
   vecper_apply_state((digit,state)->
                      my(d=state[1],
                         rev=state[2],
                         out);
                      if(!rev,
                         out=d*alternate_base4_digit(digit);
                         if(digit==1,rev=1;d*=I,
                            digit==3,rev=1;d*=-I)
                         ,
                         out=d*(2-alternate_base4_digit(4-digit));
                         if(digit==0,rev=0;d*=-I,
                            digit==2,rev=0;d*=I));
                      [ out, [d,rev] ],
                      v,
                      [1,    \\ direction I^dir
                       0]);  \\ initial not rev
 }

gp_inline__location="../alternate.tex:689";
 \\ f is a rational fraction 0 <= f <= 1
 \\ Return complex number z location in alternate fractal.
 alternate_fpoint(f) = {
   my(v=vecper_frac_digits(f,4));
   v=vecper_base4_to_alternate(v);
   vecper_frac_fromdigits(v,2);
 }

gp_inline__location="../alternate.tex:1205";
 CountLowOnes(n) = {
   type(n)=="t_INT" || error();  \\ no valuation() of other things
   valuation(n+1,2);
 }

gp_inline__location="../alternate.tex:1212";
 \\ A014707
 BitAboveLowestZero(n) = n+=1; bittest(n, valuation(n,2)+1);

gp_inline__location="../alternate.tex:1243";
 turn_samples_str = \
  "+--+++--+---++-+";

gp_inline__location="../alternate.tex:1252";
 A209615(n) = turn(n);

gp_inline__location="../alternate.tex:1276";
 turn(n) = {
   if(n<1, error("turn() is for n>=1, got ",n));
   if((BitAboveLowestOne(n) + CountLowZeros(n))%2, -1, 1);
 }

gp_inline__location="../alternate.tex:1291";
 BitAboveLowestOne(n) = {
   if(n<1, error("BitAboveLowestOne() is for n>=1, got ",n));
   bittest(n, valuation(n,2)+1);
 }
 BitAboveLowestOne_samples = {[0,0,1,0,0,1,1,0,0,0,1]};

gp_inline__location="../alternate.tex:1306";
 A038189(n) = if(n==0,0, BitAboveLowestOne(n));

gp_inline__location="../alternate.tex:1316";
 CountLowZeros(n) = valuation(n,2);
 CountLowZeros_samples = {[0,1,0,2,0,1,0,3,0,1,0,2,0]};

gp_inline__location="../alternate.tex:1363";
 turn_by_bit_twiddling(n) = {
   if(bitand(bitxor(n,from_binary(1010101010101010)),
      MaskAboveLowestOne(n)),
      1,-1);
 }

gp_inline__location="../alternate.tex:1377";
 MaskAboveLowestOne(n) = 1 + bitxor(n,n-1);

gp_inline__location="../alternate.tex:1380";
 MaskAboveLowestOne_samples = {[2,4,2,8,2,4,2,16,2,4,2,8,2,4,2,32]};

gp_inline__location="../alternate.tex:1406";
 MaskAboveLowestOne_by_Arndt(n) = bitand(n,-n)<<1;

gp_inline__location="../alternate.tex:1410";
 TurnLpred_by_Arndt(k) = {
   my(flip=0);
   while(flip<k,flip=(flip<<2)+2); \\ 10
   my(h=bitand(k,-k));
   h<<=1;  /* MaskAboveLowestOne */
   my(t=bitand(h,bitxor(k,flip)));
   t!=0;
 }

gp_inline__location="../alternate.tex:1450";
 next_turn(n) = \
   if((BitAboveLowestZero(n) + CountLowOnes(n))%2, -1, 1);

gp_inline__location="../alternate.tex:1552";
 gturn_term(x,k) = (-1)^k * x^(2^k) / (1 + x^(2^(k+1)));
 gturn(x,num_terms) = sum(k=0,num_terms-1, gturn_term(x,k)) + 0*x;

gp_inline__location="../alternate.tex:1588";
 TurnLpred(n) = n>=1 && turn(n)==1;

gp_inline__location="../alternate.tex:1590";
 TurnLpred_samples = {[1,0,0,1,1,1,0,0,1,0,0,0,1,1,0,1,1,0]};

gp_inline__location="../alternate.tex:1599";
 A106665(n) = {
   n>=0 || error("A106665() is for n>=0");
   TurnLpred(n+1);
 }

gp_inline__location="../alternate.tex:1611";
 A034947(n) = kronecker(-1,n);
 A096268(n) = valuation(n+1,2)%2;

gp_inline__location="../alternate.tex:1627";
 TurnRpred(n) = n>=1 && turn(n)==-1;

gp_inline__location="../alternate.tex:1629";
 TurnRpred_samples = {[0,1,1,0,0,0,1,1,0,1,1,1,0,0,1,0,0,1]};

gp_inline__location="../alternate.tex:1639";
 A292077(n) = {
   n>=1 || error("A292077() is for n>=1");
   TurnRpred(n);
 }

gp_inline__location="../alternate.tex:1693";
 TurnLpred_morphism_map = {Map([ [0,0],  [[1,1],[0,1]];
                                 [0,1],  [[1,1],[0,0]];
                                 [1,0],  [[1,0],[0,1]];
                                 [1,1],  [[1,0],[0,0]] ])};
 TurnLpred_vector_by_morphism(len) = {
   my(v=[ [1,0] ]);
   while(#v\2 < len,
     v=concat(apply(p->mapget(TurnLpred_morphism_map,p), v)));
   concat(v)[1..len];
 }

gp_inline__location="../alternate.tex:1726";
 gTurnLpred_term(x,k) = \
   x^(vector_modulo([1,3],k)*2^k) / (1 - x^(4*2^k));
 gTurnLpred(x,num_terms) = \
   sum(k=0,num_terms-1, gTurnLpred_term(x,k)) + 0*x;

gp_inline__location="../alternate.tex:1738";
 gTurnRpred_term(x,k) = \
   x^(vector_modulo([3,1],k)*2^k) / (1 - x^(4*2^k));
 gTurnRpred(x,num_terms) = \
   sum(k=0,num_terms-1, gTurnRpred_term(x,k)) + 0*x;

gp_inline__location="../alternate.tex:1875";
 function_run_lengths(f,n) = {
   my(previous=f(1), run=1, v=vector(n), pos=1, i=2);
   while(pos<=#v,
         my(value=f(i));
         if(value==previous,
            run++,
            v[pos]=run; pos++; run=1);
         previous=value; i++);
   v;
 }

gp_inline__location="../alternate.tex:1905";
 TurnRun(m) = {
   m>=0 || error("TurnRun() is for m>=0, got m=",m);
   if(m==0, 1,
      m%2==1, 2 + 1/2* ( turn(m) + turn(m+1) ),
              2 - 1/2* ( turn(m) + turn(m+1) ));
 }

gp_inline__location="../alternate.tex:1916";
 TurnRun_samples = {[1,2,3,2,1,3,2,1,2,2,3,1,2,3,2,2,1,2,3,2,1,3]};

gp_inline__location="../alternate.tex:1929";
 run_lengths_to_vector(runs,values) = {
   concat(vector(#runs,i,
                 vector(runs[i],j, vector_modulo(values,i-1))));
 }

gp_inline__location="../alternate.tex:1950";
 sturn(n) = turn(n) + turn(n+1);

gp_inline__location="../alternate.tex:1963";
 sturn_samples = {[0,-2,0,2,2,0,-2,0,0,-2,-2,0,2,0]};

gp_inline__location="../alternate.tex:1975";
 gsturn(x,num_terms) = -1 + (1+1/x)*gturn(x,num_terms);

gp_inline__location="../alternate.tex:2009";
 gTurnRun_by_gturn(x,k_limit) = \
   -1/2 + 2/(1-x) + 1/2*(-1+1/x)*gturn(-x,k_limit+1);

gp_inline__location="../alternate.tex:2048";
 TurnRunSpred(n) = if(n>=1 && (n==1 || turn(n-1)!=turn(n)), 1, 0);

gp_inline__location="../alternate.tex:2067";
 TurnRunSpred_by_floor(n) = \
   if(n>=1 && (n==1 || turn(floor(n/2))==-(-1)^ceil(n/2)), 1, 0);

gp_inline__location="../alternate.tex:2073";
 TurnRunSpred_samples = {[1,1,0,1,0,0,1,0,1,1,0,0,1,0,1,1]};

gp_inline__location="../alternate.tex:2122";
 TurnRunSpred_LtoH_state_table = TurnRunSpred_LtoH_state_table = {[
   2,3; 4,9; 5,8; 6,9; 7,8; 4,8; 5,9; 10,11; 11,10; 10,10; 11,11]};
 TurnRunSpred_LtoH_accepting = {[0,0,1,0,1,0,1,0,1,0,1]};

gp_inline__location="../alternate.tex:2127";
 TurnRunSpred_LtoH_transition(state,bit) = \
   TurnRunSpred_LtoH_state_table[state,bit+1];
 TurnRunSpred_LtoH_transitions(state,v) = {
   my(state=1);
   for(i=1,#v, state=TurnRunSpred_LtoH_transition(state,v[i]));
   state;
 }
 TurnRunSpred_by_LtoH(n) = {
   my(v=binary(n),
      state=TurnRunSpred_LtoH_transitions(state,Vecrev(v)));
   TurnRunSpred_LtoH_accepting[state];
 }

gp_inline__location="../alternate.tex:2332";
 gTurnRunSpred(x,num_terms) = {
   x
   + (x^2 + x^7)/(1-x^8)
   + sum(k=2,num_terms-1,
         (  x^(vector_modulo([1,3],k)*2^k)
          + x^(vector_modulo([3,1],k)*2^k + 1)
         ) / (1 - x^(4*2^k))
        );
 }

gp_inline__location="../alternate.tex:2424";
 TurnRunStart(m) = {
   m>=0 || error("TurnRunStart() is for m>=0, got m=",m);
   if(m>=1&&turn(m)==-(-1)^m, 2*m, 2*m+1);
 }

gp_inline__location="../alternate.tex:2429";
 TurnRunStart_by_pred(m) = \
   my(n=0); while(m>=0, n++; if(TurnRunSpred(n),m--)); n;

gp_inline__location="../alternate.tex:2451";
 TurnRunStart_samples = {[1,2,4,7,9,10,13,15,16,18,20,23,24]};

gp_inline__location="../alternate.tex:2487";
 gTurnRunStart(x,k_limit) = {
   1/2
   - 3/2*1/(1-x)
   + 2/(1-x)^2
   + 1/2*sum(k=0,k_limit, (-1)^k * (-x)^(2^k) / (1 + x^(2^(k+1))));
 }

gp_inline__location="../alternate.tex:2524";
 \\ v is a vector of continued fraction terms, including integer
 \\ term at v[1].
 contfrac_collapse_zeros(v) = {
   forstep(i=#v-1,2,-1,
           if(v[i]==0,v[i-1]+=v[i+1]; v=v[^i+1]; v=v[^i]));
   v;
 }

gp_inline__location="../alternate.tex:2542";
 Shallit_C_sum(u,k) = sum(j=0,k,(-1)^j/u^2^j);

gp_inline__location="../alternate.tex:2587";
 \\ c is a vector of C terms.
 \\ v is Shallit's index v=0,1,... of the current c.
 \\ Return a vector of C terms for index v+1.
 Shallit_C_expand(c,v) = {
   my(c1=c[^1]);
   my(pre=c1); pre[#pre] -= (-1)^v;
   my(post=Vecrev(c1)); post[1] += (-1)^v;
   concat([c[1..1], pre, post]);
 }
 Shallit_C(u,v) = {
   if(v==0,return([0,u]));  \\ v=0
   my(c=[0,u+1,u-1]);       \\ v=1
   for(i=1,v-1, c=Shallit_C_expand(c,i));  \\ expand i to i+1
   c;
 }

gp_inline__location="../alternate.tex:2615";
 Shallit_C_len(u,len) = Shallit_C(u,#binary(len)+2)[1..len];

gp_inline__location="../alternate.tex:2631";
 contfrac_C_2_0_samples = {[0,2]};

gp_inline__location="../alternate.tex:2643";
 contfrac_C_2_1_samples = {[0,3,1]};

gp_inline__location="../alternate.tex:2656";
 contfrac_C_2_2_samples = {[0,3,2,0,3]};

gp_inline__location="../alternate.tex:2670";
 contfrac_C_2_3_samples = {[0,3,2,0,2,4,0,2,3]};

gp_inline__location="../alternate.tex:2682";
 contfrac_C_2_inf_samples = {[0,3,2,0,2,4,0,2,4,2,2,0,4]};

gp_inline__location="../alternate.tex:2704";
 vector_run_lengths(v) = {
   if(#v==0,return([]));
   my(l=List([]),run=1);
   for(i=2,#v, if(v[i]==v[i-1],run++, listput(l,run);run=1));
   listput(l,run);
   Vec(l);
 }

gp_inline__location="../alternate.tex:2778";
 A999999_C(n) = {
   if(n==0,0,
      n==1,3,
      4 + (-1)^n*(A209615(n) + A209615(n-1)));
 }

gp_inline__location="../alternate.tex:2835";
 Alt_sum(k) = sum(i=0,k,(-1)^i/2^2^i);

gp_inline__location="../alternate.tex:2837";
 \\ Return Alt vector of first n bits below the binary point.
 Alt_vector(n) = vector(n,i,i--; length(binary(i))%2);

gp_inline__location="../alternate.tex:2846";
 \\ Return Alt fraction with n bits below the binary point.
 Alt_sum_for_bits(n) = fromdigits(Alt_vector(n),2)/2^n;

gp_inline__location="../alternate.tex:2863";
 Alt_decimal_sample = {(030860900/100000000)};

gp_inline__location="../alternate.tex:2873";
 Alt_binary_sample = {(0010011110/1000000000)};

gp_inline__location="../alternate.tex:2878";
 turn_continued_fraction_terms(n) = \
   vector(n,m,m-=2; if(m==-1,0, 2*TurnRun(m) + (m==0)));

gp_inline__location="../alternate.tex:2888";
 Alt_continued_fraction_sample = {[3,4,6,4,2,6]};

gp_inline__location="../alternate.tex:2930";
 \\ A030300 OFFSET=1
 A030300(n) = bitnegimply(1,logint(n,2));

gp_inline__location="../alternate.tex:2953";
 A000523(n) = logint(n,2);

gp_inline__location="../alternate.tex:2957";
 A000975(n) = (2<<n)\3;

gp_inline__location="../alternate.tex:2963";
 A079947(n) =  /* my PROG in A079947 */  \
   my(k=logint(n,2), p=(2<<k)\3); if(bittest(k,0), p, n-p);

gp_inline__location="../alternate.tex:2987";
 A030301(n) = 1-A030300(n);

gp_inline__location="../alternate.tex:2990";
 A079954(n) =  /* my PROG in A079954 */  \
   my(k=logint(n,2), p=(2<<k)\3); if(bittest(k,0), n-p, p);

gp_inline__location="../alternate.tex:3033";
 tree_point(d,n, L,R) = \
   my(v = binary_padded(n,d)); prod(i=1,#v, if(v[i],R,L)) * [1;1];
 sbL = [1,0;1,1];
 sbR = [1,1;0,1];
 SB_point(d,n) = tree_point(d,n, sbL, sbR);

gp_inline__location="../alternate.tex:3049";
 gen_contfrac_SB = {[ [1;2], [1;3], [1;4], [2;7], [3;10], [4;13],
   [5;16], [9;29], [13;42], [17;55] ]};
 gen_contfrac_SB_big = 2115391805846073046612386725548759872911872779603489871890231/6854601606552344285799395741761548475769616415351834056588220;

gp_inline__location="../alternate.tex:3056";
 SB(v) = prod(i=1,#v, if(v[i],sbR,sbL)) * [1;1];

gp_inline__location="../alternate.tex:3204";
 TurnLeft_by_pred(m) = {
   m>=0 || error("TurnLeft_by_pred() is for m>=0, got m=",m);
   my(n=0); while(m>=0, n++;m-=TurnLpred(n)); n;
 }
 TurnRight_by_pred(m) = {
   m>=0 || error("TurnRight_by_pred() is for m>=0, got m=",m);
   my(n=0); while(m>=0, n++;m-=TurnRpred(n)); n;
 }

gp_inline__location="../alternate.tex:3217";
 \\ Return the bit position of the highest 1-bit in n.
 \\ Must have n>=1.
 \\ Lowest bit is position 0, so power k such that 2^k is the
 \\ highest 1-bit.  2^k <= n < 2^{k+1}
 high_bit_k(n) = logint(n,2);

gp_inline__location="../alternate.tex:3249";
 TurnLeftRight_k_e(m) = {
   m>=1 || error("TurnLeftRight_k_e() is for m>=1, got m=",m);
   my(k=0,e);
   while(1, e=m-2^k; if(0<=e&&e<2^k,break()); k++);
   [k,e];
 }

gp_inline__location="../alternate.tex:3281";
 TurnLeft(m) = {
   m>=0 || error("TurnLeft() is for m>=0, got m=",m);
   if(m==0,return(1));
   my(k,e);[k,e]=TurnLeftRight_k_e(m);
   if(e==2^k-1, 2^(k+2) - vector_modulo([0,2],k),
      2^(k+2) - TurnRight(2^k - vector_modulo([2,1],k) - e));
 }

gp_inline__location="../alternate.tex:3296";
 TurnLeft_samples = {[1,4,5,6,9,13,14,16,17,20,21,22]};

gp_inline__location="../alternate.tex:3328";
 TurnRight(m) = {
   m>=0 || error("TurnRight() is for m>=0, got m=",m);
   if(m==0,return(2));
   if(m==1,return(3));
   if(m==2,return(7));
   my(k,e);[k,e]=TurnLeftRight_k_e(m);
   if(e==2^k-1, 2^(k+2) - vector_modulo([1,0],k),
      2^(k+2) - TurnLeft(2^k  - vector_modulo([1,2],k) - e));
 }

gp_inline__location="../alternate.tex:3354";
 TurnRight_samples = {[2,3,7,8,10,11,12,15,18,19,23,26]};

gp_inline__location="../alternate.tex:3461";
 TurnLeftOff(m) = 2*m - TurnLeft(m);

gp_inline__location="../alternate.tex:3464";
 TurnLeftOff_samples = {[-1,-2,-1,0,-1,-3,-2,-2,-1,-2,-1,0,0,1,-1]};

gp_inline__location="../alternate.tex:3480";
 TurnRightOff(m) = TurnRight(m) - 2*m;

gp_inline__location="../alternate.tex:3483";
 TurnRightOff_samples = {[2,1,3,2,2,1,0,1,2,1,3,4,3,2,3]};

gp_inline__location="../alternate.tex:3519";
 TurnLeftOff_initial = {[-1,-2]};

gp_inline__location="../alternate.tex:3525";
 TurnLeftOff_end = {[-2,0]};

gp_inline__location="../alternate.tex:3536";
 TurnLeftOff_by_recurrence(m) = {
   if(m<#TurnLeftOff_initial, return(TurnLeftOff_initial[m+1]));
   my(k,e);[k,e]=TurnLeftRight_k_e(m);
   if(e==2^k-1, return(vector_modulo(TurnLeftOff_end,k)));
   TurnRightOff(2^k-1 - e - vector_modulo([1,0],k))
     - vector_modulo([4,2],k);
 }

gp_inline__location="../alternate.tex:3551";
 TurnRightOff_initial = {[2,1,3]};

gp_inline__location="../alternate.tex:3557";
 TurnRightOff_end = {[1,2]};

gp_inline__location="../alternate.tex:3570";
 TurnRightOff_by_recurrence(m) = {
   if(m<#TurnRightOff_initial, return(TurnRightOff_initial[m+1]));
   my(k,e);[k,e]=TurnLeftRight_k_e(m);
   if(e==2^k-1, return(vector_modulo(TurnRightOff_end,k)));
   TurnLeftOff(2^k-1 - e - vector_modulo([0,1],k))
      + vector_modulo([2,4],k);
 }

gp_inline__location="../alternate.tex:3661";
 \\ m = 2^k - 2^l + e
 high_run_k_l_e_d(m) = {
   m>=1 || error("high_run_k_l_e_d() is for m>=1, got m=",m);
   my(k=high_bit_k(m),l=k,e=m); k++;
   while(l>=0 && bittest(m,l),
         e-=2^l;
         l--);    \\ print(k," ",l,"  ",to_binary(e));
   l++;
   my(d=vector_modulo([0,1],k) - vector_modulo([1,0],l));
   [k,l,e,d];
 }

gp_inline__location="../alternate.tex:3703";
 TurnLeftOff_by_high_run(m) = {
   if(m==0,return(-1));
   my(k,l,e,d); [k,l,e,d]=high_run_k_l_e_d(m);

   my(ret=List([]));
   if(e+d < 0,                 listput(ret,0));
   if(e==0 && k%2==1 && l==0,  listput(ret,-2));    \\ d==0
   if(e==2^(l-1)-1 && k%2==1,  listput(ret,-3+d));  \\ d=0,1
   if(#ret,
      #ret==1 || error("Oops, cases not mutually exclusive");
      return(ret[1]));

   TurnLeftOff(e + d) - 2*d;
 }

gp_inline__location="../alternate.tex:3770";
 TurnRightOff_by_high_run(m) = {
   if(m==0,return(2));
   my(k,l,e,d); [k,l,e,d]=high_run_k_l_e_d(m);

   my(ret=List([]));
   if(e-d < 0,                listput(ret,[0,   "e-d<0"]));
   if(l==0,                   listput(ret,[1-d, "1-d"])); \\ d=-1,0
   if(l==1 && k%2==0,         listput(ret,[3,   "3"]));   \\ d=0
   if(e==0         && k%2==0 && l>=2, listput(ret,[2-d, "2-d"]));
   if(e==2^(l-1)-1 && k%2==0 && l>=2, listput(ret,[4+2*d, "4+2d"]));
   if(#ret,
      #ret==1 || error("Oops, m=",m," k=",k," l=",l," e=",e," d=",d," cases not distinct: ",ret);
      return(ret[1][1]));

   TurnRightOff(e - d) - 2*d;
 }

gp_inline__location="../alternate.tex:3813";
 high_run_d(m) = \
   my(k,l,e,d); [k,l,e,d]=high_run_k_l_e_d(m); d;
 high_run_d_samples = {[0,0,-1,0,0,1,0,0,0,0,0,-1,-1,0,-1]};

gp_inline__location="../alternate.tex:3838";
 high_run_d_by_dir(m) = {
   my(k,l,e,d); [k,l,e,d]=high_run_k_l_e_d(m);
   if(l==0, 1/2*(dir(2^k-2^l) - 1),
            1/2*(dir(2^k-2^l)    ));
 }

gp_inline__location="../alternate.tex:3902";
 \\ strip high run of 1s
 high_run_e(m) = \
   my(k,l,e,d); [k,l,e,d]=high_run_k_l_e_d(m); e;

gp_inline__location="../alternate.tex:3908";
 \\ strip high run of 1s then e+d like TurnLeftOff
 high_run_e_plus_d(m) = \
   my(k,l,e,d); [k,l,e,d]=high_run_k_l_e_d(m); e+d;

gp_inline__location="../alternate.tex:3914";
 \\ strip high run of 1s then e+d like TurnRightOff
 high_run_e_minus_d(m) = \
   my(k,l,e,d); [k,l,e,d]=high_run_k_l_e_d(m); e-d;

gp_inline__location="../alternate.tex:3920";
 \\ return the highest run of 1-bits in m, or 0 if no such run
 high_run_extract(m) = {
   my(v=binary(m));
   for(i=1,#v,
       if(v[i]==0, for(j=i+1,#v, v[j]=0); break()));
   fromdigits(v,2);
 }

gp_inline__location="../alternate.tex:3962";
 dTurnLeft(m) = TurnLeft(m+1) - TurnLeft(m);

gp_inline__location="../alternate.tex:3964";
 dTurnLeft_samples = {[3,1,1,3,4,1,2,1,3,1,1,2,1,4,1,3,3]};

gp_inline__location="../alternate.tex:3972";
 dTurnRight(m) = TurnRight(m+1) - TurnRight(m);

gp_inline__location="../alternate.tex:3974";
 dTurnRight_samples = {[1,4,1,2,1,1,3,3,1,4,3,1,1,3,1,2,1]};

gp_inline__location="../alternate.tex:4007";
 dTurnLeft_by_recurrence(m) = {
   if(m==0,return(3));
   my(k,e);[k,e]=TurnLeftRight_k_e(m);
   if(e==2^k-2, vector_modulo([2,1],k),
      e==2^k-1, vector_modulo([1,3],k),
      dTurnRight(2^k-2 - e - vector_modulo([1,0],k)));
 }

gp_inline__location="../alternate.tex:4033";
 dTurnRight_by_recurrence(m) = {
   if(m==0,return(1));
   if(m==1,return(4));
   my(k,e);[k,e]=TurnLeftRight_k_e(m);
   if(e==2^k-2, vector_modulo([3,1],k),
      e==2^k-1, vector_modulo([3,2],k),
      dTurnLeft(2^k-2 - e - vector_modulo([0,1],k)));
 }

gp_inline__location="../alternate.tex:4070";
 Dean_LtoH_1a = 1;
 Dean_LtoH_1b = 2;
 Dean_LtoH_2a = 3;
 Dean_LtoH_4a = 4;
 Dean_LtoH_2b = 5;
 Dean_LtoH_4b = 6;
 Dean_LtoH_1end = 7;
 Dean_LtoH_2end = 8;
 Dean_LtoH_3end = 9;
 Dean_LtoH_4end = 10;
 Dean_state_table = Dean_state_table = {[1,2; 3,4; 1,4; 3,2]};
 Dean_LtoH_state_table = Dean_LtoH_state_table = {[2,3; 7,9; 5,4;
   6,3; 8,10; 10,8; 7,7; 8,8; 9,9; 10,10]};
 Dean_LtoH_state_to_symbol = {[1,1,2,4,2,4,1,2,3,4]};

gp_inline__location="../alternate.tex:4086";
 \\ for bits high to low of index m starting m=0 first term
 Dean_transition(state,bit) = Dean_state_table[state,bit+1];
 Dean_transitions(state,v) = {
   for(i=1,#v, state=Dean_transition(state,v[i]));
   state;
 }
 Dean_by_states_of_m(m) = {
   m>=0 || error("Dean_by_states_of_m() is for m>=0");
   Dean_transitions(1,binary(m));
 }
 Dean(n) = {
   n>=1 || error("Dean() is for n>=1");
   Dean_by_states_of_m(n-1);
 }

gp_inline__location="../alternate.tex:4101";
 vector_find_square_subword(v) = {
   for(i=1,#v,
     for(len=1,(#v-i+1)\2,
       for(j=i,i+len-1,
         if(v[j]!=v[j+len],next(2)));
       return([i,len])));
   'none;
 }
 vector_is_square_free_word(v) = \
   vector_find_square_subword(v)=='none;

gp_inline__location="../alternate.tex:4122";
 vector_is_alternating_parity(v) = \
   for(i=2,#v, (v[i]+v[i-1])%2 || return(0)); 1;

gp_inline__location="../alternate.tex:4152";
 Dean_samples = {[1,2,3,4,1,4,3,2,1,2,3,2,1,4,3,4]};

gp_inline__location="../alternate.tex:4333";
 Dean_LtoH_transition(state,bit) = \
   Dean_LtoH_state_table[state,bit+1];
 Dean_LtoH_transitions(state,v) = {
   for(i=1,#v, state=Dean_LtoH_transition(state,v[i]));
   state;
 }
 Dean_LtoH_by_states_of_m(m) = {
   m>=0 || error();
   Dean_LtoH_state_to_symbol
     [Dean_LtoH_transitions(1,Vecrev(binary(m)))];
 }
 Dean_LtoH(n) = Dean_LtoH_by_states_of_m(n-1);

gp_inline__location="../alternate.tex:4535";
 flip24(n) = if(n==2,4, n==4,2, n);

gp_inline__location="../alternate.tex:4641";
 DeanCumul_vector(len) = vector_cumulative(vector(len,n,Dean(n)));

gp_inline__location="../alternate.tex:4643";
 DeanCumul(n) = sum(i=1,n, Dean(i));

gp_inline__location="../alternate.tex:4670";
 dir_by_turns(n) = sum(i=1,n, turn(i));
 dir_vector_by_turns(len) = \
   vector_cumulative(concat(0,vector(len-1,n,turn(n))));

gp_inline__location="../alternate.tex:4678";
 dir_samples = {[0,1,0,-1,0,1,2,1,0,1,0,-1,-2,-1,0,-1,0,1]};

gp_inline__location="../alternate.tex:4695";
 gdir_term(x,k) = 1/(1-x) * gturn_term(x,k);

gp_inline__location="../alternate.tex:4707";
 \\ good for coeffs of x^n where n < 2^num_terms
 gdir(x,num_terms) = sum(k=0,num_terms-1, gdir_term(x,k)) + 0*x;

gp_inline__location="../alternate.tex:4742";
 dir(n) = {
   n>=0 || error("dir() is for n>=0");
   my(k = if(n,high_bit_k(n)) + 1);
   bittest(n,k)==0 || error();
   sum(j=0, k-1,
       if(bittest(n,j) != bittest(n,j+1), if(j%2==0,1,-1)));
 }

gp_inline__location="../alternate.tex:4751";
 dir_of_bits(v) = {
   v=concat(0,v);
   sum(i=1,#v-1, if(v[i]!=v[i+1], if((#v-i)%2==1,1,-1)));
 }

gp_inline__location="../alternate.tex:4907";
 gdir_01_10_term(k) = \
   (x^(2^k) + x^(2*2^k)) * sum(n=0,2^k-1, x^n) / (1 - x^(2^(k+2)));

gp_inline__location="../alternate.tex:4963";
 \\ Return a vector of digits, high to low, which are +1 and -1
 \\ alternating, and possible 0s.  s is +/-1 and is the lowest
 \\ non-zero in the return (thus determining the signs above).
 n_to_folded(n,s) = {
   my(k=0, l=List([]));
   while(n, my(a=(n%2)*s); listput(l,a);
            n -= a; if(a, s = -s); n /= 2);
   Vecrev(l);
 }

gp_inline__location="../alternate.tex:4978";
 n_to_folded_indices(n,s) = {
   my(v=n_to_folded(n,s));
   apply(i->#v-i, Vec(select(i->i,v,1)));
 }

gp_inline__location="../alternate.tex:5085";
 dir_by_folded(n) = {
   my(v=n_to_folded_indices(n,-1));
   my(t=#v-1);  t%2==1 || error("oops");
   vector_modulo([0,1],n) - sum(i=1,#v, (-1)^v[i]);
 }

gp_inline__location="../alternate.tex:5119";
 dir_prev_by_folded(n) = {
   my(v=n_to_folded_indices(n,1));
   my(t=#v-1); t%2==0 || error("oops");
   vector_modulo([0,1],n) - sum(i=1,#v, (-1)^v[i]);
 }

gp_inline__location="../alternate.tex:5163";
 dir_by_folded_pos(n) = {
   my(v=n_to_folded_indices(n,1));
   (n%2)
   - sum(i=1,#v, (-1)^v[i])
   + turn(n);
 }

gp_inline__location="../alternate.tex:5172";
 dir_by_f2(n) = {
   my(v=n_to_folded_indices(n,1));   \\ print((-1)^(#v));
   (n%2)
   - sum(i=1,#v, (-1)^v[i])
   + if(#v,
        if(turn(n)==-1,
           - (-1)^(v[#v]),         \\ double up
             (-1)^(v[#v]) ))       \\ not last term
   ;
 }

gp_inline__location="../alternate.tex:5186";
 BitAboveLowestOne_by_folded(n) = {
   my(v=n_to_folded_indices(n,1));
   #v>=2 && v[#v-1]==v[#v]+1;
 }

gp_inline__location="../alternate.tex:5193";
 turn_by_folded(n) = {
   my(v=n_to_folded_indices(n,1));
   (-1)^(BitAboveLowestOne(n) + v[#v]);
 }

gp_inline__location="../alternate.tex:5234";
 PmOneBits(n) = {
   n>=0 || error("PmOneBits() is for n>=0");
   sum(i=0,if(n,high_bit_k(n)),
       if(bittest(n,i), if(i%2==0,1,-1)));
 }

gp_inline__location="../alternate.tex:5241";
 PmOneBits_samples = {[0,1,-1,0,1,2,0,1,-1,0,-2,-1,0,1,-1,0]};

gp_inline__location="../alternate.tex:5274";
 Gray(n) = bitxor(n, n\2);
 Gray_of_bits(v) = vector(#v,i, if(i==1,v[i], bitxor(v[i-1],v[i])));

gp_inline__location="../alternate.tex:5282";
 Gray_samples = {[0,1,3,2,6,7,5,4,12,13,15,14,10,11,9,8]};

gp_inline__location="../alternate.tex:5377";
 KochTurn(n) = {
   n>=1 || error("KochTurn() is for n>=1");
   if(CountLowZeros(n)%2==0, 1, -2);
 }

gp_inline__location="../alternate.tex:5385";
 A056832(n) = bitand(n,bitxor(n,n-1))%3;

gp_inline__location="../alternate.tex:5481";
 UnGray(g) = {
   my(v=binary(g),r=0);
   for(i=1,#v,           /* high to low */
           my(new_r = bitxor(r, v[i]));
           v[i] = bitxor(v[i], r);
           r=new_r);
   from_binary_vector(v);
 }

gp_inline__location="../alternate.tex:5493";
 \\ A139351 = count even position 1-bits
 \\ k=logint(n,2) is bit position of highest 1
 \\ if k even, then 2*floor(k/2) = k
 \\ if k odd, then 2*floor(k/2) = k-1 which is the top even position
 A139351(n) = sum(i=0,if(n,logint(n,2)\2), bittest(n,2*i));

gp_inline__location="../alternate.tex:5502";
 \\ A139352 = count odd position 1-bits
 \\ k=logint(n,2) is bit position of highest 1
 \\ if k even, then 2*floor((k-1)/2)+1 = k-11 which is the last
 \\   odd position
 \\ if k odd, then 2*floor((k-1)/2)+1 = k
 A139352(n) = sum(i=0,if(n,(logint(n,2)-1)\2), bittest(n,2*i+1));

gp_inline__location="../alternate.tex:5540";
 A229216_expand(v,rep=1) = {
   for(i=1,rep,
     v = concat(vector(#v,i,
                       if(v[i]==1, [1,-3,2,1],
                          v[i]==2, [2,1,3,2],
                          v[i]==3, [3,2,-1,3],
                          v[i]==-1, [-1,3,-2,-1],
                          v[i]==-2, [-2,-1,-3,-2],
                          v[i]==-3, [-3,-2,1,-3],
                          error()))));
   v;
 }

gp_inline__location="../alternate.tex:5563";
 A229216_vector(len) = {
   my(v=[1]);
   while(#v<len, v=A229216_expand(v));
   v[1..len];
 }

gp_inline__location="../alternate.tex:5571";
 A229216(n) = {
   n>=1 || error("A229216() is for n>=1");
   n--; [1,-3,-2,-1,3,2][sum(i=0,if(n,logint(n,2)), if(bittest(n,i),(-1)^i)) % 6 + 1];
 }

gp_inline__location="../alternate.tex:5582";
 sqrt3i = geom_sqrt_as_quad(-3);
 w6 = 1/2 + 1/2*sqrt3i;
 w3 = w6^2;
 A229216_dir_to_z_map = { Map([1, 1;
                               2, w6;
                               3, w3;
                              -1, -1;
                              -2, -w6;
                              -3, -w3]) };

gp_inline__location="../alternate.tex:5621";
 \\ odd number of low 0-bits, A096268 period-doubling
 KochRpred(n) = {
   n>=1 || error();
   valuation(n,2)%2==1;
 }

gp_inline__location="../alternate.tex:5630";
 \\ even number of low 0-bits, A035263
 KochLpred(n) = {
   n>=1 || error();
   valuation(n,2)%2==0;
 }
 A035263(n) = KochLpred(n);

gp_inline__location="../alternate.tex:5642";
 \\ cumulative KochRpred, A123087
 KochTurnsR(n) = sum(i=1,n, KochRpred(i));
 A123087(n) = KochTurnsR(n);

gp_inline__location="../alternate.tex:5650";
 \\ cumulative KochLpred, A050292
 KochTurnsL(n) = sum(i=1,n, KochLpred(i));
 A050292(n) = KochTurnsL(n);

gp_inline__location="../alternate.tex:5725";
 dir_by_bit_products(n) = {
   my(k=if(n,logint(n,2)));  \\ highest 1-bit at position k
   bittest(n,0)
     - 2*sum(j=0,k-1, (-1)^j*bittest(n,j)*bittest(n,j+1));
 }

gp_inline__location="../alternate.tex:5740";
 Alt11Pairs(n) = {
   n>=0 || error();
   \\ top j=logint(n,2)-1 has j+1 position of highest 1-bit
   sum(j=0,if(n,logint(n,2)-1),
       (-1)^j * bittest(n,j) * bittest(n,j+1));
 }

gp_inline__location="../alternate.tex:5750";
 Alt11Pairs_samples = {[0,0,0,1,0,0,-1,0,0,0,0,1]};

gp_inline__location="../alternate.tex:5775";
 \\ sum (-1)^lo where lo is the low end of each even-length
 \\ run of 1-bits in n
 alternating_even_runs(n) = {
   my(k=if(n,logint(n,2)), j=0, ret=0);
   while(1,
      while(bittest(n,j)==0, j++; if(j>k,break(2)));
      my(lo=j);
      while(bittest(n,j)==1, j++);
      my(len=j-lo);
      if(len%2==0, ret += (-1)^lo));
   ret;
 }

gp_inline__location="../alternate.tex:5804";
 dAlt11Pairs(n) = {
   n>=1 || error("dAlt11Pairs() is for n>=1");
   Alt11Pairs(n) - Alt11Pairs(n-1);
 }

gp_inline__location="../alternate.tex:5825";
 dAlt11Pairs_samples = {[0,0,1,-1,0,-1,1,0,0,0,1,0]};

gp_inline__location="../alternate.tex:5958";
 CountBitTransitions(n) = {
   my(v=concat(0,binary(n)));  \\ with zeros above high end
   sum(i=1,#v-1, v[i]!=v[i+1]);
 }
 flip_evens(n) = {
   my(v=binary(n));
   forstep(i=#v,1,-2, v[i]=1-v[i]);
   fromdigits(v,2);
 }
 \\ return n with odd position bits flipped,
 \\ counting from 0 as the least significant bit
 flip_odds(n) = {
   return(bitxor(n,from_binary(1010101010101010)));
   my(v=binary(n));
   forstep(i=#v-1,1,-2, v[i]=1-v[i]);
   fromdigits(v,2);
 }

gp_inline__location="../alternate.tex:5996";
 \\ return [maxdir, n_of_maxdir]
 DirMax_and_N_by_search(k) = {
   my(n_max, d=vecmax(vector(2^k,n,n--; dir(n)), &n_max));
   [d, n_max-1];
 }

gp_inline__location="../alternate.tex:6002";
 \\ return [maxdir, n_of_maxdir]
 DirMin_and_N_by_search(k) = {
   my(n_min, d=vecmin(vector(2^k,n,n--; dir(n)), &n_min));
   [d, n_min-1];
 }

gp_inline__location="../alternate.tex:6019";
 DirMax(k) = ceil(k/2);

gp_inline__location="../alternate.tex:6023";
 DirMax_samples = {[0,1,1,2,2,3,3]};

gp_inline__location="../alternate.tex:6040";
 DirMaxN(k) = {
   1/5 * ( vector_modulo([2,4],k) * 2^k
           - vector_modulo([2,3,3,2],k) );
 }

gp_inline__location="../alternate.tex:6052";
 DirMaxN_samples = {[0,1,1,6,6,25,25,102,102,409,409]};

gp_inline__location="../alternate.tex:6067";
 DirMaxN_binary_samples = {[0,1,1,110,110,11001,11001]};

gp_inline__location="../alternate.tex:6086";
 DirMaxN_num_bits(k) = k - (k%2==0);
 DirMaxN_bit_vector(k) = \
   vector(max(0,DirMaxN_num_bits(k)),i, if(i%4==1||i%4==2,1,0));
 DirMaxN_by_bits(k) = fromdigits(DirMaxN_bit_vector(k),2);

gp_inline__location="../alternate.tex:6108";
 DirMin(k) = -floor(k/2);

gp_inline__location="../alternate.tex:6115";
 DirMin_samples = {[0,0,-1,-1,-2,-2,-3]};

gp_inline__location="../alternate.tex:6133";
 DirMinN(k) = {
   1/5 * ( vector_modulo([4,2],k) * 2^k
           - vector_modulo([4,4,1,1],k) );
 }

gp_inline__location="../alternate.tex:6152";
 DirMinN_samples = {[0,0,3,3,12,12,51,51,204,204,819]};

gp_inline__location="../alternate.tex:6167";
 DirMinN_binary_samples = {[0,0,11,11,1100,1100,110011,110011]};

gp_inline__location="../alternate.tex:6193";
 DirMinN_num_bits(k) = k - (k%2);
 DirMinN_bit_vector(k) = \
   vector(DirMinN_num_bits(k),i, if(i%4==1||i%4==2,1,0));
 DirMinN_by_bits(k) = fromdigits(DirMinN_bit_vector(k),2);

gp_inline__location="../alternate.tex:6387";
 TurnsL_by_sum(n) = sum(j=1,n,TurnLpred(j));

gp_inline__location="../alternate.tex:6391";
 TurnsL(n) = 1/2* ( n + dir(n) );

gp_inline__location="../alternate.tex:6395";
 TurnsL_samples = {[1,1,1,2,3,4,4,4,5,5,5,5,6,7,7,8,9,9]};

gp_inline__location="../alternate.tex:6407";
 TurnsR_by_sum(n) = sum(j=1,n,TurnRpred(j));

gp_inline__location="../alternate.tex:6411";
 TurnsR(n) = 1/2*     ( n - dir(n) );

gp_inline__location="../alternate.tex:6415";
 TurnsR_samples = {[0,1,2,2,2,2,3,4,4,5,6,7,7,7,8,8,8,9]};

gp_inline__location="../alternate.tex:6465";
 dir_mod4_samples = {[0,1,0,3,0,1,2,1,0,1,0,3,2,3,0,3]};

gp_inline__location="../alternate.tex:6486";
 dir_mod_4_Arndt_flip(k) = (256^k-1)*2/3;

gp_inline__location="../alternate.tex:6490";
 dir_mod_4_Arndt_k(n) = if(n, logint(n,256)+1, 0);

gp_inline__location="../alternate.tex:6498";
 dir_mod_4_Arndt(n,extra=0) = {
   my(k=dir_mod_4_Arndt_k(n) + extra,
      flip=dir_mod_4_Arndt_flip(k));
   CountOneBits(bitxor(flip,Gray(n))) % 4;
 }

gp_inline__location="../alternate.tex:6528";
 dir4_state_table = {[ 0,1;    \\ d=0
                       0,3;    \\ d=1
                       2,3;    \\ d=2
                       2,1 ]}; \\ d=3
 dir4_base4_state_table = {[ 0,1,0,3;    \\ d=0
                             0,1,2,1;    \\ d=1
                             2,3,2,1;    \\ d=2
                             2,3,0,3 ]}; \\ d=3

gp_inline__location="../alternate.tex:6538";
 dir4_transition(state,bit) = dir4_state_table[state+1,bit+1];
 dir4_transitions(state,v) = {
   for(i=1,#v, state=dir4_transition(state,v[i]));
   state;
 }
 dir4_by_states(n) = dir4_transitions(0,binary(n));

gp_inline__location="../alternate.tex:6547";
 dir4_base4_transition(state,digit) = \
   dir4_base4_state_table[state+1,digit+1];

gp_inline__location="../alternate.tex:6635";
 dir4_LtoH_state_table = {[ 1,6;    \\ 0
                            1,2;    \\ 1
                            1,3;    \\ 2
                            4,2;    \\ 3
                            4,3;    \\ 4
                            5,6;    \\ 5
                            5,7;    \\ 6
                            8,6;    \\ 7
                            8,7 ]}; \\ 8
 dir4_LtoH_transition(state,bit) = \
   dir4_LtoH_state_table[state+1,bit+1];
 dir4_LtoH_transitions(state,v) = {
   for(i=1,#v, state=dir4_LtoH_transition(state,v[i]));
   state;
 }
 dir4_LtoH_state_to_dir_vector = [0,0,0, 2,2, 1,1, 3,3];
 dir4_LtoH_state_to_dir(state) = \
   dir4_LtoH_state_to_dir_vector[state+1];
 dir4_LtoH_by_states(n) = {
   dir4_LtoH_state_to_dir(
     dir4_LtoH_transitions(0,Vecrev(binary(n))));
 }

gp_inline__location="../alternate.tex:6812";
 dir4pred_LtoH_state_table = {[ 0,1;    \\ 0
                                0,3;    \\ 1
                                2,3;    \\ 2
                                2,1;    \\ 3
                                0,8;    \\ 4
                                8,1;    \\ 5
                                2,8;    \\ 6
                                8,3;    \\ 7
                                8,8 ]}; \\ 8
 dir4pred_LtoH_transition(state,bit) = \
   dir4pred_LtoH_state_table[state+1,bit+1];
 dir4pred_LtoH_transitions(state,v) = {
   for(i=1,#v, state=dir4pred_LtoH_transition(state,v[i]));
   state;
 }
 dir4pred_LtoH_accepting_vector = [1,1,0,0, 1,0,0,0, 0];
 dir4pred_LtoH_state_is_accepting(state) = \
   dir4pred_LtoH_accepting_vector[state+1];
 dir4pred_LtoH_state_to_dir(state) = \
   dir4pred_LtoH_state_to_dir_vector[state+1];
 dir4pred_LtoH_by_states(n,dir) = {
   dir4pred_LtoH_state_is_accepting(
     dir4pred_LtoH_transitions(4+dir,Vecrev(binary(n))));
 }

gp_inline__location="../alternate.tex:6967";
 dir_mod4_eq_0_at_n_samples = {[0,2,4,8,10,14,16,18,20]};

gp_inline__location="../alternate.tex:6984";
 dir_mod4_eq_1_at_n_samples = {[1,5,7,9,17,21,23,27,29]};

gp_inline__location="../alternate.tex:7020";
 dir_mod4_eq_2_at_n_samples = {[6,12,22,24,26,30,38,44,48]};

gp_inline__location="../alternate.tex:7033";
 dir_mod4_eq_3_at_n_samples = {[3,11,13,15,19,25,35,43,45]};

gp_inline__location="../alternate.tex:7069";
 dx(n) = real(I^dir(n));

gp_inline__location="../alternate.tex:7078";
 dx_samples = {[1,0,1,0,1,0,-1,0,1,0,1,0,-1,0,1]};

gp_inline__location="../alternate.tex:7099";
 dy(n) = imag(I^dir(n));

gp_inline__location="../alternate.tex:7101";
 dy_samples = {[0,1,0,-1,0,1,0,1,0,1,0,-1,0,-1,0]};

gp_inline__location="../alternate.tex:7116";
 \\ A014081
 Count11Pairs(n) = hammingweight(bitand(n,n>>1));
 A014081(n) = Count11Pairs(n);

gp_inline__location="../alternate.tex:7126";
 A048735(n) = bitand(n,n>>1);

gp_inline__location="../alternate.tex:7160";
 Shapiro_P(n,x) = {
   n>=0 || error();
   if(n==0,Pol(1), Shapiro_P(n-1,x) + x^(2^(n-1))*Shapiro_Q(n-1,x));
 }
 Shapiro_Q(n,x) = {
   n>=0 || error();
   if(n==0,Pol(1), Shapiro_P(n-1,x) - x^(2^(n-1))*Shapiro_Q(n-1,x));
 }

gp_inline__location="../alternate.tex:7193";
 A016031(n) = 2^(2^(n-1) - n);

gp_inline__location="../alternate.tex:7281";
 \\ A271495 eighth moments of the Rudin-Shapiro polynomials
 gA271495(x) = {
   -(90194313216*x^11-15300820992*x^10-1979711488*x^9
     -292552704*x^8-22216704*x^7+10649600*x^6-1024*x^5
     -144384*x^4+7008*x^3+664*x^2-54*x-1)
   /(8*x+1) /(16*x-1)
   /(1409286144*x^10-264241152*x^9-25690112*x^8-4128768*x^7
     -311296*x^6+170496*x^5-2624*x^4-2208*x^3+148*x^2+8*x-1);
 }

gp_inline__location="../alternate.tex:7301";
 \\ A271496 tenth moments of the Rudin-Shapiro polynomials
 gA271496(x) = {
   -(369435906932736*x^11-32160715112448*x^10
     -2001454759936*x^9-145223581696*x^8-4454350848*x^7
     +1392508928*x^6-5865472*x^5-4599808*x^4+123648*x^3
     +4768*x^2-220*x-1)
   /(1+16*x)
   /(32*x-1)
   /(1443109011456*x^10-135291469824*x^9-6576668672*x^8
     -528482304*x^7-19922944*x^6+5455872*x^5-41984*x^4
     -17664*x^3+592*x^2+16*x-1);
 }

gp_inline__location="../alternate.tex:7407";
 GRS(n) = {
   n>=0 || error("GRS() is for n>=0");
   (-1)^Count11Pairs(n);
 }

gp_inline__location="../alternate.tex:7428";
 GRS_samples = {[1,1,1,-1,1,1,-1,1,1,1,1,-1,-1,-1,1,-1]};

gp_inline__location="../alternate.tex:7436";
 A020985(n) = GRS(n);

gp_inline__location="../alternate.tex:7459";
 Count11Pairs_samples = {[0,0,0,1,0,0,1,2,0,0,0,1,1,1,2,3]};

gp_inline__location="../alternate.tex:7502";
 A020987(n) = \
   sum(i=0,if(n,logint(n,2))-1, bittest(n,i)&&bittest(n,i+1)) % 2;

gp_inline__location="../alternate.tex:7519";
 A020987_by_table(n) = { my(state=1);
   for(i=0,if(n,logint(n,2)),
     state=[1,5,3,7,1,7,3,5][state+bittest(n,i)]);
   bittest(state,1);
 }

gp_inline__location="../alternate.tex:7531";
 \\ Count number of 11 bit pairs with overlaps between pairs not
 \\ allowed.
 \\ Not same as just base 4 count 3 digits.
 count_nonoverlapping_11_pairs(n) = {
   my(ret=0);
   for(j=0,if(n,logint(n,2)),
     if(bittest(n,j) && bittest(n,j+1),
        ret++;
        j++));  \\ skip to next so non-overlapping
   ret;
 }

gp_inline__location="../alternate.tex:7558";
 \\ equivalent to base 4 num digit 3s
 Count11PairsEven(n) = {
   sum(i=0,if(n,logint(n,2))\2,
       bittest(n,2*i) && bittest(n,2*i+1));
 }
 Count11PairsOdd(n) = {
   sum(i=0,if(n,logint(n,2))\2,
       bittest(n,2*i+1) && bittest(n,2*i+2));
 }

gp_inline__location="../alternate.tex:7571";
 \\ A160383
 Base4Count3s(n) = my(v=digits(n,4)); sum(i=1,#v, v[i]==3);

gp_inline__location="../alternate.tex:7592";
 GRSalt(n) = (-1)^n * GRS(n);

gp_inline__location="../alternate.tex:7594";
 GRSalt_samples = {[1,-1,1,1,1,-1,-1,-1,1,-1]};

gp_inline__location="../alternate.tex:7640";
 \\ Return just the low run of 1s in n.
 \\ A135481
 low1s(n) = bitxor(n,n+1) >> 1;

gp_inline__location="../alternate.tex:7649";
 \\ Number of 11 bit pairs in the low run of 1s in n,
 \\ overlapping pairs allowed.
 \\ So like Count11Pairs but only on the low 1s of n.
 CountLow11(n) = max(0,CountLowOnes(n)-1);

gp_inline__location="../alternate.tex:7669";
 \\ A245194
 dCount11Pairs(n) = Count11Pairs(n+1) - Count11Pairs(n);
 \\ per Neil in A245194
 gA245194(x,num_terms) = {
   sum(k=0,num_terms-1,
       my(t=x^(2^k)); t^3/((1+t)*(1+t^2)));
 }

gp_inline__location="../alternate.tex:7700";
 A245194(n) = \
   if(n==0,0, my(k=valuation(n,2)); bittest(n,k+1) - (n%2) - k+ 1);

gp_inline__location="../alternate.tex:7747";
 dGRS(n) = GRS(n+1) - GRS(n);

gp_inline__location="../alternate.tex:7778";
 dGRSalt(n) = GRSalt(n+1) - GRSalt(n);

gp_inline__location="../alternate.tex:7813";
 \\ polynomial of hammingweighted GRS terms
 hamGRSpoly(k,x) = sum(j=0,2^k-1, GRS(j)*x^CountOneBits(j));

gp_inline__location="../alternate.tex:7833";
 A285869(n) = n - 2*floor((n+1)/4);

gp_inline__location="../alternate.tex:7840";
 Paper(n) = if(n%2==0, (-1)^(n\2), Paper(n\2));

gp_inline__location="../alternate.tex:7842";
 hamPaper(k,x) = sum(j=0,2^k-1, Paper(j)*x^CountOneBits(j));

gp_inline__location="../alternate.tex:7851";
 A162330(n) = n + 1 - 2*floor( (n+2)/4 );

gp_inline__location="../alternate.tex:7862";
 delete_second_lowest_bit(n) = \
   my(v=binary(n)); if(#v>=2,v=v[^#v-1]); fromdigits(v,2);

gp_inline__location="../alternate.tex:7873";
 \\ second least significant bit
 A021913(n) = {
   n>=0 || error("A021913() is for n>=0");
   bittest(n,1);
 }

gp_inline__location="../alternate.tex:7882";
 \\ delete second lowest bit
 A083219(n) = {
   n>=0 || error("A083219() is for n>=0");
   n - 2*floor(n/4);
 }

gp_inline__location="../alternate.tex:7920";
 hamGRSpoly_triangle(len,target=1,rev=0) = {
   my(ret=[]);
   for(n=0,len-1,
     my(row=vector(n+1));
     for(j=0,2^n-1,
       if(GRS(j)==target,
         row[CountOneBits(j)+1]++));
     ret=concat(ret,if(rev,Vecrev(row),row)));
   ret;
 }

gp_inline__location="../alternate.tex:7945";
 hamGRSpoly_P(n,x) = {
   my(p0=1, p1=1+x);
   for(i=1,n, [p1,p0] = [(1-x)*p1 + 2*x*p0, p1]);
   p0;
 }

gp_inline__location="../alternate.tex:7967";
 \\       k-1  k
 \\      --------
 \\ n-2 |  -1
 \\ n-1 |  -1 +1
 \\ n   |      *
 hamGRS_T(n,k) = {
   if(n<0 || k<0 || k>n, return(0));
   if(n<=1, return(1));
   hamGRS_T(n-1,k) - hamGRS_T(n-1,k-1) + 2*hamGRS_T(n-2,k-1);
 }
 hamGRS_T = memoize(hamGRS_T);

gp_inline__location="../alternate.tex:8003";
 g2hamGRS(x,y) = (1 + 2*y*x)/(1 + (y-1)*x - 2*y*x^2);

gp_inline__location="../alternate.tex:8010";
 hamGRS_T_formula(n,k) = \
   hamGRS_T(n-1,k) - hamGRS_T(n-1,k-1) + 2*hamGRS_T(n-2,k-1);

gp_inline__location="../alternate.tex:8031";
 hamGRSpoly_C(k,x) = \
   if(k==0, 1/(1-x), x^k * (2*x-1)^(k-1) / (1-x)^(k+1));

gp_inline__location="../alternate.tex:8053";
 A275874(n) = (n-4)*(n+1)*(n+3)/6;

gp_inline__location="../alternate.tex:8072";
 hamGRS_Tplus(n,k) = {
   if(n<0 || k<0 || k>n, return(0));
   if(n<=1, return(1));
   hamGRS_Tplus(n-1,k)
   - hamGRS_Tplus(n-1,k-1)
   + 2*hamGRS_Tplus(n-2,k-1)
   + binomial(n-2,k-2);
 }
 hamGRS_Tminus(n,k) = {
   if(n<0 || k<0 || k>n, return(0));
   if(n<=1, return(0));
   hamGRS_Tminus(n-1,k)
   - hamGRS_Tminus(n-1,k-1)
   + 2*hamGRS_Tminus(n-2,k-1)
   + binomial(n-2,k-2);
 }
 hamGRS_Tplus = memoize(hamGRS_Tplus);
 hamGRS_Tminus = memoize(hamGRS_Tminus);

gp_inline__location="../alternate.tex:8130";
 hamGRSpoly_Pplus(n,x) = sum(k=0,n, hamGRS_Tplus(n,k)*x^k);

gp_inline__location="../alternate.tex:8134";
 g2hamGRS_plus(x,y) = {
   ( 1 + (y-1)*x - y*(2+y)*x^2 )
   / ( (1 - (y+1)*x) * (1 + (y-1)*x - 2*y*x^2) );
 }

gp_inline__location="../alternate.tex:8149";
 hamGRSpoly_Cplus(k,x) = {
   if(k==0, 1/(1-x),
      1/2*x^k*(1 + (2*x-1)^(k-1)) / (1-x)^(k+1));
 }

gp_inline__location="../alternate.tex:8182";
 A000125(n) = binomial(n+1,3)+n+1;

gp_inline__location="../alternate.tex:8234";
 hamGRSpoly_Pminus(n,x) = sum(k=0,n, hamGRS_Tminus(n,k)*x^k);

gp_inline__location="../alternate.tex:8238";
 g2hamGRS_minus(x,y) = {
   y^2*x^2
   / ( (1 - (y+1)*x) * (1 + (y-1)*x - 2*y*x^2) );
 }

gp_inline__location="../alternate.tex:8249";
 hamGRSpoly_Cminus(k,x) = {
   if(k==0, Pol(0),
      1/2*x^k*(1 - (2*x-1)^(k-1)) / (1-x)^(k+1));
 }

gp_inline__location="../alternate.tex:8289";
 A279019(n) = (n-4)*(n-5);
 A002378(n) = n*(n+1);

gp_inline__location="../alternate.tex:8304";
 A060354(n) = n*(n^2-3*n+4)/2;

gp_inline__location="../alternate.tex:8362";
 dsum(n) = dx(n)+dy(n);

gp_inline__location="../alternate.tex:8381";
 ddiff(n) = dx(n) - dy(n);

gp_inline__location="../alternate.tex:8443";
 operator_P(w,s) = {
   s==1 || s==-1 || error();
   vector(2*#w+1,i, if(i%2, if(s*(-1)^(i\2)>0,'g,'d),
                            w[i/2]));
 }

gp_inline__location="../alternate.tex:8453";
 \\ epsilon[n] = (-1)^n
 epsvec_alternating(n) = vector(n,i, (-1)^i);

gp_inline__location="../alternate.tex:8458";
 epsvec_dragon(n) = vector(n,i, 1);

gp_inline__location="../alternate.tex:8461";
 turn_gd(n) = if(turn(n)>0, 'g, 'd);
 gd_flip(gd) = if(gd=='g,'d, gd=='d,'g, error());

gp_inline__location="../alternate.tex:8464";
 \\ epsvec[n] applied outer-most
 epsvec_product(epsvec) = {
   my(w=[]);
   for(i=1,#epsvec, w=operator_P(w,epsvec[i]));
   w;
 }

gp_inline__location="../alternate.tex:8490";
 w_count(w,r,gd) = sum(i=1,r, w[i]==gd);
 w_count_diff(w,r) = w_count(w,r,'g) - w_count(w,r,'d);

gp_inline__location="../alternate.tex:8531";
 A_poly(w) = sum(r=0,floor(#w/2),  I^ w_count_diff(w,2*r)     *x^r);
 B_poly(w) = sum(r=0,floor(#w/2)-1,I^(w_count_diff(w,2*r+1)-1)*x^r);

gp_inline__location="../alternate.tex:8541";
 Ctilde(epsvec,m,n) = {
   sum(r=0,2^(n-m+1)-1,
     prod(j=0,n-m,
       I^(epsvec[n-j]*abs(bittest(r,j)-bittest(r,j+1))))
     * x^r);
 }
 Atilde(epsvec,m,n) = real(Ctilde(epsvec,m,n));
 Btilde(epsvec,m,n) = imag(Ctilde(epsvec,m,n));

gp_inline__location="../alternate.tex:8696";
 swap23(n) = if(n==2,3, n==3,2, n);

gp_inline__location="../alternate.tex:8708";
 GRS4_state_table = {[0,1;
                      0,2;
                      3,1;
                      3,2]};
 GRS4_transition(state,bit) = GRS4_state_table[state+1,bit+1];
 GRS4(n,state=0) = {
   my(v=binary(n));
   for(i=1,#v, state=GRS4_transition(state,v[i]));
   state;
 }

gp_inline__location="../alternate.tex:8736";
 GRS4_samples = {[0,1,0,2,0,1,3,1,0,1,0,2,3,2,0,2]};

gp_inline__location="../alternate.tex:8769";
 GRS_from_GRS4(n) = {
   if(n==0 || n==1, 1,
      n==2 || n==3, -1,
      error());
 }

gp_inline__location="../alternate.tex:8780";
 \\ GRS4 = A100260
 { my(table=[1,3,1,5,7,3,7,5]);
   A100260_compact(n) = my(k=logint(n,2), state=1); n--;
     forstep(i=k,0,-1, state=table[state+bittest(n,i)]); state>>1;
 }

gp_inline__location="../alternate.tex:8891";
 swap12(n) = if(n==1,2, n==2,1, n);

gp_inline__location="../alternate.tex:8926";
 GRS_eq_plus1_at_n_samples = {[0,1,2,4,5,7,8,9]};

gp_inline__location="../alternate.tex:8945";
 GRS_eq_minus1_at_n_samples = {[3,6,11,12,13,15,19,22]};

gp_inline__location="../alternate.tex:8958";
 GRSalt_eq_plus1_at_n_samples = {[0,2,3,4,8,10,11,13]};

gp_inline__location="../alternate.tex:8973";
 GRSalt_eq_minus1_at_n_samples = {[1,5,6,7,9,12,17,21]};

gp_inline__location="../alternate.tex:9023";
 GRSrunSpred(n) = n==0 || GRS(n)!=GRS(n-1);

gp_inline__location="../alternate.tex:9025";
 GRSrunSpred_samples = {[1,0,0,1,1,0,1,1,0,0,0,1,0,0,1]};

gp_inline__location="../alternate.tex:9257";
 GRSrunSpredAlt(n) = n==0 || GRSalt(n)!=GRSalt(n-1);

gp_inline__location="../alternate.tex:9273";
 GRSrunSpredAlt_samples = {[1,1,1,0,0,1,0,0,1,1,1,0,1,1,0]};

gp_inline__location="../alternate.tex:9304";
 GRSrun(m) = {
   my(len=1,prev=GRS(0),n=1);
   while(1,
     my(g=GRS(n));
     if(g==prev, len++,
        m==0, return(len),
        m--; len=1; prev=g);
     n++);
 }
 GRSrun_samples = {[3,1,2,1,4,3,1,1,3,1,2,1]};

gp_inline__location="../alternate.tex:9326";
 GRSrunAlt(m) = {
   my(len=1,prev=GRSalt(0),n=1);
   while(1,
     my(g=GRSalt(n));
     if(g==prev, len++,
        m==0, return(len),
        m--; len=1; prev=g);
     n++);
 }
 GRSrunAlt_samples = {[1,1,3,3,1,1,2,1,4,1,3,4]};

gp_inline__location="../alternate.tex:9380";
 dir_mod4_in_range(lo,hi) = \
   lo=max(lo,0); apply(n->dir(n)%4, [lo..hi]);

gp_inline__location="../alternate.tex:9388";
 dir4_is_next_at_10(n) = {
   my(d=dir(n)%4);
   for(i=n+1,n+9, if(dir(i)%4==d, return(0)));
   dir(n+10)%4==d || error("oops");
   1;
 }

gp_inline__location="../alternate.tex:9398";
 dir4_fullset_length(n) = {
   my(seen=[0,0,0,0], len=0);
   while(seen!=[1,1,1,1],
     seen[dir(n+len)%4+1]=1; len++);
   len;
 }

gp_inline__location="../alternate.tex:9474";
 dir4_fullset_10_samples = {[13,26,42,61,77,93,106,122,141,154]};

gp_inline__location="../alternate.tex:9568";
 is_func_palindrome(n,len,func) = {
   my(t=n+len-1);
   while(n<t,
     if(func(n)!=func(t), return(0));
     n++;t--);
   1;
 }

gp_inline__location="../alternate.tex:9644";
 GRSplusN(m) = {
   m>=0 || error("GRSplusN() is for m>=0");
   my(n=0); while(1, if(GRS(n)==1, if(m==0,return(n)); m--); n++);
 }
 GRSminusN(m) = {
   m>=0 || error("GRSminusN() is for m>=0");
   my(n=0); while(1, if(GRS(n)==-1, if(m==0,return(n)); m--); n++);
 }

gp_inline__location="../alternate.tex:9653";
 GRSplusK(k) = 2^(k-1) + 2^floor((k-1)/2);

gp_inline__location="../alternate.tex:9657";
 GRSminusK(k) = 2^(k-1) - 2^floor((k-1)/2);

gp_inline__location="../alternate.tex:9673";
 GRSrunEpred(n) = GRS(n)!=GRS(n+1);

gp_inline__location="../alternate.tex:9715";
 A073057_HtoL_state_table = {[1,2; 1,3; 4,2; 4,3; 3,4; 1,5]};
 A073057_LtoH_2a = 1;
 A073057_LtoH_3a = 2;
 A073057_LtoH_4a = 3;
 A073057_LtoH_1a = 4;
 A073057_LtoH_2b = 5;
 A073057_LtoH_3g = 6;
 A073057_LtoH_4g = 7;
 A073057_LtoH_1b = 8;
 A073057_LtoH_2c = 9;
 A073057_LtoH_3b = 10;
 A073057_LtoH_4c = 11;
 A073057_LtoH_1c = 12;
 A073057_LtoH_2d = 13;
 A073057_LtoH_3c = 14;
 A073057_LtoH_4b = 15;
 A073057_LtoH_1d = 16;
 A073057_LtoH_2e = 17;
 A073057_LtoH_3d = 18;
 A073057_LtoH_4d = 19;
 A073057_LtoH_1e = 20;
 A073057_LtoH_2f = 21;
 A073057_LtoH_3e = 22;
 A073057_LtoH_4f = 23;
 A073057_LtoH_1f = 24;
 A073057_LtoH_3f = 26;
 A073057_LtoH_4e = 27;
 A073057_LtoH_T = 28;
 A073057_LtoH_U = 29;
 A073057_LtoH_S = 30;
 A073057_LtoH_state_to_name = {["2a","3a","4a","1a","2b","3g","4g",
   "1b","2c","3b","4c","1c","2d","3c","4b","1d","2e","3d","4d",
   "1e","2f","3e","4f","1f",'none,"3f","4e","T","U","S"]};
 A073057_LtoH_state_table = {[
   1,2;        \\   1 = 2a  -> 2a,3a
   5,14;       \\   2 = 3a  -> 2b,3c
   8,11;       \\   3 = 4a  -> 1b,4c
   4,3;        \\ 4 = 1a  -> 1a,4a
   1,9;        \\   5 = 2b  -> 2a,2c
   8,11;       \\   6 = 3g  -> 1b,4c
   18,10;      \\   7 = 4g  -> 3d,3b
   4,12;       \\ 8 = 1b  -> 1a,1c
   5,14;       \\   9 = 2c  -> 2b,3c
   5,13;       \\   10 = 3b  -> 2b,2d
   19,15;      \\   11 = 4c  -> 4d,4b
   8,11;       \\ 12 = 1c  -> 1b,4c
   18,10;      \\   13 = 2d  -> 3d,3b
   18,10;      \\   14 = 3c  -> 3d,3b
   8,16;       \\   15 = 4b  -> 1b,1d
   19,15;      \\ 16 = 1d  -> 4d,4b
   5,13;       \\   17 = 2e  -> 2b,2d
   26,22;      \\   18 = 3d  -> 3f,3e
   23,27;      \\   19 = 4d  -> 4f,4e
   8,16;       \\ 20 = 1e  -> 1b,1d
   18,17;      \\   21 = 2f  -> 3d,2e
   18,17;      \\   22 = 3e  -> 3d,2e
   23,24;      \\   23 = 4f  -> 4f,1f
   19,20;      \\ 24 = 1f  -> 4d,1e
   0,0;        \\   25 = unused
   26,21;      \\   26 = 3f  -> 3f,2f
   19,20;      \\   27 = 4e  -> 4d,1e
   4,6;        \\ 28 = T  -> 1a,3g
   5,7;        \\   29 = U  -> 2b,4g
   28,29]};    \\   30 = S  -> T,U

gp_inline__location="../alternate.tex:9816";
 End(k) = vector_modulo([1,1+I],k)*2^floor(k/2);

gp_inline__location="../alternate.tex:9818";
 alternate_point(n) = {
   n>=0 || error("alternate_point() is for n>=0");
   my(k=if(n,high_bit_k(n)), s=1, z=0);
   forstep(j=k,0,-1,  \\ high to low
     if(bittest(n,j),
        z += s*End(j);
        if(bittest(n,j+1), s=-s)));
   z;
 }

gp_inline__location="../alternate.tex:9832";
 alternate_point_by_points(n) = alternate_points(#binary(n))[n+1];

gp_inline__location="../alternate.tex:9879";
 End_samples = {[1,1+I,2,2+2*I,4,4+4*I]};

gp_inline__location="../alternate.tex:9996";
 point_DK_pow(v,j) = {
   sum(i=0,j-1, (-1)^v[i+1])
   + floor(v[j+1]/2);
 }
 point_DK(n,s, z=I) = {     \\ z=zeta unfold direction
   my(v=n_to_folded_indices(n,s),t=#v-1);  \\ 0 to t
   sum(j=0,t,
       z^-point_DK_pow(v,j)
       * (-1)^j
       * (1+z)^v[j+1]);
 }

gp_inline__location="../alternate.tex:10029";
 point_zeta_by_folded(n,s,zet) = {
   my(v=n_to_folded_indices(n,s),t=#v-1);  \\ v = 0 to t
   sum(j=0,t, (-1)^j
              * zet^(-point_zeta_d(v,j))
              * (1+zet)^v[j+1]);
 }

gp_inline__location="../alternate.tex:10041";
 point_zeta_d(v,j) = sum(i=0,j-1,(-1)^(v[i+1])) + floor(v[j+1]/2);

gp_inline__location="../alternate.tex:10060";
 theta_to_zet(th) = exp(I*(Pi-th));

gp_inline__location="../alternate.tex:10107";
 point_by_folded(n,s) = {
   my(v=n_to_folded_indices(n,s),t=#v-1);  \\ 0 to t
   \\ print(v," t="t);
   sum(j=0,t,
       \\ print(v[j+1]," I^j=",I^j," vsum=",sum(e=0,j-1,v[e+1]));
       I^j                            \\ each term
       * (-1)^sum(e=0,j-1,v[e+1])     \\ accumulating
       * End(v[j+1]));
 }

gp_inline__location="../alternate.tex:10129";
 point_samples = {[0,1,1+I,2+I,2,3,3+I,2+I,2+2*I]};

gp_inline__location="../alternate.tex:10239";
 \\ This as pairs of 1...-1 so the lowest is s=-1.
 n_to_folded_from_runs(n) = {
   if(n==0,return([]));
   my(v=concat(0,binary(n)));
   vector(#v,i,
          if(i<#v && v[i]==0 && v[i+1]==1,     1,  \\ top of run
             v[i]==1 && (i==#v || v[i+1]==0), -1,  \\ bottom of run
             0));
 }

gp_inline__location="../alternate.tex:10380";
 point_by_revPoint(n,k) = {
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   if(n==0, 0,
      a==0, point_by_revPoint(n1,k-1),
            End(k-1) + I*(-1)^(k-1)*revPoint(n1,k-1));
 }

gp_inline__location="../alternate.tex:10393";
 revPoint_ref(n,k) = End(k) - alternate_point(2^k-n);

gp_inline__location="../alternate.tex:10412";
 revPoint(n,k) = {
   \\ print("revPoint "n" k="k);
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   if(n==0, 0,
      a==0, I*(-1)^(k-1) * point_by_revPoint(n1,k-1),
            I*(-1)^(k-1) * End(k-1) + revPoint(n1,k-1));
 }

gp_inline__location="../alternate.tex:10476";
 revPointRot_ref(n,k) = -I*(-1)^(k-1) * revPoint_ref(n,k);

gp_inline__location="../alternate.tex:10489";
 point_by_revPointRot(n,k) = {
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   if(n==0, 0,
      a==0, point_by_revPointRot(n1,k-1),
            End(k-1) + revPointRot(n1,k-1));
 }

gp_inline__location="../alternate.tex:10510";
 revPointRot(n,k) = {
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   if(n==0, 0,
      a==0, point_by_revPointRot(n1,k-1),
            End(k-1) - revPointRot(n1,k-1));
 }

gp_inline__location="../alternate.tex:10739";
 expand(z) = conj(z)*b;
 unexpand(z) = conj(z/b);

gp_inline__location="../alternate.tex:10766";
 expand_k(k,z) = if(k%2==0,z*End(k),conj(z)*End(k));

gp_inline__location="../alternate.tex:10793";
 alternate_point_by_new_low_bit(n) = {
   my(n1=n\2, a=n%2, z=alternate_point(n1));
   expand(z) + I^dir(2*n1) * a;
 }

gp_inline__location="../alternate.tex:10933";
 vector_initial(v,n) = if(n==0,[], v[1..n]);
 alternate_point_by_sum(n) = {
   my(v=binary(n));
   sum(i=1,#v, v[i] * End(#v-i)
               * I^dir_of_bits(concat(vector_initial(v,i-1),[0])));
 }
 alternate_point_by_sum_GRS(n) = {
   my(v=binary(n));
   sum(i=1,#v, v[i] * End(#v-i)
               * GRS(fromdigits(vector_initial(v,i-1),2)));
 }

gp_inline__location="../alternate.tex:10964";
 alternate_point_by_low_to_high(n) = {
   my(z=0, s=1, k=0);
   while(n,
         if(n%4==3, s=-s);
         if(n%2==1, z+=s*End(k));
         n\=2; k++);
   if(s<0, z=-z);
   z;
 }

gp_inline__location="../alternate.tex:10993";
 point_base4_z_table = {[ 0,    1,   1+I,  1;     \\ 0
                          0,    1,     0,  I;     \\ 1
                          1+I,  I,     0,  I;     \\ 2
                          1+I,  I,   1+I,  1  ]}; \\ 3
 point_base4_transition_z(state,digit) = \
   point_base4_z_table[state+1,digit+1];
 point_and_dir_by_base4(n,final_add=1) = {
   my(z=0,state=0,v=digits(n,4));
   for(i=1,#v,
       z = 2*z + point_base4_transition_z(state,v[i]);
       state=dir4_base4_transition(state,v[i]));
   if(state==2||state==3, z+=1+I);
   [z,state];
 }

gp_inline__location="../alternate.tex:11628";
 point_real_by_procedure(n) = {
   my(v=digits(n,4), d=0);
   for(i=1,#v,
     d=dir4_base4_transition(d,v[i]);
     v[i]=((v[i]+d)%4==2));
   fromdigits(v,2) + (d>=2);
 }

gp_inline__location="../alternate.tex:11641";
 GRScumul_by_procedure(n) = {
   my(v=digits(2*n+2,4), state=0);
   for(i=1,#v,
     state=dir4_base4_transition(state,v[i]);
     v[i]=((v[i]+state)%4==2));
   state==0 || state==2 || error("oops");
   fromdigits(v,2) + (state>=2);
 }

gp_inline__location="../alternate.tex:11652";
 \\ Since 2*n+2 is even, the final state is either 0 or 2.
 \\ But write dir>=2 for similarity to A068915_compact().
 { my(table=[0,1,0,3; 0,1,2,1; 2,3,2,1; 2,3,0,3]);
   table==dir4_base4_state_table || error();
   GRScumul_compact(n) = my(v=digits(2*n+2,4), dir=0);
     for(i=1,#v, dir=table[dir+1,v[i]+1]; v[i]=((dir+v[i])%4==2));
     fromdigits(v,2) + (dir>>1); }

gp_inline__location="../alternate.tex:11663";
 { my(table=[0,1,0,3; 0,1,2,1; 2,3,2,1; 2,3,0,3]);
   table==dir4_base4_state_table || error();
   GRScumulAlt_compact(n) = my(v=digits(2*n+2,4), dir=0);
     for(i=1,#v, dir=table[dir+1,v[i]+1]; v[i]=((dir-v[i])%4==2));
     fromdigits(v,2) + (dir>>1);
 }

gp_inline__location="../alternate.tex:11692";
 dir4_base4_transition_by_bit_twiddling(state,digit) = {
   (state - ((state + (digit>>1))%2)
          + ((digit + (digit>>1))%2) )  %4;
 }

gp_inline__location="../alternate.tex:11708";
 \\ Keeping signed end e and summing into z.
 point_by_bittest_LtoH(n) = {
   my(e=1,z=0);
   for(k=0,if(n,logint(n,2)), \\ low to high
     if(bittest(n,k), z+=e);
     if(bittest(n,k+1)&&bittest(n,k+2), e=-e);
     e=(1+I)*conj(e));
   if(real(e)>0,z,-z);
 }

gp_inline__location="../alternate.tex:11720";
 \\ Keeping signed end e and summing into z.
 point_by_bittest_LtoH2(n) = {
   my(e=1,z=0);
   for(k=0,if(n,logint(n,2)), \\ low to high
     if(bittest(n,k), z+=(e*=(-1)^bittest(n,k+1)));
     e=(1+I)*conj(e));
   if(real(e)>0,z,-z);
 }

gp_inline__location="../alternate.tex:11734";
 \\ Negations below 11, then keeping end e and summing into z.
 point_by_binary(n) = {
   my(v=binary(n),s=1);
   for(i=2,#v,     \\ high to low
     v[i]*=s;
     if(v[i]&&v[i-1], s=-s));
   my(e=1,z=0);
   forstep(i=#v,1,-1,     \\ low to high
     z+=e*v[i];
     e=(1+I)*conj(e));
   z;
 }

gp_inline__location="../alternate.tex:11749";
 \\ same as Xnum()
 binary_to_base4_spread(n) = fromdigits(binary(n),4);
 zorder_z_to_n(z) = {
   2*binary_to_base4_spread(imag(z))
   + binary_to_base4_spread(real(z));
 }
 zorder_n_to_z(n) = {
   my(v=digits(n,4));
   fromdigits(v\2,2)*I + fromdigits(v%2,2);
 }

gp_inline__location="../alternate.tex:11762";
 \\ Z-order style bit pairs
 point_base4_zorder_table = \
   2*imag(point_base4_z_table) + real(point_base4_z_table);
 point_base4_transition_zorder(state,digit) = \
   point_base4_zorder_table[state+1,digit+1];

gp_inline__location="../alternate.tex:11773";
 \\ final + 1+I must propagate carry separately in X and Y bits
 \\ which is not easy
 alternate_to_zorder(n,omit_final=0) = {
   my(v=digits(n,4),state=0);
   for(i=1,#v,
     [v[i],state] = [point_base4_transition_zorder(state,v[i]),
                     dir4_base4_transition    (state,v[i])]);
   n=fromdigits(v,4);
   if(!omit_final,
     n = zorder_z_to_n(zorder_n_to_z(n)
                       + if(state==2||state==3, 1+I)));
   n;
 }

gp_inline__location="../alternate.tex:11818";
 dnorm(n) = norm(alternate_point(n+1)) - norm(alternate_point(n));

gp_inline__location="../alternate.tex:11820";
 dnorm_samples = {[1,1,3,-1,5,1,-5,3,5,5,7,-5,-7,-3]};

gp_inline__location="../alternate.tex:11938";
 dnorm_half_minus_one_samples = {[0,0,1,-1,2,0,-3,1,2,2,3,-3,-4,-2]};

gp_inline__location="../alternate.tex:11968";
 XorY(n) = my(z=alternate_point(n)); if(n%2==0,real(z),imag(z));

gp_inline__location="../alternate.tex:11972";
 XorY_samples = {[0,0,1,1,2,0,3,1,2,2,3,3,4,2]};

gp_inline__location="../alternate.tex:11994";
 YorX(n) = my(z=alternate_point(n)); if(n%2==0,imag(z),real(z));

gp_inline__location="../alternate.tex:12002";
 YorX_samples = {[0,1,1,2,0,3,1,2,2,3,3,4,2]};

gp_inline__location="../alternate.tex:12030";
 A068915(n) = {
   n>=0 || error("A068915() is for n>=0");
   A068915_formula(n);
 }
 A068915_formula(n) = {
   if(n<=0, return(0));
   if(n==1, return(1));
   if(n%2==0, abs(A068915(n/2) - A068915(n/2-1)),      \\ even
              A068915((n-1)/2) + A068915((n-1)/2+1));  \\ odd
 }
 A068915 = memoize(A068915);

gp_inline__location="../alternate.tex:12558";
 YorX_by_base4(n) = {
   my(v=digits(n,4), dir=0, f=(-1)^n);
   for(i=1,#v,
     dir=dir4_base4_state_table[dir+1,v[i]+1];
     v[i]=((f*v[i]-dir)%4==2));
   fromdigits(v,2) + (dir>>1);
 }

gp_inline__location="../alternate.tex:12588";
 dnorm_half_plus_one_samples = {[1,1,2,0,3,1,-2,2,3,3,4,-2,-3,-1]};

gp_inline__location="../alternate.tex:12702";
 abs_dnorm_samples = {[1,1,3,1,5,1,5,3,5,5,7,5,7,3]};

gp_inline__location="../alternate.tex:12744";
 A068915_to_st(n) = if(n%2==0, ['t, (n-2)/2], ['s, (n-1)/2]);

gp_inline__location="../alternate.tex:12811";
 \\ Keeping signed end e and summing into z.
 A068915_by_bittest_LtoH(n) = {
   n++;
   my(e=1, z=0);
   for(k=0,if(n,logint(n,2)), \\ low to high
     if(bittest(n,k), z+=(e*=(-1)^bittest(n,k+1)));
     e=(1+I)*conj(e));
   abs(if(n%2, imag(z), real(z)));
 }

gp_inline__location="../alternate.tex:12823";
 { my(table=[0,1,0,3; 0,1,2,1; 2,3,2,1; 2,3,0,3]);
   table == dir4_base4_state_table || error();
   A068915_compact(n) = my(v=digits(n+1,4), dir=0, f=(-1)^n);
     for(i=1,#v, dir=table[dir+1,v[i]+1]; v[i]=((v[i]*f-dir)%4==2));
     fromdigits(v,2) + (dir>>1); }

gp_inline__location="../alternate.tex:12921";
 unpoint_v_is_known(v) = {
      v==[0,1]
   || v==[0,-1]
   || v==[1,-1]  \\ z=-s
   || v==[-1,1]  \\ z=-s
   || v==[I,-1]  \\ z=-I*s
   || v==[-I,1]  \\ z=-I*s
   ;
 }

gp_inline__location="../alternate.tex:12994";
 \\ return true if z is an Gaussian integer
 z_is_integer(z) = is_integer(real(z)) && is_integer(imag(z));

gp_inline__location="../alternate.tex:12997";
 z_mod_b(z) = (real(z) + imag(z)) % 2;

gp_inline__location="../alternate.tex:13007";
 z_is_even(z) = z_mod_b(z)==0;

gp_inline__location="../alternate.tex:13012";
 \\ Return 0,1,2,3 which is low bit l=z_mod_b(z), and second bit
 \\ s=z_mod_b(z) after dividing out (so (z-l)/b)
 z_mod_bsquared_2bits(z) = {
   my(lo=z_mod_b(z));
   z = (z-lo)/b;
   2*z_mod_b(z) + lo;
 }

gp_inline__location="../alternate.tex:13030";
 \\ giving 0, 1, b, I (=b-1) according as z mod b^2
 z_mod_bsquared(z) = [0,I;1,1+I][(real(z)%2)+1,(imag(z)%2)+1];

gp_inline__location="../alternate.tex:13048";
 z_mod_bsquared_by_mod_b(z) = {
   my(lo=z_mod_b(z)); z -= lo; z /= b;
   my(hi=z_mod_b(z));
   b*hi + lo + if(lo&&hi,I*b^2);
 }

gp_inline__location="../alternate.tex:13057";
 alternate_unpoint(z,s) = {
   my(debug=0);
   z_is_integer(z) || error("alternate_unpoint() should be integer z, got ",z);
   s==1 || s==-1 || error("alternate_unpoint() should be s=+/-1, got ",s);
   if(debug,print("unpoint z="z"  s="s));
   if(z==0,return([0,0]));
   my(v=List([]), count=0);  \\ bits low to high
   while(! (z==0 || z==-s || z==-I*s),
     if(debug,print(" at z="z"  s="s"  bits="bits" vHL="Vecrev(v)));
     my(bit=z_mod_b(z));
     if(z_mod_bsquared(z)==I, s=-s);
     if(bit, z-=s);
     z = conj(z/b);
     if(! z_is_integer(z), error("oops, z=",z));
     listput(v,bit);
     if(norm(z)<=2,
        count++;if(count>10,error("oops z=",z," s="s)));
     );
   if(debug,print(" end z="z" s="s" bits high to low "Vecrev(v)));
   if(z==0 && s==1,   [0, from_binary_vector(Vecrev(v))],
      z==0 && s==-1,  [2, from_binary_vector(Vecrev(v))],
      z==I && s==-1,  [1, 2^#v-from_binary_vector(Vecrev(v))],
      z==-I && s==1,  [3, 2^#v-from_binary_vector(Vecrev(v))],
      z==1 && s==-1,  [99, -1],
      z==-1 && s==1,  [99, 1],
      error("oops, alternate_unpoint() end z=",z," s=",s));
 }

gp_inline__location="../alternate.tex:13124";
 z_count_visits(z) = sum(s=0,1,s=2*s-1; alternate_unpoint(z,d) >= 0);

gp_inline__location="../alternate.tex:13144";
 unpoint_iterate(v) = {
   my(z=v[1], s=v[2]);
   z_is_integer(z) || error("unpoint_iterate() non integer z=",z);
   if(z_mod_bsquared(z)==I, s=-s);
   if(z_mod_b(z), z-=s);
   z = unexpand(z);
   [z,s];
 }
 unpoint_iterations(n,v) = {
   my(result=vector(n));
   for(i=1,n, v=unpoint_iterate(v);
              result[i]=v);
   result;
 }

gp_inline__location="../alternate.tex:13180";
 alternate_unpoint_s_of_zd(z,d) = I^(d-if(z_mod_b(z),1));

gp_inline__location="../alternate.tex:13194";
 alternate_unpoint_of_d(z,d) = \
   alternate_unpoint(z, alternate_unpoint_s_of_zd(z,d));

gp_inline__location="../alternate.tex:13299";
 unpoint_v_ending(v) = {
   for(i=1,100, v=unpoint_iterate(v);
                if(unpoint_v_is_known(v), return(v));
                \\ if(v==[-I,-1], return(v);
      );
   ["other",v];
 }
 unpoint_v_ending_is_known(v) = {
   unpoint_v_is_known(unpoint_v_ending(v));
 }
 unpoint_z_ending_is_known(z) = {
   unpoint_v_ending_is_known([z,1])==1
   && unpoint_v_ending_is_known([z,-1])==1;
 }

gp_inline__location="../alternate.tex:13411";
 alternate_n_to_arm_and_other(n) = {
   my(debug=0);
   if(n<0,error("alternate_n_to_arm_and_other() is for n>=0"));
   my(v = concat([0,0,0],binary(n)));
   my(pos = #v);
   while(pos >= 1 && v[pos]==0, pos--); \\ skip low 0s
   if(pos < 1, return([0,0]));  \\ all zeros
   if(debug,print("v="v" skip zeros to pos="pos));

   pos--;  \\ skip lowest 1 bit
   my(t = if(pos>=1,v[pos],0));
   if(debug,print(" pos="pos" t="t));
   my(flip=0);
   while(1,
         pos--;                \\ skip t bit or unchanged bit
         if(pos<1, flip=1; break());

         if(debug,print(" pos="pos" flip"));
         v[pos]=1-v[pos];         \\ flip bit

         pos--;                \\ unchanged bit
         if(pos<1, break());

         if(v[pos]!=t,
            if(debug,print(" pos="pos" !=t"));
            break());
         if(debug,print(" pos="pos" unchanged"));
        );
   my(other = from_binary_vector(v));
   if(flip, [2*t-1, 2^#v - other],
            [0, other]);
 }

gp_inline__location="../alternate.tex:13447";
 \\ Return other(n), or -1 if no other visit on the present arm.
 alternate_n_to_other(n) = {
   my(an=alternate_n_to_arm_and_other(n));
   if(an[1]==0, an[2], -1);
 }

gp_inline__location="../alternate.tex:13461";
 other_n_samples = [0,-1,-1,7,-1,-1,14,3,-1,13,-1,31,28,9,6];

gp_inline__location="../alternate.tex:13540";
 n_to_other_by_delta_seen_delta = Set();
 n_to_arm_and_other_by_delta(n) = {
   my(debug=0);
   if(debug,print("n_to_arm_and_other_by_delta "n));
   if(n==0,return([0,0]));
   my(v = concat([0,0,0],binary(n)));
   my(pos = #v);
   my(s = 1);
   my(h = -1);
   my(delta = 0);
   while(pos > 1,
         n_to_other_by_delta_seen_delta
           = setunion(n_to_other_by_delta_seen_delta,Set([delta]));

         \\ old_bit == old_bit_signed mod b^2
         my(a0 = v[pos]);
         my(a1 = v[pos-1]);
         if(debug,print(" at s="s" h="h" delta="delta"  n bits a1="a1" a0="a0));
         if(a1==1 && a0==1,
            s = -s;
            if(debug,print("  flip s to "s)));

         my(z = a1*b + a0 + delta);
         if(z_mod_bsquared(z) == I, h = -h);

         my(c0 = z_mod_b(z));
         delta = conj( (delta + a0*s - c0*h) / b );
         if(debug,print("  to c0="c0));

         v[pos] = c0;
         pos--;
        );
   if(debug,print("end "v" delta "delta" s="s" h="h"   n="from_binary_vector(v)));
   v = v[^1];
   if(delta, [if(s==h,1,-1), 2^#v-from_binary_vector(v)],
             [0, from_binary_vector(v)]);
 }

gp_inline__location="../alternate.tex:13621";
 n_to_arm_and_other_state_transition(state,bit) = {
   my(s=state[1], h=state[2], delta=state[3], currentbit=state[4]);
   \\ old_bit == old_bit_signed mod b^2
   my(a0 = currentbit);
   my(a1 = bit);
   if(a1==1 && a0==1, s = -s);

   my(z = a1*b + a0 + delta);
   if(z_mod_bsquared(z) == I, h = -h);

   my(c0 = z_mod_b(z));
   delta = conj( (delta + a0*s - c0*h) / b );

   [ [s,h,delta,bit], c0 ];
 }
 n_to_arm_and_other_by_states(n) = {
   if(n==0,return([0,0]));
   my(debug=0);
   my(v = concat([0,0,0],binary(n)));
   if(debug,print("v="v));
   my(pos = #v);
   my(state=[1,-1,0,v[#v]]);
   forstep(i=#v, 2, -1,
     my(bit=v[i-1]);
     my(ret=n_to_arm_and_other_state_transition(state,bit));
     if(debug,print("at state="state" bit="bit"  ret="ret));
     state=ret[1];
     v[i]=ret[2];
   );
   my(s=state[1], h=state[2], delta=state[3], currentbit=state[4]);
   v=v[^1];  \\ v[1] not set by loop
   if(debug,print("final v="v));
   if(delta, [if(s==h,1,-1), 2^#v-from_binary_vector(v)],
             [0, from_binary_vector(v)]);
 }

gp_inline__location="../alternate.tex:13663";
 OXpred_list_by_search(k) = {
   my(m=Map(),limit=2^k);
   for(n=1,limit,
       my(an=alternate_n_to_arm_and_other(n));
       if(an[1]==0 && an[2]<=limit,
          mapput(m,bitxor(n,an[2]),1)));
   m=Mat(m);
   if(matsize(m)[2],vecsort(Vec(m[,1])),[]);
 }

gp_inline__location="../alternate.tex:13687";
 OXpred(c) = {
   if(c==0,return(0));
   if(c%4, return(0));            \\ must >=2 low zeros
   c=n_odd_part(c);
   while(c%4==1,c\=4);
   return(c==0);
 }

gp_inline__location="../alternate.tex:13750";
 OXpred_at_samples = {[4,8,16,20,32,40,64,80,84,128,160]};

gp_inline__location="../alternate.tex:13760";
 is_A181666(n) = {
   n>=1 || return(0);
   my(v=binary(n),i=1);
   while(i<=#v, if(v[i]!=i%2,break); i++);  \\ 1,0 alternating
   while(i<=#v, if(v[i],return(0)); i++);   \\ all 0s
   1;
 }

gp_inline__location="../alternate.tex:13769";
 OddPart(n) = n>>valuation(n,2);

gp_inline__location="../alternate.tex:13773";
 is_pow4(n) = n>0 && n == 4^logint(n,4);

gp_inline__location="../alternate.tex:13776";
 is_4_pow_k_minus_1_over_3(n) = is_pow4(n*3+1);

gp_inline__location="../alternate.tex:13787";
 A082375(n) = my(m=sqrtint(4*n+1)); m-1 - (4*n+1-m^2)\2;

gp_inline__location="../alternate.tex:13799";
 A055086(n) = sqrtint(4*n+1) - 1;

gp_inline__location="../alternate.tex:13804";
 A027434(n) = {
   n>=0 || error();
   ceil(2*sqrt(n));
 }

gp_inline__location="../alternate.tex:13811";
 \\ formula by Andre Hallqvist
 A181666_t(n) = {
   n>=1 || error();
   (4 * 2^A055086(n-1) - 2^A082375(n-1))/3;
 }

gp_inline__location="../alternate.tex:13819";
 A181666_a(n) = {
   n>=1 || error();
   (2^A027434(n) - 2^A082375(n-1)) / 3;
 }

gp_inline__location="../alternate.tex:13827";
 A181666_by_sqrt(n) = {
   n>=1 || error();
   my(h = sqrtint(4*n-3)+1); (2^h - 2^((h^2+1)\2 - 2*n) )/3;
 }

gp_inline__location="../alternate.tex:13834";
 A181666_by_loop(n) = {
   my(ret=0);
   forstep(i=A082375(n-1),A055086(n-1),2, ret += 2^i);
   ret;
 }

gp_inline__location="../alternate.tex:13853";
 OXpred_at_binary_samples = {[100,1000,10000,10100,100000,101000]};

gp_inline__location="../alternate.tex:13877";
 OXminN(c) = {
   OXpred(c) || error("OXminN() oops, c=",c," is not OXpred");
   1/2*c + 2^(CountLowZeros(c) - 2);
 }
 OXminN_by_search(c) = {
   for(n=1,4*c,
       my(an=alternate_n_to_arm_and_other(n));
       an[1]==0 || next;
       if(bitxor(n,an[2])==c, return(n)));
 }

gp_inline__location="../alternate.tex:13891";
 OXminN_samples = {[3,6,12,11,24,22,48,44,43,96,88,86]};

gp_inline__location="../alternate.tex:13925";
 NumOXpred(k) = floor((k-1)^2/4);

gp_inline__location="../alternate.tex:13932";
 NumOXpred_samples = {[0,0,0,1,2,4,6,9,12,16,20,25]};

gp_inline__location="../alternate.tex:14044";
 Opred(d) = {
   if(d==0, return(0));
   if(d%4, return(0));            \\ must >=2 low zeros
   d=n_odd_part(d);
   while(d,
         if(d%2 == 0, return(0),  \\ no more 0-bits between +/-1
            d%4 == 1, d--,        \\ is +1, subtract it
            d%4 == 3, d++);       \\ is -1, add it back
         d/=2;
         if(d%2!=0, return(0));   \\ must 0-bit between +/-1
         d/=2;
        );
   1;
 }

gp_inline__location="../alternate.tex:14061";
 Opred_at_samples = {[4,8,12,16,20,24,32,40,44,48,52]};

gp_inline__location="../alternate.tex:14091";
 n_to_bits_pm1(n) = {
   my(l=List([]));
   while(n,
         my(a=if(n%2 == 0, 0,
                 n%4 == 1, 1,       \\ is +1
                 n%4 == 3, -1));    \\ is -1
         listput(l,a);
         n-=a;
         n%2==0 || error("oops");
         n/=2);
   Vecrev(l);
 }

gp_inline__location="../alternate.tex:14113";
 Opred_by_search(d) = {
   my(n=1);
   for(n=1,16*abs(d),
       my(an=alternate_n_to_arm_and_other(n));
       if(an[1]==0 && abs(an[2]-n)==d, return(1)));
   0;
 }

gp_inline__location="../alternate.tex:14122";
 Opred_vec_by_search(d_max) = {
   my(n=1,v=vector(d_max));
   for(n=1,16*abs(d_max),
       my(an=alternate_n_to_arm_and_other(n));
       if(an[1]==0,
          my(d=abs(an[2]-n));
          if(d<=#v,v[d]=1)));
   v;
 }

gp_inline__location="../alternate.tex:14137";
 Opred_only_positives(d) = {
   if(d==0, return(0));
   while(d,
         if(d%4 != 0, return(0));  \\ must two 0-bits below +/-1
         d = n_odd_part(d);
         if(d%4 == 1, d--,         \\ is +1, subtract it
            d%4 == 3, return(0));  \\ is -1, disallow
         d /= 2;
        );
   1;
 }

gp_inline__location="../alternate.tex:14151";
 Opred_list_by_search(k) = {
   my(s=Set());
   for(n=1,2^k,
       my(an=alternate_n_to_arm_and_other(n));
       if(an[1]==0 && an[2]<n, s=setunion(s,Set([n-an[2]]))));
   Vec(s);
 }

gp_inline__location="../alternate.tex:14190";
 NumOpred_by_sum(k) = {
     sum(l=1,ceil (k/2)-1, 2^(l-1) * (ceil(k/2)  - l))
   + sum(l=1,floor(k/2)-1, 2^(l-1) * (floor(k/2) - l));
 }

gp_inline__location="../alternate.tex:14201";
 NumOpred(k) = vector_modulo([2,3],k)*2^floor(k/2) - k - 2;

gp_inline__location="../alternate.tex:14205";
 NumOpred_samples = {[0,0,0,1,2,5,8,15,22,37,52,83]};

gp_inline__location="../alternate.tex:14235";
 dNumOpred(k) = NumOpred(k+1) - NumOpred(k);

gp_inline__location="../alternate.tex:14315";
 Opred_max(k) = {
   my(v=vector(k));
   forstep(i=1,#v-2,2,v[i]=1);
   from_binary_vector(v);
 }
 Opred_min(k) = {
   my(v=vector(k));
   forstep(i=1,#v-2,2,v[i]=if(i==1,1,-1));
   from_binary_vector(v);
 }

gp_inline__location="../alternate.tex:14345";
 Skd_by_dir(k,d) = d%=4; sum(n=0,2^k-1, dir(n)%4==d);

gp_inline__location="../alternate.tex:14380";
 Skd_by_End(k,d) = {
   k>=0 || error("Skd_by_End() is for k>=0");
   if(k==0, d%=4; [1,0,0,0][d+1],
            1/4*( 2^k + 2*real(End(k)*(-I)^d) ));
 }

gp_inline__location="../alternate.tex:14396";
 Sk0_formula(k) = 2^(k-2) + 2^floor((k-2)/2);
 Sk0(k) = {
   if(k<0,error("Sk0() is for k>=0"));
   if(k==0,1, Sk0_formula(k));
 }

gp_inline__location="../alternate.tex:14405";
 S0_samples = {[1,1,2,3,6,10,20,36,72,136,272]};

gp_inline__location="../alternate.tex:14427";
 Sk1_formula(k) = 2^(k-2) + if(k%2==1, 2^floor((k-2)/2));
 Sk1(k) = {
   if(k<0,error("Sk1() is for k>=0"));
   if(k==0,0, Sk1_formula(k));
 }

gp_inline__location="../alternate.tex:14436";
 S1_samples = {[0,1,1,3,4,10,16,36,64,136,256]};

gp_inline__location="../alternate.tex:14455";
 Sk2_formula(k) = 2^(k-2) - 2^floor((k-2)/2);
 Sk2(k) = {
   if(k<0,error("Sk2() is for k>=0"));
   if(k==0,0, Sk2_formula(k));
 }

gp_inline__location="../alternate.tex:14464";
 S2_samples = {[0,0,0,1,2,6,12,28,56,120,240]};

gp_inline__location="../alternate.tex:14485";
 Sk3_formula(k) = 2^(k-2) - if(k%2==1, 2^floor((k-2)/2));
 Sk3(k) = {
   if(k<0,error("Sk3() is for k>=0"));
   if(k==0,0, Sk3_formula(k));
 }

gp_inline__location="../alternate.tex:14494";
 S3_samples = {[0,0,1,1,4,6,16,28,64,120,256]};

gp_inline__location="../alternate.tex:14506";
 Skd_funcs = [Sk0,Sk1,Sk2,Sk3];
 Skd(k,d) = vector_modulo(Skd_funcs,d)(k);

gp_inline__location="../alternate.tex:14509";
 Skd_by_abs(k,d) = \
   1/4*( geom_abs((I+1)^k + (-I)^(k+d))^2 - 1 );

gp_inline__location="../alternate.tex:14578";
 SN(n,d) = {
   1/4 * (n
          + 2*real((-I)^d * alternate_point(n))
          + if(n%2==1, (-1)^d)
         );
 }
 SN_by_dir(n,d) = d%=4; sum(j=0,n-1, dir(j)%4==d);

gp_inline__location="../alternate.tex:14590";
 SN0_samples = {[0,1,1,2,2,3,3,3,3,4,4,5,5,5,5]};

gp_inline__location="../alternate.tex:14597";
 SN1_samples = {[0,0,1,1,1,1,2,2,3,3,4,4,4,4,4]};

gp_inline__location="../alternate.tex:14604";
 SN2_samples = {[0,0,0,0,0,0,0,1,1,1,1,1,1,2,2]};

gp_inline__location="../alternate.tex:14611";
 SN3_samples = {[0,0,0,0,1,1,1,1,1,1,1,1,2,2,3]};

gp_inline__location="../alternate.tex:14708";
 L_generated_samples = {[1,2,4,4,12,8,28,16,60,32,124]};
 R_generated_samples = {[1,2,4,8,8,20,16,44,32,92,64]};
 B_generated_samples = {[2,4,8,12,20,28,44,60,92,124,188]};
 LQ_generated_samples = {[1,1,3,2,7,4,15,8,31,16,63]};
 RQ_generated_samples = {[1,2,2,5,4,11,8,23,16,47,32]};
 BQ_generated_samples = {[2,3,5,7,11,15,23,31,47,63,95]};

gp_inline__location="../alternate.tex:14736";
 L_formula(k) = \
   vector_modulo([4,2],k) * 2^floor(k/2) - vector_modulo([4,0],k);
 L(k) = {
   if(k<0,error("L() is for k>=0"));
   if(k==0,1, L_formula(k));
 }

gp_inline__location="../alternate.tex:14746";
 L_samples = {[1,2,4,4,12,8,28,16,60,32,124]};

gp_inline__location="../alternate.tex:14771";
 R_formula(k) = \
   vector_modulo([2,6],k) * 2^floor(k/2) - vector_modulo([0,4],k);
 R(k) = {
   if(k<0,error("R() is for k>=0"));
   if(k==0,1, R_formula(k));
 }

gp_inline__location="../alternate.tex:14781";
 R_samples = {[1,2,4,8,8,20,16,44,32,92,64]};

gp_inline__location="../alternate.tex:14801";
 B(k) = {
   k>=0 || error("B() is for k>=0");
   vector_modulo([6,8],k) * 2^floor(k/2) - 4;
 }

gp_inline__location="../alternate.tex:14806";
 B_samples = {[2,4,8,12,20,28,44,60,92,124,188]};

gp_inline__location="../alternate.tex:14879";
 LQ(k) = {
   if(k<0,error("LQ() is for k>=0"));
   vector_modulo([2,1],k) * 2^floor(k/2) - vector_modulo([1,0],k);
 }

gp_inline__location="../alternate.tex:14889";
 LQ_samples = {[1,1,3,2,7,4,15,8,31,16,63]};

gp_inline__location="../alternate.tex:14906";
 RQ(k) = {
   if(k<0,error("RQ() is for k>=0"));
   vector_modulo([1,3],k) * 2^floor(k/2) - vector_modulo([0,1],k);
 }

gp_inline__location="../alternate.tex:14916";
 RQ_samples = {[1,2,2,5,4,11,8,23,16,47,32]};

gp_inline__location="../alternate.tex:14936";
 BQ(k) = {
   k>=0 || error("BQ() is for k>=0");
   vector_modulo([3,4],k) * 2^floor(k/2) - 1;
 }

gp_inline__location="../alternate.tex:14941";
 BQ_samples = {[2,3,5,7,11,15,23,31,47,63,95]};

gp_inline__location="../alternate.tex:15077";
 AL_formula(k) = {
   2^(k-2) - vector_modulo([1,1/2],k) *2^floor(k/2)
           + vector_modulo([1,0],k);
 }
 AL(k) = {
   if(k<0,error("AL() is for k>=0"));
   if(k==0,0, AL_formula(k));
 }

gp_inline__location="../alternate.tex:15088";
 AL_samples = {[0,0,0,1,1,6,9,28,49,120,225]};

gp_inline__location="../alternate.tex:15104";
 AR_formula(k) = {
   2^(k-2) - vector_modulo([1/2,3/2],k) *2^floor(k/2)
           + vector_modulo([0,1],k);
 }
 AR(k) = {
   if(k<0,error("AR() is for k>=0"));
   if(k==0,0, AR_formula(k));
 }

gp_inline__location="../alternate.tex:15115";
 AR_samples = {[0,0,0,0,2,3,12,21,56,105,240]};

gp_inline__location="../alternate.tex:15132";
 A(k) = 2^(k-1) - vector_modulo([3/2,2],k)*2^floor(k/2) + 1;

gp_inline__location="../alternate.tex:15137";
 A_by_floor_ceil(k) = {
      (2^floor((k-1)/2) - 1)
    * (2^ceil ((k-1)/2) - 1);
 }

gp_inline__location="../alternate.tex:15155";
 A_samples = {[0,0,0,1,3,9,21,49,105,225,465]};

gp_inline__location="../alternate.tex:15271";
 Turn3left(k) = if(k<=2,0, k==3,1, 2^(k-4));

gp_inline__location="../alternate.tex:15280";
 Turn3right(k) = if(k<4,0, 2^(k-4));

gp_inline__location="../alternate.tex:15282";
 Turn1left(k)  = if(k==0,0,k==1,1, k==2||k==3,1, 2^(k-4) + 1-(k%2));
 Turn1right(k) = if(k<=2,0, k==3,1,              2^(k-4) +   (k%2));
 Turn2left(k)  = if(k<=3,0,             2^(k-3) - 1 + (k%2));
 Turn2right(k) = if(k<=1,0, k==2||k==3,1,   2^(k-3) + 0 - (k%2));

gp_inline__location="../alternate.tex:15291";
 \\ Look for runs of "value" within the turn() sequence.
 \\ Return vector [c1,c2,c3] counts of how many runs of length
 \\ 1,2,3 occur between n=1 to n=2^k-1 inclusive.
 turn_count_runs(k,value) = {
   my(prev=0, len=0, runs=[0,0,0]);
   for(n=1,2^k-1,
       my(t = turn(n));
       if(prev==value && t==value, len++,        \\ continue run
          prev==value && t!=value, runs[len]++,  \\ end run
          prev!=value && t==value, len=1);       \\ start run
       prev=t);
   if(prev==value, runs[len]++);
   runs;
 }

gp_inline__location="../alternate.tex:15319";
 Turn3left_over_AL_limit = 1/4;

gp_inline__location="../alternate.tex:15325";
 Turn3right_over_AR_limit = 1/4;

gp_inline__location="../alternate.tex:15341";
 dA_by_floor_ceil(k) = {
   1/2 * (2^floor(k/2) - 1)
       * 2^ceil(k/2);
 }

gp_inline__location="../alternate.tex:15351";
 dA(k) = {
   k>=0 || error("dA() is for k>=0");
   2^(k-1) - 2^floor((k-1)/2);
 }

gp_inline__location="../alternate.tex:15356";
 dA_samples = {[0,0,1,2,6,12,28,56,120,240,496,992]};

gp_inline__location="../alternate.tex:15376";
 JA(k) = {
   k>=0 || error("JA() is for k>=0");
   2^floor(k/2) - 1;
 }

gp_inline__location="../alternate.tex:15381";
 JA_samples = {[0,0,1,1,3,3,7,7,15,15,31,31]};

gp_inline__location="../alternate.tex:15409";
 S(k) = vector_modulo([3,4],k) * 2^floor(k/2) - 1;

gp_inline__location="../alternate.tex:15411";
 S_samples = {[2,3,5,7,11,15,23,31,47,63]};

gp_inline__location="../alternate.tex:15434";
 D(k) = A(k);

gp_inline__location="../alternate.tex:15453";
 P(k) = 2^(k-1) + vector_modulo([3/2,2],k)*2^floor(k/2);

gp_inline__location="../alternate.tex:15459";
 P_samples = {[2,3,5,8,14,24,44,80,152,288]};

gp_inline__location="../alternate.tex:15480";
 A211525(n) = 2^(n+1) + vector_modulo([3,4],n)*2^floor(n/2);

gp_inline__location="../alternate.tex:15488";
 A211525_values_at_ijk(x,i,j,k) = {
   vector(8,n,n--; my(t,u,v);[t,u,v]=binary_padded(n,3);
          (x[i+t]+x[j+u]+x[k+v])*(-1)^(t+u+v)); \\ +i+j+k
 }
 A211525_pred(x) = {
   for(i=1,#x-1,for(j=1,#x-1,for(k=1,#x-1,
       my(len=#Set(A211525_values_at_ijk(x,i,j,k)));
       if(!(len==2||len==4), return(0)))));
   1;
 }
 A211525_tlist(n) = {
   select(A211525_pred,
          vector(3^(n+1),t,t--; apply(d->d-1,digits_padded(t,n+1,3))));
 }
 A211525_by_list(n) = #A211525_tlist(n);

gp_inline__location="../alternate.tex:15531";
 \\ how many distinct sums occur, for various i,j,k
 A211525_setlengths(x) = {
   my(m=Map());
   for(i=1,#x-1,for(j=1,#x-1,for(k=1,#x-1,
       mapput(m,#Set(A211525_values_at_ijk(x,i,j,k)),1))));
   Set(Mat(m)[,1]);
 }

gp_inline__location="../alternate.tex:15542";
 A211525_ternary(t,len) = apply(d->d-1,digits_padded(t,len,3));
 A211525_binary_pn1(t,len) = apply(d->2*d-1,binary_padded(t,len));
 A211525_list_pn1(len) = \
   vector(2^len,t,t--; A211525_binary_pn1(t,len));

gp_inline__location="../alternate.tex:15548";
 A211525_binary_pn01(t,len) = {
   my(v=A211525_binary_pn1(t,floor(len/2)));
   vector(len,i, if(i%2,0,v[i\2]));
 }
 A211525_list_pn01(len) = \
   vector(2^floor(len/2),t,t--; A211525_binary_pn01(t,len));

gp_inline__location="../alternate.tex:15561";
 A211525_binary_pn10(t,len) = {
   my(v=A211525_binary_pn1(t,ceil(len/2)));
   vector(len,i, if(i%2,v[i\2+1],0));
 }
 A211525_list_pn10(len) = \
   vector(2^ceil(len/2),t,t--; A211525_binary_pn10(t,len));

gp_inline__location="../alternate.tex:15578";
 A211525_tlist_by_initials(n) = {
   my(l=min(n+1,2),
      v=vector(3^l,t,t--; A211525_ternary(t,l)));
   if(n>=1,v=select(x->x!=[0,0],v));
   if(n<=1,return(v));
   l=n-1;
   my(pn1=A211525_list_pn1(l),
      pn01=A211525_list_pn01(l),
      pn10=A211525_list_pn10(l));
   v=apply(x->my(exts=if(x[1]==0,pn01,
                         x[2]==0,pn10,
                         pn1));
              apply(ext->concat(x,ext), exts), v);
   concat(v);
 }

gp_inline__location="../alternate.tex:15721";
 Xpred(n) = {
   n>=0 || error("Xpred() is for n>=0, got n=",n);
   my(v=digits(n,4));
   for(i=1,#v, v[i]==0 || v[i]==1 || return(0));
   1;
 }

gp_inline__location="../alternate.tex:15731";
 Xpred_samples = {[1,1,0,0,1,1,0,0,0,0,0,0]};

gp_inline__location="../alternate.tex:15741";
 A151666(n) = Xpred(n);

gp_inline__location="../alternate.tex:15745";
 A151666_compact(n) = \
   if(n, forstep(i=1,logint(n,2),2, if(bittest(n,i),return(0)))); 1;

gp_inline__location="../alternate.tex:15759";
 \\ per Neil Sloane in A151666, those n with k many base-4 digits
 gXpred(k,x) = prod(j=0,k-1, 1 + x^(4^j));

gp_inline__location="../alternate.tex:15781";
 Xnum(m) = {
   m>=0 || error("Xnum() is for m>=0, got m=",m);
   fromdigits(binary(m),4);
 }

gp_inline__location="../alternate.tex:15787";
 Xpred_at_samples = {[0,1,4,5,16,17,20,21,64,65,68,69]};

gp_inline__location="../alternate.tex:15795";
 A000695(n) = Xnum(n);

gp_inline__location="../alternate.tex:15813";
 Gpred(n) = {
   n>=0 || error("Gpred() is for n>=0, got n=",n);
   my(v=digits(n,4));
   for(i=1,#v, v[i]==0 || v[i]==2 || return(0));
   1;
 }

gp_inline__location="../alternate.tex:15829";
 Gpred_samples = {[1,0,1,0,0,0,0,0,1,0,1,0]};

gp_inline__location="../alternate.tex:15837";
 Gpred_compact(n) = \
   if(n, forstep(i=0,logint(n,2),2, if(bittest(n,i),return(0)))); 1;

gp_inline__location="../alternate.tex:15846";
 gGpred(k,x) = prod(j=0,k-1, 1 + x^(2*4^j));

gp_inline__location="../alternate.tex:15859";
 Gnum(m) = {
   m>=0 || error("Gnum() is for m>=0, got m=",m);
   fromdigits(2*binary(m),4);
 }

gp_inline__location="../alternate.tex:15869";
 Gnum_samples = {[0,2,8,10,32,34,40,42,128,130,136,138]};

gp_inline__location="../alternate.tex:15878";
 A062880(n) = Gnum(n);

gp_inline__location="../alternate.tex:16002";
 NonXpred(n) = n>=0 && !Xpred(n);
 NonGpred(n) = n>=0 && !Gpred(n);

gp_inline__location="../alternate.tex:16031";
 NonXnum_k(m) = \
   my(k=0); while(!(m<4^(k+1)-2^(k+1)),k++); k;

gp_inline__location="../alternate.tex:16037";
 NonXnum(m) = {
   m>=0 || error("NonXnum() is for m>=0");
   my(k=NonXnum_k(m));
   if(m < 2*(4^k-2^k),
      4^k + NonXnum(m - (4^k-2^k)),
      m + 2^(k+1));
 }

gp_inline__location="../alternate.tex:16055";
 NonXnum_samples = {[2,3,6,7,8,9,10,11,12,13,14,15]};

gp_inline__location="../alternate.tex:16066";
 NonXnum_base4_samples = {[2,3,12,13,20,21,22,23,30,31,32,33]};

gp_inline__location="../alternate.tex:16178";
 NonXnum_by_procedure(m) = {
   my(k=if(m==0,1,logint(m,4)+2),
      n=m+2^k);
   while(1,
     k = k-1;
     \\ if(k==0,break);  stops anyway at k=0, no test needed

     k>=0 || error();
     my(v=digits(n,4));
     while(#v<k+1, v=concat(0,v));
     my(lopos=#v-(k+1-1));   \\ pos of low k+1 many digits
     for(i=1,lopos-1,
         v[i]==0 || v[i]==1 || error()); \\ high digits 0 or 1
     my(vlo=v[lopos..#v]);
     #vlo==k+1 || error("k=",k," vlo length ",#vlo);
     my(lo=fromdigits(vlo,4));  \\ low digits m + 2*2^k
     \\ print("k="k" n="n" cf offset "2*2^k"  "v" part "vlo);
     lo >= 0 + 2*2^k || error("oops, lo too small");
     lo < 4^(k+1) - 2^(k+1) + 2*2^k || error("oops, lo too big");

     if(bittest(n,2*k+1)==1, break);
     if(bittest(n-2^k,2*k)==0,
        n = n-2^k);
     );
   n;
 }

gp_inline__location="../alternate.tex:16314";
 NonXnum_bit_scan_is_digit0(n,k) = {
   0 <= n - 2*2^k || error();
   n - 2*2^k < 4^(k+1) + 2^(k+1) || error();
   if(bittest(n,2*k)==0,
      return(1));
   for(i=k,2*k-1,
     if(bittest(n,i)!=0, return(0)));
   1;
 }

gp_inline__location="../alternate.tex:16352";
 \\ a long one-liner
 NonXnum_compact(n) = {
   my(k=if(n,logint(n,4))+2, t); n+=2^k;
   while(!bittest(n,2*(k--)+1), if(!bittest(t=n-2^k,2*k),n=t)); n;
 }

gp_inline__location="../alternate.tex:16361";
 \\ think until() a touch obscure
 NonXnum_by_until(n) = {
   my(k=if(n,logint(n,4))+1, t); n+=1<<(k+1);
   until(bittest(n,2*(k--)+1),
     if(!bittest(t=n-2^k,2*k),n=t));
   n;
 }

gp_inline__location="../alternate.tex:16371";
 \\ with lots of workings out
 NonXnum_by_bigprocedure(m) = {
   my(debug=0);
   if(debug, print("NonXnum_by_bigprocedure() m=",m));
   my(orig_m=m);
   my(k=0); while(!(m<4^(k+1)-2^(k+1)),k++);
   if(debug, print("  start k="k));
   my(n=m+2^(k+1), ret=0, seen=0);
   while(k>=0,
     m < 4^(k+1)-2^(k+1) || error("m=",m," range k=",k);
     if(debug, print("  at k="k" n=[",to_base4(n),"]  m="m));
     bitlength(m+2^(k+1)) <= 2*(k+1) || error();
     n == ret + m + 2^(k+1) || error();
     bittest(n,2*k+1) == (m >= 2*(4^k-2^k))
       || error("condition k=",k);
     ret + NonXnum(m) == NonXnum(orig_m) || error();
     my(v=digits(n,4));
     for(i=1,seen, v[i]==0 || v[i]==1 || error());

     if(bittest(n,2*k+1),   \\ got a 2 or 3
        ret + m + 2^(k+1) == n  || error("final");
        return(n));
     v[seen+1]==0 || v[seen+1]==1 || error("high now is 0 or 1");

     \\ 1 001000    bit 1 at 2k and at least one other 1-bit
     \\             converse: 0 at 2k, or 1 there and below all 0s
     my(by_scan=0);
     for(i=k,2*k-1, if(bittest(n,i), by_scan=1;break)); \\ a 1-bit
     by_scan = by_scan && bittest(n,2*k);

     my(want_sub=1);
     for(i=k,2*k-1, if(bittest(n,i),
                       want_sub=0;break));  \\ non-zero, no sub
     if(bittest(n,2*k)==0, want_sub=1);     \\ zero high, want sub
     want_sub == !by_scan  || error();

     want_sub == (bittest(n-2^k,2*k) == 0) || error("want vs bit");

     n -= 2^k;
     bittest(n,2*k) == (m >= 4^k-2^k) || error("output 1 cmp");
     bittest(n,2*k) == by_scan
       || error("by_scan=",by_scan," vs bittest ",bittest(n,2*k),
                " orig_m=",orig_m);
     if(bittest(n,2*k),      \\ still got bit 2k after sub
        \\ n += 2^k;
        );
     n += 2^k;

     if(want_sub, n -= 2^k);

     if(want_sub,
        bittest(n,2*k)==0 || error("sub is for output 0 digit"));

     if(4^k-2^k <= m,
        ret += 4^k;
        m -= 4^k-2^k);
     k--; seen++);
   n;
 }

gp_inline__location="../alternate.tex:16443";
 \\ Return the smallest n with Im point(n) = y.
 YfirstN_by_search(y) = {
   y>=0 || error();
   for(n=0,oo, if(imag(alternate_point(n))==y, return(n)));
 }

gp_inline__location="../alternate.tex:16477";
 NonGnum_k(m) = NonXnum_k(m);

gp_inline__location="../alternate.tex:16482";
 NonGnum(m) = {
   m>=0 || error("NonGnum() is for m>=0, got m=",m);
   my(k=NonGnum_k(m));
   if(m < 2*4^k-2^k,   m + 2^k,
      2*4^k-2^k <= m && m < 3*4^k-2*2^k,
                       2*4^k + NonGnum(m-(2*4^k-2^k)),
      m + 2^(k+1));
 }

gp_inline__location="../alternate.tex:16502";
 NonGnum_samples = {[1,3,4,5,6,7,9,11,12,13,14,15]};

gp_inline__location="../alternate.tex:16510";
 NonGnum_base4_samples = {[1,3,10,11,12,13,21,23,30,31,32,33]};

gp_inline__location="../alternate.tex:16527";
 base4_digit(n,k) = 2*bittest(n,2*k+1) + bittest(n,2*k);

gp_inline__location="../alternate.tex:16529";
 digits_padded_if_necessary(n,k,base=10) = {
   my(v = digits(n,base));
   while(#v < k, v=concat(0,v));
   v;
 }

gp_inline__location="../alternate.tex:16535";
 NonGnum_by_bigprocedure(m) = {
   my(debug=0);
   m>=0 || error("NonGnum_by_bigprocedure() is for m>=0");
   my(k=if(m==0,1,logint(m,4)+2),
      n=m+2^k,
      ret=0);
   while(1,
     k = k-1;
     if(k<0,break);

     my(v=digits_padded_if_necessary(n,k+1,4));
     if(debug,print(" k="k" "v"  m="m));
     k>=0 || error();
     m < 4^(k+1)-2^(k+1) || error("m too big");
     my(lopos=#v-k);   \\ pos of low k+1 many digits
     for(i=1,lopos-1,
         v[i]==0 || v[i]==2 || error()); \\ high digits 0 or 2
     my(vlo=v[lopos..#v]);
     #vlo==k+1 || error("k=",k," vlo length ",#vlo);
     my(lo=fromdigits(vlo,4));  \\ low digits m + 2*2^k
     lo == m + 2*2^k || error("lo ",lo," wrong want ",m+2*2^k);
     \\ print("k="k" n="n" cf offset "2*2^k"  "v" part "vlo);
     lo >= 0 + 2*2^k || error("oops, lo too small");
     lo < 4^(k+1) - 2^(k+1) + 2*2^k || error("oops, lo too big");

     (m >= 3*4^k - 2*2^k) == (base4_digit(n,k)==3)
       || error("digit 3 condition");
     if(base4_digit(n,k)==3,
        if(debug,print("  digit 3 ret "n" "to_base4(n)));
        ret += m + 2^(k+1);
        n == ret  || error();
        return(n));
     if(debug,print("  not 3"));
     n -= 2^k;

     v=digits_padded_if_necessary(n,k+1,4);
     vlo=v[lopos..#v];
     lo=fromdigits(vlo,4);
     lo == m + 2^k || error("lo sub ",lo," wrong want ",m+2^k);

     if(debug,print("  sub to "
                digits_padded_if_necessary(n,k+1,4)));
     (4^k - 2^k <= m && m < 2*4^k - 2^k)
       == (base4_digit(n,k)==1)
       || error("digit 1 condition");
     if(base4_digit(n,k)==1,
        if(debug,print("  digit 1 ret "n" "to_base4(n)));
        ret += m + 2^k;
        n == ret || error();
        return(n));
     if(debug,print("  not 1"));

     if(base4_digit(n,k)==2,
        n += 2^k);

     if(m >= 2*4^k-2^k,
       if(debug,print("  is 2"));
       m -= 2*4^k - 2^k;
       ret += 2*4^k);
     );

   if(debug, print(" final ret "n" "to_base4(n)));
   n == ret || error("final ret");
   n;
 }

gp_inline__location="../alternate.tex:16687";
 NonGnum_procedure(m) = {
   m>=0 || error("NonGnum_procedure() is for m>=0");
   my(k=if(m==0,1,logint(m,4)+2),
      n=m+2^k,
      ret=0);
   while(1,
     k = k-1;
     if(k<0,break);
     if(base4_digit(n,k)==3, return(n));
     my(r=n-2^k);
     if(base4_digit(r,k)==1, return(r));
     if(base4_digit(r,k)==0, n=r));
   n;
 }

gp_inline__location="../alternate.tex:16752";
 NonGnum_compact(n) = {
   my(k=if(n,logint(n,4))+2, t); n+=2^k;
   while(k--; !bittest(n,2*k+1) || !bittest(n,2*k),
     if(!bittest(t=n-2^k,2*k+1), n=t; if(bittest(n,2*k),break)));
   n;
 }

gp_inline__location="../alternate.tex:16768";
 SpredInf_by_other(n) = {
   my(an=alternate_n_to_arm_and_other(n));
   an[1]!=0;
 }
 DpredInf_by_other(n) = {
   my(an=alternate_n_to_arm_and_other(n));
   an[1]==0;
 }

gp_inline__location="../alternate.tex:16789";
 SpredInf(n) = Xpred(n) || Gpred(n);

gp_inline__location="../alternate.tex:16794";
 SpredInf_samples = {[1,1,1,0,1,1,0,0,1,0,1,0,0,0,0,0,1,1,0,0]};

gp_inline__location="../alternate.tex:16817";
 SnumInf(m) = {
   m>=0 || error("SnumInf() is for m>=0, got m=",m);
   if(m==0,return(0));
   my(v=binary(m+1),
       a=v[2]);   \\ second highest bit
   v=v[^2];       \\ remove that bit
   fromdigits(v,4) * (1+a);
 }

gp_inline__location="../alternate.tex:16829";
 SnumInf_samples = {[0,1,2,4,5,8,10,16,17,20,21,32]};

gp_inline__location="../alternate.tex:16840";
 A126684_compact(n) = \
   if(n==1,0, my(v=binary(n)); fromdigits(v[^2],4)<<v[2]);

gp_inline__location="../alternate.tex:16848";
 SnumInf_base4_samples = {[0,1,2,10,11,20,22,100,101,110,111,200]};

gp_inline__location="../alternate.tex:16860";
 \\ remove second highest 1-bit
 A162751(n) = fromdigits(binary(n+1)[^2],2);

gp_inline__location="../alternate.tex:16879";
 DpredInf(n) = {
   n>=0 || return(0);
   my(v=digits(n,4),seen1=0,seen2=0);
   for(i=1,#v,
       if(v[i]==3, return(1));
       if(v[i]==1, seen1=1; if(seen2,return(1)));
       if(v[i]==2, seen2=1; if(seen1,return(1))));
   0;
 }

gp_inline__location="../alternate.tex:16892";
 DpredInf_by_bits(n) = {
   my(v=digits(n,2),seen_even=0,seen_odd);
   for(i=1,#v,
       if(v[i], if(i%2==0, seen_even=1,
                           seen_odd=1);
                if(seen_even && seen_odd, return(1))));
   0;
 }

gp_inline__location="../alternate.tex:16903";
 DpredInf_samples = {[0,0,0,1,0,0,1,1,0,1,0,1,1,1,1,1,0,0,1,1]};

gp_inline__location="../alternate.tex:16914";
 DpredInf_at_samples = {[3,6,7,9,11,12,13,14,15,18,19,22,23,24]};

gp_inline__location="../alternate.tex:16930";
 DpredInf_at_base4_samples = {[3,12,13,21,23,30,31,32,33,102,103,112]};

gp_inline__location="../alternate.tex:16950";
 \\ func is a function called x=func(i) for i=0 upwards.
 \\ Return a vector of the run lengths of the first n many runs of
 \\ "value" returned by func().
 FuncRunsOf(func,value,n) = {
   my(prev=func(0), l=List([]), i=1, run=(prev==value));
   while(#l<n,
         my(this=func(i)); i++;
         if(this==value,                run++,
            prev==value && this!=value, listput(l,run); run=0);
         prev=this);
   Vec(l);
 }

gp_inline__location="../alternate.tex:16991";
 Spred_k(k,n) = {
   if(n<0,   error("Spred_k() n=",n," negative"));
   if(n>2^k, error("Spred_k() n=",n," bigger than 2^",k));
   my(an = alternate_n_to_arm_and_other(n));
   n==0 || an[1]!=0 || an[2] > 2^k;
 }
 Spred_list(k) = select(n->Spred_k(k,n),vector(2^k+1,n,n-1));

gp_inline__location="../alternate.tex:17019";
 Dpred_k(k,n) = {
   if(n<0,   error("Dpred_k() n=",n," negative"));
   if(n>2^k, error("Dpred_k() n=",n," bigger than 2^",k));
   my(an = alternate_n_to_arm_and_other(n));
   n>0 && an[1]==0 && an[2] <= 2^k;
 }
 Dpred_list(k) = select(n->Dpred_k(k,n),vector(2^k+1,n,n-1));

gp_inline__location="../alternate.tex:17080";
 DpredLeft_k(k,n) = Dpred_k(k,n) && turn(n)==1;

gp_inline__location="../alternate.tex:17085";
 DpredRight_k(k,n) = Dpred_k(k,n) && turn(n)==-1;

gp_inline__location="../alternate.tex:17139";
 DpredLeft(k,n) = Dpred_k(k,n) && turn(n)==1;

gp_inline__location="../alternate.tex:17145";
 DpredRight(k,n) = Dpred_k(k,n) && turn(n)==-1;

gp_inline__location="../alternate.tex:17155";
 DpredLeftInf(n) = {
   return(n>=1 && DpredInf_by_other(n) && turn(n)==1);
   my(v=digits(n,4));
   for(i=1,#v, if(!(v[i]==0||v[i]==1), return(0)));
   1;
 }

gp_inline__location="../alternate.tex:17165";
 DpredLeftInf_samples = {[0,0,0,0,0,0,1,0,0,1,0,0]};

gp_inline__location="../alternate.tex:17177";
 DpredLeftInf_at_samples = {[6,9,13,14,22,24,25,29,30,33,36,37]};

gp_inline__location="../alternate.tex:17191";
 NonDpredLeftInf_at_samples = {[0,1,2,3,4,5,7,8,10,11,12,15]};
 NonDpredLeftInf(n) = n>=0 && !DpredLeftInf(n);

gp_inline__location="../alternate.tex:17211";
 DpredRightInf(n) = {
   return(n>=1 && DpredInf_by_other(n) && turn(n)==-1);
   my(v=digits(n,4));
   for(i=1,#v, if(!(v[i]==0||v[i]==2), return(0)));
   1;
 }

gp_inline__location="../alternate.tex:17219";
 DpredRightInf_samples = {[0,0,0,1,0,0,0,1,0,0,0,1]};

gp_inline__location="../alternate.tex:17231";
 DpredRightInf_at_samples = {[3,7,11,12,15,18,19,23,26,27,28,31]};

gp_inline__location="../alternate.tex:17245";
 NonDpredRightInf_at_samples = {[0,1,2,4,5,6,8,9,10,13,14,16]};
 NonDpredRightInf(n) = n>=0 && !DpredRightInf(n);

gp_inline__location="../alternate.tex:17374";
 Sleft(k) = vector_modulo([1,3],k) * 2^floor(k/2) \
            - vector_modulo([1,2],k);

gp_inline__location="../alternate.tex:17382";
 Sleft_samples = {[0,1,1,4,3,10,7,22,15,46]};

gp_inline__location="../alternate.tex:17397";
 Sright(k)= vector_modulo([2,1],k) * ( 2^floor(k/2) - 1);

gp_inline__location="../alternate.tex:17404";
 Sright_samples = {[0,0,2,1,6,3,14,7,30,15]};

gp_inline__location="../alternate.tex:17449";
 Dleft(k) = {
   if(k==0,0,
      2^(k-2) - vector_modulo([1/2,3/2],k)*2^floor(k/2)
      + vector_modulo([0,1],k));
 }
 Dright(k) = {
   if(k==0,0,
      2^(k-2) - vector_modulo([1,1/2],k)*2^floor(k/2)
      + vector_modulo([1,0],k));
 }

gp_inline__location="../alternate.tex:17509";
 LpredInf(n) = Gpred(n) || Gpred(n+1);

gp_inline__location="../alternate.tex:17515";
 LpredInf_by_base4(n) = {
   my(l=List(digits(n,4)));
   if(#l>=1 && (l[#l]==3 || l[#l]==1), \\ low run 13333
      while(#l>=1 && l[#l]==3, listpop(l));
      (#l>=1 && l[#l]==1) || return(0);
      listpop(l));
   while(#l>=1 && (l[#l]==0 || l[#l]==2), listpop(l));
   #l==0;
 }

gp_inline__location="../alternate.tex:17529";
 LpredInf_samples = {[1,1,1,0,0,0,0,1,1,1,1,0]};

gp_inline__location="../alternate.tex:17539";
 \\ per recurrence in Gawron and Ulas and as shown in A270803
 A270803(n) = {             \\ Thue-Morse inverse, LpredInf
   if(n==0 || n==3, 0,
      n==1 || n==2, 1,
      n%4==0, A270803(n-1),
      n%4==1, A270803(n-2),
      n%4==2, A270803(n-3),
             (A270803(n-4) + A270803((n-3)/4)) % 2);
 }
 A270803 = memoize(A270803);

gp_inline__location="../alternate.tex:17554";
 \\ Gawron and Ulas theorem 3.1 characterizing.
 \\ n>0 and in n+1 all even bit positions >=2 are bit=0.
 A270803_compact(n) = \
   if(n==0,0, n++; forstep(i=2,logint(n,2),2, if(bittest(n,i), return(0))); 1);

gp_inline__location="../alternate.tex:17572";
 A001002(n) = \
   sum(k=ceil(n/2),n, binomial(n+k,k)*binomial(k, n-k))/(n+1);

gp_inline__location="../alternate.tex:17587";
 \\ first 4^k terms generating function, x^0 to x^(4^k-1) inclusive
 gLpredInf_k(k,x) = - 1/x + (1+1/x)*gGpred(k,x);

gp_inline__location="../alternate.tex:17603";
 \\ first n terms of generating function, x^0 to x^(n-1) inclusive
 gLpredInf_n(n,x) = sum(j=0,n-1, LpredInf(j)*x^j);

gp_inline__location="../alternate.tex:17616";
 LnumInf(m) = {
   m>=0 || error("LnumInf() is for m>=0, got m=",m);
   Gnum(floor((m+1)/2)) - (m%2);
 }

gp_inline__location="../alternate.tex:17627";
 LnumInf_samples = {[0,1,2,7,8,9,10,31,32,33,34,39]};

gp_inline__location="../alternate.tex:17635";
 \\ per recurrence in Gawron and Ulas and as shown in A270804
 A270804(n) = {     \\ Thue-Morse inverse 1-bit positions
   n>=0 || error();
   if(n<=2,n,
      n==3,7,
      n%4==0,A270804(n-1)+1,
      n%4==1,A270804(n-2)+2,
      n%4==2,A270804(n-3)+3,
      n%8==3,A270804(n-3)+7,
             4*A270804((n-1)/2)+3);
 }

gp_inline__location="../alternate.tex:17649";
 A270804_compact(n) = \
   my(v=binary(n+1)); 2*fromdigits(v[^#v],4) - !v[#v];

gp_inline__location="../alternate.tex:17667";
 NonLpredInf(n) = n>=0 && !LpredInf(n);

gp_inline__location="../alternate.tex:17684";
 z_is_visited(z) = {
      alternate_unpoint(z, 1)[1]==0
   || alternate_unpoint(z,-1)[1]==0;
 }

gp_inline__location="../alternate.tex:17689";
 LpredInf_by_point(n) = {
   my(z=alternate_point(n));
   my(dz=I^dir(n));
      ! z_is_visited(z+I*dz)
   || ! z_is_visited(z+(1+I)*dz);
 }

gp_inline__location="../alternate.tex:17698";
 LpredInf_by_location(n) = {
   my(z=alternate_point(n));
   my(d=dir(n));
      (real(z)==imag(z)   && d==0)
   || (real(z)==imag(z)+1 && d==1);
 }

gp_inline__location="../alternate.tex:17780";
 ThueMorse(n) = CountOneBits(n) % 2;

gp_inline__location="../alternate.tex:17783";
 ThueMorse_samples = {[0,1,1,0,1,0,0,1,1,0]};

gp_inline__location="../alternate.tex:17792";
 A010060(n) = ThueMorse(n);
 A010059(n) = 1-ThueMorse(n);

gp_inline__location="../alternate.tex:17799";
 \\ first n terms of generating function, x^0 to x^(n-1) inclusive
 gThueMorse_n(n,x) = sum(j=0,n-1, ThueMorse(j)*x^j);

gp_inline__location="../alternate.tex:17819";
 \\ per Benoit Cloitre in A010060
 \\ good for n of k many bits
 gThueMorse_bits(k,x) = 1/2*( 1/(1-x) - prod(j=0,k-1, 1-x^(2^j)) );

gp_inline__location="../alternate.tex:17899";
 gXpred_sub_1_inverse(x) = -1 + (1+x)/(1-x^4);

gp_inline__location="../alternate.tex:17902";
 gXpred_sub_1_inverse_samples = {[0,1,0,0,1,1,0,0,1,1,0,0]};

gp_inline__location="../alternate.tex:17921";
 LnumInf_by_bits(m) = {
   m++;
   my(v=concat(0,binary(m)));
   fromdigits(2*v[1..#v-1],4) - 1 + v[#v];
 }

gp_inline__location="../alternate.tex:17954";
 power_vecpol(v,n) = {
   my(ret=v);
   for(i=2,n, ret=multiply_vecpol(v,ret));
   ret;
 }
 multiply_vecpol(u,v) = {
   vector(#v,i,i--; sum(j=0,i, u[j+1]*v[i-j+1]) % 2);
 }
 compositional_inverse(v) = {
   my(debug=0,
      start=1,
      inverse=vector(#v),
      powered=v,
      cancelled=v);
   while(1,
         if(start>#v,return(v));
         if(v[start],break());
         start++);
   inverse[start]=1;
   for(i=start+1,#v,
       powered=multiply_vecpol(v,powered);
       if(cancelled[i],
          inverse[i]=1;
          if(debug,print("at "i);
                   print(" "cancelled);
                   print(" "powered));
          cancelled = vector(#v,i, (cancelled[i]+powered[i])%2);
          if(debug,print("="cancelled));
          cancelled[i]==0 || error();
          ));
   if(debug,print("result "inverse));
   inverse;
 }

gp_inline__location="../alternate.tex:18008";
 A254379(n) = (n%2==0 && ThueMorse(n)==1);

gp_inline__location="../alternate.tex:18056";
 \\ 1 = n has all runs of 0-bits even length
 \\ 0 = n has any run of 0-bits odd length
 BaumSweet(n) = {
   my(v=binary(n),len=0);
   for(i=1,#v,
       if(v[i]==0,
          len++,
          if(len%2, return(0)); len=0));  \\ odd run return 0
   len%2==0;  \\ odd final run return 0, even return 1
 }

gp_inline__location="../alternate.tex:18073";
 BaumSweet_samples = {[1,1,0,1,1,0,0,1,0,1,0,0,1]};

gp_inline__location="../alternate.tex:18084";
 \\ Charles R Greathouse in A086747
 A086747_recursive(n) = {
   if(n<3, n<2,
      if(n%2, A086747_recursive(n\2),
              n%4==0 && A086747_recursive(n/4)));
 }

gp_inline__location="../alternate.tex:18100";
 BaumSweet_pairwise_morphism_map = {
   Map([[0,0], [0,0,0,0];
        [0,1], [1,0,0,1];
        [1,0], [0,1,0,0];
        [1,1], [1,1,0,1] ]);
 }
 BaumSweet_pairwise_expand(v) = {
   #v%2==0 || error("BaumSweet_pairwise_expand() is for even length vector");
   my(ret=List([]));
   forstep(i=1,#v,2,
     listput(ret, mapget(BaumSweet_pairwise_morphism_map,
                         [v[i],v[i+1]])));
   concat(Vec(ret));
 }

gp_inline__location="../alternate.tex:18121";
 \\ Allouche, section 2.4 example 4
 \\ is A316831 as 0..3
 BaumSweet_morphism_state_table = {
   [[1,2],  \\ A->AB
    [3,2],  \\ B->CB
    [2,4],  \\ C->BD
    [4,4]   \\ D->DD
   ]};
 BaumSweet_vector_by_morphism_states(len) = {
   my(v=[1]);
   while(#v < len,
     v=concat(apply(e->BaumSweet_morphism_state_table[e], v)));
   v[1..len];
 }

gp_inline__location="../alternate.tex:18138";
 { my(table=[0,1; 2,1; 1,3; 3,3]);
   A316831(n) = my(ret=0); forstep(i=if(n,logint(n,2)),0,-1,
     ret=table[ret+1,bittest(n,i)+1]);   ret; }

gp_inline__location="../alternate.tex:18142";
 {my(table=[0,1; 2,1; 1,3; 3,3]);
   table == apply(s->s-1, Mat(BaumSweet_morphism_state_table~))
     || error();
 A316831(n) = my(v=binary(n),ret=0); for(i=1,#v, ret=table[ret+1,v[i]+1]); ret;
 }

gp_inline__location="../alternate.tex:18156";
 BaumSweet_vector_by_morphism(len) = \
   apply(e->[1,1,0,0][e], BaumSweet_vector_by_morphism_states(len));

gp_inline__location="../alternate.tex:18262";
 gBaumSweet_n(n,x) = sum(j=0,n-1, BaumSweet(j)*x^j);

gp_inline__location="../alternate.tex:18272";
 gXpred_n(n,x) = sum(j=0,n-1, Xpred(j)*x^j);
 gXpred_times_x_n(n,x) = x*gXpred_n(n-1,x);
 gBaumSweet_times_x_n(n,x) = x*gBaumSweet_n(n-1,x);

gp_inline__location="../alternate.tex:18349";
 A086747_compact(n) = {
   if(n==0,0, my(z=0); for(i=0,logint(n,2),
     if(bittest(n,i), if(z%2,return(0)); z=0, z++)); 1);
 }

gp_inline__location="../alternate.tex:18357";
 BaumSweetK(n,k) = {
   my(zeros=0);
   for(i=0,if(n,logint(n,2)),
     if(bittest(n,i), if(zeros%k,return(0)); zeros=0,
        zeros++));
   1;
 }

gp_inline__location="../alternate.tex:18373";
 \\ g^(2^k-1) + x*g + 1 = 0
 BaumSweetKminusPoly(k,x,len) = {
   my(g=1);
   for(i=1,len-1,
     my(p=lift((g+O(x^(i+1)))^(2^k-1) + x*g + 1));
     if(polcoeff(p,i) % 2,
        g += x^i));
   g;
 }

gp_inline__location="../alternate.tex:18387";
 \\ g^(2^k+1) + x*g + 1 = 0
 BaumSweetKplusPoly(k,x,len) = {
   my(g=0);
   for(i=0,len-1,
     my(p=lift((g+O(x^(i+1)))^(2^k+1) + x*g + 1));
     if(polcoeff(p,i) % 2,
        g += x^i));
   g;
 }

gp_inline__location="../alternate.tex:18411";
 BaumSweet_mult_and_radix(n,mult,radix) = {
   my(zeros=0);
   while(n,
     if(n%radix, if(zeros%mult,return(0)); zeros=0,
        zeros++);
     n \= radix);
   1;
 }

gp_inline__location="../alternate.tex:18462";
 gGpred_n(n,x) = sum(j=0,n-1, Gpred(j)*x^j);

gp_inline__location="../alternate.tex:18465";
 gGpred_times_x_n(n,x) = x*gGpred_n(n-1,x);

gp_inline__location="../alternate.tex:18471";
 gGpred_times_x_inverse_n(n,x) = {
   my(v=compositional_inverse(vector(n,n,n-=2; n>=0 && Gpred(n))));
   subst(Polrev(v),'x,x);
 }

gp_inline__location="../alternate.tex:18531";
 gKM_times_x_inverse(x) = x + x^2;
 gKM(n,x) = subst(Polrev(KM_vector(n)),'x,x);
 gKM_times_x(n,x) = x*gKM(n,x);

gp_inline__location="../alternate.tex:18540";
 gKM_k(k,x) = sum(j=0,k-1, x^(2^j));

gp_inline__location="../alternate.tex:18549";
 RpredInf_by_location(n) = {
   my(z=alternate_point(n));
   my(d=dir(n)%4);
       imag(z)==0
   || (imag(z)==1 && d==3)
   || (imag(z)==1 && d==0 && real(z)%2==1);
 }

gp_inline__location="../alternate.tex:18580";
 RpredInf(n) = Xpred(n) || Xpred(n+1) || Xpred(n+2);

gp_inline__location="../alternate.tex:18598";
 RpredInf_by_base4(n) = {
   my(l=List(digits(n,4)));
   if(#l>=1 && (l[#l]==2 || l[#l]==3),    \\ low run 0333[23]
      listpop(l);
      while(#l>=1 && l[#l]==3, listpop(l));
      (#l==0 || (#l>=1 && l[#l]==0)) || return(0);
      listpop(l));
   while(#l>=1 && (l[#l]==0 || l[#l]==1), listpop(l));
   #l==0;
 }

gp_inline__location="../alternate.tex:18615";
 RpredInf_samples = {[1,1,1,1,1,1,0,0,0,0,0,0]};

gp_inline__location="../alternate.tex:18697";
 RnumInf(m) = {
   m>=0 || error("RnumInf() is for m>=0, got m=",m);
   Xnum(floor(m/2)+1) - vector_modulo([1,0,2,1],m);
 }

gp_inline__location="../alternate.tex:18709";
 Rnum_samples = {[0,1,2,3,4,5,14,15,16,17,18,19]};

gp_inline__location="../alternate.tex:18716";
 Rnum_base4_samples = {[0,1,2,3,10,11,32,33,100,101,102,103]};

gp_inline__location="../alternate.tex:18732";
 NonRpredInf(n) = n>=0 && !RpredInf(n);

gp_inline__location="../alternate.tex:18789";
 gen_enclosure_right_samples = [0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0];

gp_inline__location="../alternate.tex:18814";
 gen_enclosure_left_samples = [0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,1,0];

gp_inline__location="../alternate.tex:18850";
 DpredFirst_k(k,n) = Dpred_k(k,n) && n < alternate_n_to_other(n);

gp_inline__location="../alternate.tex:18858";
 DpredFirstInf(n) = DpredInf(n) && n < alternate_n_to_other(n);

gp_inline__location="../alternate.tex:18862";
 DpredFirstInf_samples = {[0,0,0,1,0,0,1,0,0,1,0,1,1,0,0,1,0,0,1,1]};

gp_inline__location="../alternate.tex:18879";
 \\ return a vector of the first n terms of A171588
 A171588_vector(n) = {
   if(n==0,return([]));
   my(v=[0]);
   while(#v<n, v=concat(apply(n->if(n==0,[0,0,1],[0]),v)));
   v[1..n];
 }

gp_inline__location="../alternate.tex:18888";
 \\ return a vector of the first n terms of A286691
 A286691_vector(n) = {
   my(v=A171588_vector(n\3+1));
   v=concat(apply(n->if(n==0,[0,1,0],[1,1,0]), v));
   v[1..n];
 }

gp_inline__location="../alternate.tex:18901";
 DpredFirstInf_at_samples = {[3,6,9,11,12,15,18,19,22,24,25]};

gp_inline__location="../alternate.tex:18915";
 DpredSecond(n) = DpredInf(n) && n > alternate_n_to_other(n);

gp_inline__location="../alternate.tex:18919";
 DpredSecond_samples = {[0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,0,0,0,0,0]};

gp_inline__location="../alternate.tex:18936";
 DpredSecond_at_samples = {[7,13,14,23,26,27,28,29,31,39,45]};

gp_inline__location="../alternate.tex:18950";
 DpredFirstInf_across_join(n) = {
   my(k=length(binary(n)));
   DpredFirst_k(k+1,n);
 }

gp_inline__location="../alternate.tex:18966";
 D_by_DpredFirstInf(k) = sum(n=0,2^k, DpredFirst_k(k,n));

gp_inline__location="../alternate.tex:18971";
 D_by_DpredSecond(k) = sum(n=0,2^k, DpredSecond(n));

gp_inline__location="../alternate.tex:19015";
 DpredSecondL(n) = DpredSecond(n) && TurnLpred(n);

gp_inline__location="../alternate.tex:19022";
 DpredSecondL_at_samples = {[13,14,29,45,46,49,52,53,54,56,61]};

gp_inline__location="../alternate.tex:19034";
 DpredSecondR(n) = DpredSecond(n) && TurnRpred(n);

gp_inline__location="../alternate.tex:19041";
 DpredSecondR_at_samples = {[7,23,26,27,28,31,39,55,58,71,87]};

gp_inline__location="../alternate.tex:19054";
 AL_by_DpredSecondR(k) = sum(n=0,2^k, DpredSecondR(n));

gp_inline__location="../alternate.tex:19061";
 AR_by_DpredSecondL(k) = sum(n=0,2^k, DpredSecondL(n));

gp_inline__location="../alternate.tex:19134";
 func_is_consecutive(n,f,value,reps) = {
   while(reps > 0,
         if(f(n)!=value,return(0));
         reps--; n++);
   1;
 }
 func_first_consecutive(f,value,reps) = \
   for(n=0,oo, if(func_is_consecutive(n,f,value,reps),return(n)));

gp_inline__location="../alternate.tex:19178";
 Epred(n) = DpredSecond(n+1);
 EpredL(n) = DpredSecondR(n+1);
 EpredR(n) = DpredSecondL(n+1);

gp_inline__location="../alternate.tex:19275";
 EpredEight_enclosure_sides = [1,1,1,-1, -1,1,1,-1];

gp_inline__location="../alternate.tex:19295";
 DpredSecondEight(n) = {
   my(v=digits(n,4));
   my(i=#v);
   if(i<1 || v[i]!=2, return(0)); i--;
   if(i<1 || v[i]!=2, return(0)); i--;
   while(i>=1 && v[i]==3, i--);
   if(i<1 || v[i]!=2, return(0)); i--;
   while(i>=1 && (v[i]==2||v[i]==3), i--);
   if(i<1 || v[i]!=1, return(0)); i--;
   1;
 }
 DpredSecondEight_by_each(n) = \
   for(i=0,7, if(!DpredSecond(n+i), return(0))); 1;

gp_inline__location="../alternate.tex:19384";
 EncEight_formula(k) = {
   2/3*2^(k-6)
   - vector_modulo([1, 0],k)*2^floor((k-6)/2)
   + vector_modulo([1/3, -1/3],k);
 }
 EncEight(k) = if(k<=3,0, EncEight_formula(k));

gp_inline__location="../alternate.tex:19393";
 EncEight_by_sum(k) = {
   sum(l=0,k\2,               \\ low base-4 3s
     sum(m=0,k\2,             \\ middle base-4 2or3
       my(h=k-2*(m+l+4));     \\ high bits
       if(h==-1, 2^m,         \\ top base-4 1 can be high bit
          h>=0, 2^m * 2^h)));
 }

gp_inline__location="../alternate.tex:19415";
 EncEight_product(k) = \
   1/3*(2^floor((k-5)/2) - 1)*(2^ceil((k-5)/2) - (-1)^k);

gp_inline__location="../alternate.tex:19423";
 EncEight_samples = {[0,0,0,0,0,0,0,1,1,5,7,21,35,85,155]};

gp_inline__location="../alternate.tex:19444";
 vector_bool_and_following(v) = vector(#v,i,v[i]&&i<#v&&v[i+1]);

gp_inline__location="../alternate.tex:19463";
 A097038(n) = {
   n>=0 || error("A097038() is for n>=0");
   2*2^n/3 + (-1)^n/3 - 2^(n/2)*(1+(-1)^n)/2;
 }

gp_inline__location="../alternate.tex:19475";
 A052551(n) = 2*2^floor(n/2) - 1;

gp_inline__location="../alternate.tex:19480";
 A086341(n) = 2*2^floor(n/2) - (-1)^n;

gp_inline__location="../alternate.tex:19504";
 Manhattan(z) = abs(real(z)) + abs(imag(z));
 Leading(z) = abs(real(z)) - abs(imag(z));

gp_inline__location="../alternate.tex:19507";
 GRScumul(n)    = Manhattan(alternate_point(n+1));
 GRScumulAlt(n) = Leading  (alternate_point(n+1));

gp_inline__location="../alternate.tex:19527";
 GRScumul_samples = {[1,2,3,2,3,4,3,4,5,6]};

gp_inline__location="../alternate.tex:19540";
 A020986(n) = GRScumul(n);

gp_inline__location="../alternate.tex:19555";
 GRScumulAlt_samples = {[1,0,1,2,3,2,1,0,1,0]};

gp_inline__location="../alternate.tex:19568";
 A020990(n) = GRScumulAlt(n);

gp_inline__location="../alternate.tex:19806";
 GRScumul_s_list_by_search(s) = {
   my(l=List([]),n=0,cumul=0);
   while(#l<=s,
         if(cumul==s,listput(l,n));
         n++; cumul+=GRS(n));
   Vec(l);
 }

gp_inline__location="../alternate.tex:19869";
 GRScumulFirstN_by_search(s) = {
   s>=1 || error("GRScumulFirstN_by_search() is for s>=1");
   my(cumul=0);
   for(n=0,oo, cumul+=GRS(n); if(cumul==s,return(n)));
 }
 GRScumulFirstN_list_by_search(len) = {
   my(v=vector(len),n=0);
   while(!v[#v],
         my(s=GRScumul(n));
         if(s<=#v&&v[s]==0, v[s]=n);
         n++);
   v;
 }

gp_inline__location="../alternate.tex:19887";
 GRScumulFirstN_samples = {[0,1,2,5,8,9,10,21,32,33]};

gp_inline__location="../alternate.tex:19900";
 A212591(n) = {
   n>=1 || error();
   MfirstN(n) - 1;
 }

gp_inline__location="../alternate.tex:19909";
 GRScumulFirstN_base4_samples = {[0,1,2,11,20,21,22,111,200,201]};

gp_inline__location="../alternate.tex:19924";
 GRScumulLastN_by_search(s) = {
   my(cumul=0,visit=0);
   for(n=0,oo,
     cumul+=GRS(n);
     if(cumul==s,visit++;if(visit==s,return(n))));
 }

gp_inline__location="../alternate.tex:19934";
 GRScumulLastN_samples = {[0,3,6,15,26,27,30,63,106,107]};

gp_inline__location="../alternate.tex:19949";
 GRScumulLastN_base4_samples = {[0,3,12,33,122,123,132,333,1222,1223]};

gp_inline__location="../alternate.tex:19969";
 MfirstN_by_search(s) = \
   for(n=0,oo, if(Manhattan(alternate_point(n))==s,return(n)));
 MfirstN_list_by_search(len) = {
   my(v=vector(len),n=0);
   while(!v[#v],
         my(s=Manhattan(alternate_point(n)));
         s++; if(s<=#v&&v[s]==0, v[s]=n);
         n++);
   v;
 }

gp_inline__location="../alternate.tex:19981";
 MfirstN(s) = {
   if(s==0,return(0));
   my(n=0);
   Gnum(s\2)
   + if(s%2==0, -2/3*(4^(CountLowZeros(s)-1) - 1),
                1);
 }

gp_inline__location="../alternate.tex:20003";
 MfirstN_samples = {[0,1,2,3,6,9,10,11,22,33]};

gp_inline__location="../alternate.tex:20014";
 MfirstN_base4_samples = {[0,1,2,3,12,21,22,23,112,201]};

gp_inline__location="../alternate.tex:20028";
 Mvisits(s) = if(s==0,1, s);

gp_inline__location="../alternate.tex:20030";
 MlastN_by_search(s) = {
   my(visit=0,target=Mvisits(s));
   for(n=0,oo,
         if(Manhattan(alternate_point(n))==s,
            visit++;
            if(visit==target,return(n))));
 }

gp_inline__location="../alternate.tex:20049";
 MlastN_samples = {[0,1,4,7,16,27,28,31,64,107]};

gp_inline__location="../alternate.tex:20056";
 MlastN_base4_samples = {[0,1,10,13,100,123,130,133,1000,1223]};

gp_inline__location="../alternate.tex:20105";
 MfirstN_by_digits(s) = {
   if(s==0,return(0));
   my(v=binary(floor(s/2)),i=#v);
   if(s%2==0,
      while(i>=1, if(v[i],i--;break()); v[i]=1; i--));
   while(i>=1, if(v[i],v[i]=2); i--);
   1 + fromdigits(v,4);
 }

gp_inline__location="../alternate.tex:20127";
 MfirstN_by_digits2(s) = {
   if(s==0,return(0));
   my(v=binary(s));
   my(low=v[#v]); v=v[^#v];
   v*=2;  \\ digits 0,2
   if(low==0,     \\ low 1000 becomes 112
      forstep(i=#v,1,-1, if(v[i],v[i]=1;break()); v[i]=1);
      fromdigits(v,4)+1;
      ,
      fromdigits(v,4)+1;
      );
 }

gp_inline__location="../alternate.tex:20143";
 A212591_compact(n) = {
   my(v=2*binary(n\2));
   if(n%2==0, for(j=#v-valuation(n,2)+1,#v, v[j]=1));
   fromdigits(v,4);
 }

gp_inline__location="../alternate.tex:20166";
 MfirstN_by_Xnum(s) = {
   if(s==0,return(0));
   Xnum(floor((s-1)/2)) + Xnum(ceil((s-1)/2)) + 1;
 }

gp_inline__location="../alternate.tex:20177";
   \\ Xnum(s\2) + Xnum(s\2-1+(s%2)) + 1;

gp_inline__location="../alternate.tex:20261";
 MfirstN_2k_samples = {[1,2,6,22,86,342,1366,5462]};

gp_inline__location="../alternate.tex:20358";
 MfirstZ(s) = alternate_point(MfirstN(s));

gp_inline__location="../alternate.tex:20386";
 MfirstZ_samples = {[0,1,1+I,2+I,3+I,3+2*I,3+3*I,4+3*I,7+I]};

gp_inline__location="../alternate.tex:20672";
 z_turn(z) = {
   forstep(s=-1,1,2,
           my(an=alternate_unpoint(z,s));
           if(an[1]==0,return(turn(an[2]))));
   error();
 }

gp_inline__location="../alternate.tex:20696";
 MfirstZ_path_length_Manhattan(s_limit) = \
   sum(s=1,s_limit, Manhattan(MfirstZ(s) - MfirstZ(s-1)));

gp_inline__location="../alternate.tex:20710";
 GRScumulFirstN(s) = {
   s>=1 || error("GRScumulFirstN() is for s>=1");
   MfirstN(s) - 1;
 }

gp_inline__location="../alternate.tex:20725";
 A020988(n) = (2/3)*(4^n-1);

gp_inline__location="../alternate.tex:20742";
 \\ Return the n which is the first visit to x-y == d.
 LfirstN_by_search(d) = {
   for(n=0,oo,
     my(z=alternate_point(n));
     if(real(z)-imag(z)==d,return(n)));
 }

gp_inline__location="../alternate.tex:20843";
 MlastN_k(s) = logint(s,2);
 MlastN(s) = {
   if(s==0,return(0));
   my(k=MlastN_k(s));
   2^(2*k+1) - Xnum(2^(k+1) - s);
 }

gp_inline__location="../alternate.tex:20867";
 MlastN_by_digits(s) = {
   my(v=binary(s-1));
   for(i=if(is_power_of_2(s),1,2),#v, v[i]=if(v[i]==0,2,3));
   1 + fromdigits(v,4);
 }

gp_inline__location="../alternate.tex:21050";
 GRScumulLastN_r(s) = logint(s,2);
 GRScumulLastN(s) = {
   s>=1 || error("GRScumulLastN() is for s>=1, got s=",s);
   my(r=GRScumulLastN_r(s));
   s - 1
   + 2/3*(4^r - 1)
   + 2*sum(j=0,r-1, floor((s-1)/2^(j+1)) * 4^j);
 }

gp_inline__location="../alternate.tex:21066";
 GRScumulLastN_by_base_change(n) = {
   n>=1 || error("GRScumulLastN_by_base_change() is for n>=1, got s=",s);
   my(v=binary(n-1));
   for(i=1,#v,
         if(i==1, if(is_power_of_2(n),v[i]=3),
            v[i]+=2));
   fromdigits(v,4);
 }

gp_inline__location="../alternate.tex:21079";
 A020991(n) = GRScumulLastN(n);

gp_inline__location="../alternate.tex:21083";
 A020991_by_base_change(n) = {
   n>=1 || error();
   my(v=apply(d->d+2,digits(n-1,2)));
   if(n>1&&#v!=valuation(n,2),v[1]=1);
   fromdigits(v,4);
 }

gp_inline__location="../alternate.tex:21092";
 A020991_by_base_change2(n) = {
   n>=1 || error();
   my(v=digits(n-1,2)); for(i=1,#v, if((v[i]+=2)!=3, v[1]=1)); fromdigits(v,4);
 }

gp_inline__location="../alternate.tex:21121";
 binary_to_base4_01_by_sum(t) = {
   t>=1 || error();
   my(r=0); while(!(2^r <= t && t <= 2^(r+1)-1 && r>=0), r++);
   t + 2*sum(j=0,r-1, floor(t/2^(j+1))*4^j);
 }

gp_inline__location="../alternate.tex:21147";
 \\ return [k,r] where n == 2^k + r and 0<=r<2^k,
 \\ so the high bit of n as an exponent, and remainder r
 high_bit_k_and_remainder(n) = {
   if(n==0,error());
   my(v=binary(n));
   [#v-1, fromdigits(v[^1],2)];
 }

gp_inline__location="../alternate.tex:21167";
 MlastZ(s) = {
   s>=0 || error("MlastZ() is for s>=0");
   alternate_point(MlastN(s));
 }

gp_inline__location="../alternate.tex:21181";
 MlastZ_samples = {[0,1,2,2+I,4,4+I,4+2*I,4+3*I,8]};

gp_inline__location="../alternate.tex:21203";
 A053644(n) = {
   n>=0 || error("A053644() is for n>=0");
   if(n==0,0, highbit(n));
 }

gp_inline__location="../alternate.tex:21210";
 A053645(n) = {
   n>=1 || error("A053645() is for n>=1");
   n - highbit(n);
 }

gp_inline__location="../alternate.tex:21320";
 Leading_MlastZ_samples = {[0,1,2,1,4,3,2,1,8,7,6,5,4,3,2,1,16]};

gp_inline__location="../alternate.tex:21330";
 A080079(n) = 2<<logint(n,2) - n;

gp_inline__location="../alternate.tex:21369";
 VfirstN_by_search(x) = \
   for(n=0,oo, if(real(alternate_point(n))==x,return(n)));
 VfirstN_list_by_search(len) = {
   my(v=vector(len),n=0);
   while(!v[#v],
         my(x=real(alternate_point(n)));
         x++; if(x<=#v&&v[x]==0, v[x]=n); n++);
   v;
 }

gp_inline__location="../alternate.tex:21381";
 VfirstN_by_Gnum(x) = {
   if(x==0,return(0));
   Gnum(floor((x-1)/2)) + Gnum(ceil((x-1)/2)) + 1;
 }

gp_inline__location="../alternate.tex:21400";
 VfirstN_samples = {[0,1,3,5,11,17,19,21,43,65]};

gp_inline__location="../alternate.tex:21417";
 \\ number of visits to vertical column x
 Vvisits(x) = if(x==0,1, 2*x);

gp_inline__location="../alternate.tex:21426";
 VlastN_by_search(x) = {
   my(visit=0,target=Vvisits(x));
   for(n=0,oo,
     if(real(alternate_point(n))==x,
        visit++;
        if(visit==target,return(n))));
 }

gp_inline__location="../alternate.tex:21438";
 VlastN_samples = {[0,2,8,14,32,54,56,62,128,214]};

gp_inline__location="../alternate.tex:21468";
 M_list_by_search(s) = {
   my(v=alternate_points(2*#binary(s)),l=List([]));
   for(i=1,#v,
       if(Manhattan(v[i])==s,listput(l,i-1)));
   Vec(l);
 }

gp_inline__location="../alternate.tex:21477";
 lex_n_point_Leading(n1,n2) = \
   lex(Leading(alternate_point(n1)),Leading(alternate_point(n2)));

gp_inline__location="../alternate.tex:21503";
 \\ n which has minimum s=GRScumul(n) in range M(k) <= n < M(k+1)
 Brillhart_Morton_m(k) = 1/3*(5*4^k-2);

gp_inline__location="../alternate.tex:21513";
 Brillhart_Morton_m_samples = {[1,6,26,106,426,1706,6826]};

gp_inline__location="../alternate.tex:21789";
 GRScumulRatio_inexact(n) = GRScumul(n)/sqrt(n);
 GRScumulRatio_squared(n) = GRScumul(n)^2/n;

gp_inline__location="../alternate.tex:22144";
 \\ n which has maximum s=GRScumul(n) in range 4^k <= n < 4^(k+1)
 Brillhart_Morton_M(k) = 2/3*(4^(k+1) - 1);

gp_inline__location="../alternate.tex:23004";
 GRScumul_ratio_squared_of_s(s) = (2*s)^2/(Gnum(s)-1);

gp_inline__location="../alternate.tex:23050";
 GRS_ratio_frac_step(s) = \
  GRScumul_ratio_squared_of_s(s+1) - GRScumul_ratio_squared_of_s(s);

gp_inline__location="../alternate.tex:23125";
 GRScumul_ratio_s_to_k(s) = {
   s>=1 || error("GRScumul_ratio_s_to_k() is for s>=1");
   logint(s,2);
 }

gp_inline__location="../alternate.tex:23139";
 GRScumul_ratio_s_is_increase(s) = \
   CountLowOnes(s) <= ceil(GRScumul_ratio_s_to_k(s)/2);

gp_inline__location="../alternate.tex:23142";
 GRScumul_ratio_s_is_increase_by_compare(s) = \
   GRS_ratio_frac_step(s) > 0;

gp_inline__location="../alternate.tex:23158";
 GRScumul_ratio_s_is_decrease(s) = \
   CountLowOnes(s) > ceil(GRScumul_ratio_s_to_k(s)/2);

gp_inline__location="../alternate.tex:23161";
 GRScumul_ratio_s_is_decrease_by_compare(s) = \
   GRScumul_ratio_squared_of_s(s+1) <GRScumul_ratio_squared_of_s(s);

gp_inline__location="../alternate.tex:23177";
 GRScumul_ratio_decrease_at_s_samples = {[1,3,7,15,23,31,47,63,79,95,111,127,159]};

gp_inline__location="../alternate.tex:23189";
 GRScumul_ratio_decrease_at_s_binary_samples = {[1,11,111,1111,10111,11111,101111,111111,1001111]};

gp_inline__location="../alternate.tex:23229";
 A112714_pred(n) = {
   n++;
   my(m=CountLowZeros(n),k=n/2^m);
   k%2 || error();
   k<2^m;
 }

gp_inline__location="../alternate.tex:23256";
 dGnum(s) = 1/3*(4^(CountLowOnes(s)+1) + 2);

gp_inline__location="../alternate.tex:23269";
 dGnum_samples = {[2,6,2,22,2,6,2,86,2,6,2,22]};

gp_inline__location="../alternate.tex:23282";
 A276391(n) = {
   n>=1 || error("A276391() is for n>=1");
   (2<<(2*valuation(n,2)) + 1)/3;
 }

gp_inline__location="../alternate.tex:23316";
 gA276391(x,k_limit) = \
   sum(k=0,k_limit, 4^k*x^(2^k)/(1+x^(2^k)));

gp_inline__location="../alternate.tex:23431";
 GRS_ratio_step_first_term(s)  = (8*s+4) * (Gnum(s) - 1);
 GRS_ratio_step_second_term(s) = 4*s^2*dGnum(s);
 GRS_ratio_step(s) = \
   GRS_ratio_step_first_term(s) - GRS_ratio_step_second_term(s);

gp_inline__location="../alternate.tex:23594";
 GRS_ratio_step_reduced(s) = {
   my(k=GRScumul_ratio_s_to_k(s),l=CountLowOnes(s));
   (8*s+4) * (1/3*s*2^(k+2) + 1/3*2^(k+1) - 1)
   - 4*s^2*1/3*(2^(2*l+2) + 2);
 }

gp_inline__location="../alternate.tex:23655";
 GRS_ratio_step_reduced2(s) = {
   my(k=GRScumul_ratio_s_to_k(s),l=CountLowOnes(s));
   4/3*(  s^2*( 2^(k+3) - 2^(2*l+2) )
                + (4*s+1)*2^(k+1)
                - (2*s+4)*2^(k+1) + 1 );
 }

gp_inline__location="../alternate.tex:23768";
 GRS_ratio_step_increased(s) = {
   my(k=GRScumul_ratio_s_to_k(s),l=CountLowOnes(s));
   (8*s+4)*(s*2^(k+1) - 1) - 4*s^2*1/3*(2^(2*l+2) + 2);
 }

gp_inline__location="../alternate.tex:23912";
 gen_GRS_ratio_diagonal_steps_s_decrease = [63,79,95,111];

gp_inline__location="../alternate.tex:23975";
 BEM_lambda_k(x,k) = GRScumul   (floor(4^k*x)) / sqrt(4^k*x);
 BEM_mu_k(x,k)     = GRScumulAlt(floor(4^k*x)) / sqrt(4^k*x);

gp_inline__location="../alternate.tex:23981";
 BEM_lambda_f(f) = \
   1/geom_sqrt_as_quad(f) * Manhattan(alternate_fpoint(f));
 BEM_mu_f(f) = \
   1/geom_sqrt_as_quad(f) * Leading(alternate_fpoint(f));

gp_inline__location="../alternate.tex:23988";
 BEM_rho(d) = d%=4; if(d==0,1, d==2,-1, 0);
 BEM_a(x,k) = \
   sum(r=1,k, BEM_rho(floor(4^r*x)) * GRS(floor(4^r*x)) / 2^r);
 BEM_a_vector(x,k) = \
   vector(k,r, BEM_rho(floor(4^r*x)) * GRS(floor(4^r*x)));

gp_inline__location="../alternate.tex:24014";
 \\ if n=2^r-1 then return r, if not then return symbol 'none
 which_power_of_2_sub_1(n) = \
   if(n>=1 && is_power_of_2(n+1), 1+logint(n,2), 'none);

gp_inline__location="../alternate.tex:24138";
 BM_theta(v) = 1 - 2^-v;

gp_inline__location="../alternate.tex:24217";
 dGRScumulLastN(s) = {
   s>=1 || error("dGRScumulLastN() is for s>=1");
   GRScumulLastN(s+1) - GRScumulLastN(s);
 }

gp_inline__location="../alternate.tex:24239";
 A022156_compact(n) = {
   n++; my(k=logint(n,2));
   if(hammingweight(n)==k+1, 2*4^k + 1, (2*4^valuation(n,2) + 1)/3);
 }

gp_inline__location="../alternate.tex:24268";
 alternate_midpoint(n) = \
   1/2*(alternate_point(n) + alternate_point(n+1));

gp_inline__location="../alternate.tex:24488";
 MidTurn(n) = my(t=turn(n)); if(turn(n+1) == t, t, 0);

gp_inline__location="../alternate.tex:24495";
 MidTurn_by_two_turn(n) = 1/2*(turn(n) + turn(n+1));

gp_inline__location="../alternate.tex:24499";
 MidTurn_samples = {[0,-1,0,1,1,0,-1,0,0,-1,-1,0,1,0,0,1]};

gp_inline__location="../alternate.tex:24513";
 gMidTurn(x,num_terms) = 1/2*gsturn(x,num_terms);

gp_inline__location="../alternate.tex:24533";
 MidDir_by_turns(n) = sum(i=1,n, MidTurn(i));
 MidDir_vector_by_turns(len) = \
   vector_cumulative(concat(0,vector(len-1,n,MidTurn(n))));

gp_inline__location="../alternate.tex:24541";
 MidDir_samples = {[0,0,-1,-1,0,1,1,0,0,0,-1,-2,-2,-1,-1,-1,0,0]};

gp_inline__location="../alternate.tex:24554";
 gMidDir(x,num_terms) = 1/(1-x) * gMidTurn(x,num_terms);

gp_inline__location="../alternate.tex:24733";
 \\ from alternate-nauty.c
 DiameterCount_generated_samples = \
   [1,1,1,2,4,2,264,2,5348880,2,7629973004184608,2];

gp_inline__location="../alternate.tex:24750";
 Diameter_formula(k) = \
   2*2^floor(k/2) + vector_modulo([-1,1],k);
 Diameter(k) = if(k<=2,2^k, Diameter_formula(k));

gp_inline__location="../alternate.tex:24758";
 Diameter_samples = {[1,2,4,5,7,9,15,17,31,33]};

gp_inline__location="../alternate.tex:24778";
 A016116(n) = 2^floor(n/2);

gp_inline__location="../alternate.tex:24880";
 \\ Catalan number, sum of Catalan triangle column n
 catalan(n) = binomial(2*n,n)/(n+1);

gp_inline__location="../alternate.tex:24884";
 Catalan_samples = {[1,1,2,5,14,42,132]};

gp_inline__location="../alternate.tex:24919";
 DiameterCount_formula(k) = {
   my(h=2^(k/2));
   2/(h-1) * binomial(2*h-4,h-2);
 }
 DiameterCount(k) = {
   if(k<=2, 1,
      k%2==1, 2,
      DiameterCount_formula(k));
 }

gp_inline__location="../alternate.tex:24931";
 DiameterCount_samples = {[1,1,1,2,4,2,264,2,5348880]};

gp_inline__location="../alternate.tex:24955";
 W_generated_samples=[1,4,20,65,272,1022,4768,20780,106560,513816];

gp_inline__location="../alternate.tex:24957";
 WpathTerm_by_sum(n,i) = sum(j=0,n-1, abs(i-j));
 Wpath_by_sum(n) = 1/2*sum(i=0,n-1, WpathTerm_by_sum(n,i));

gp_inline__location="../alternate.tex:24960";
 WpathTerm(n,i) = {
   (i>=0 && i<=n-1)
     || error("WpathTerm i=",i," out of range max ",n-1);
   1/2*( (i+1)*i + (n-i)*(n-1-i) );
 }

gp_inline__location="../alternate.tex:24968";
 \\ Wiener index of path of n vertices.
 Wpath(n) = 1/6*(n-1)*n*(n+1);  \\ tetrahedral numbers

gp_inline__location="../alternate.tex:24980";
 \\ Wiener index of star of n vertices (n-1 leaves, 1 centre).
 Wstar(n) = (n-1)^2;

gp_inline__location="../alternate.tex:25018";
 W_factor_4_2floor = {[(1)/(15),(11)/(120)]};

gp_inline__location="../alternate.tex:25025";
 W_factor_4 = {[1/2,(11)/(24)]};

gp_inline__location="../alternate.tex:25032";
 W_factor_2_2floor = {[5/6,1]};

gp_inline__location="../alternate.tex:25039";
 W_factor_2 = {[2,(25)/(12)]};

gp_inline__location="../alternate.tex:25044";
 W_factor_2floor = {[(12)/(5),(131)/(30)]};

gp_inline__location="../alternate.tex:25048";
 W(k) = {
     vector_modulo(W_factor_4_2floor,k) * 4^k * 2^floor(k/2)
   + vector_modulo(W_factor_4       ,k) * 4^k
   + vector_modulo(W_factor_2_2floor,k) * 2^k * 2^floor(k/2)
   + vector_modulo(W_factor_2       ,k) * 2^k
   - vector_modulo(W_factor_2floor  ,k) *       2^floor(k/2);
 }

gp_inline__location="../alternate.tex:25057";
 W_samples = {[1,4,20,65,272,1022,4768,20780]};

gp_inline__location="../alternate.tex:25122";
 WtriangleTerm_by_sum(n,x,y) = \
   sum(x2=1,n, sum(y2=1,x2, abs(x-x2)+abs(y-y2)));
 Wtriangle_by_sum(n) = \
   1/2 * sum(x=1,n, sum(y=1,x, WtriangleTerm_by_sum(n,x,y)));

gp_inline__location="../alternate.tex:25144";
 T(n) = 1/2*n*(n+1);

gp_inline__location="../alternate.tex:25147";
 T_samples = {[0,1,3,6,10,15,21]};

gp_inline__location="../alternate.tex:25174";
 Wtriangle(n) =  1/30 * (n-1) * n * (n+1) * (n+2) * (2*n+1);

gp_inline__location="../alternate.tex:25180";
 Wtriangle_samples = {[0,0,4,28,108,308,728,1512]};

gp_inline__location="../alternate.tex:25220";
 WtriangleTop(n) =  1/2 * (n-1) * n * (n+1);

gp_inline__location="../alternate.tex:25225";
 WtriangleTop_samples = {[0,0,3,12,30,60,105,168]};

gp_inline__location="../alternate.tex:25250";
 Wextra_by_sum(n) = sum(x=0,n-2, sum(x2=x+2-(x%2),n-1, 2));

gp_inline__location="../alternate.tex:25253";
 Wextra(n) = (n-1)^2 - vector_modulo([1,0],n);

gp_inline__location="../alternate.tex:25259";
 Wextra_samples = {[0,0,0,4,8,16,24,36]};

gp_inline__location="../alternate.tex:25290";
 Weven(n) = 1/30 * (n-1) * (2*n^4 + 7*n^3 - 8*n^2 + 47*n - 120);

gp_inline__location="../alternate.tex:25303";
 Weven_samples = {[0,1,20,90,272,663,1404]};

gp_inline__location="../alternate.tex:25316";
 WpyramidTerm_by_sum(n,x,y) = {
   sum(y2=0,n-1, sum(x2=y2-(n-1),(n-1)-y2,
       \\ print(x","y" to "x2","y2" = "abs(x-x2)+abs(y-y2));
       abs(x-x2)+abs(y-y2)));
 }
 Wpyramid_by_sum(n) = {
   1/2 * sum(y=0,n-1, sum(x=y-(n-1),(n-1)-y,
             WpyramidTerm_by_sum(n,x,y)));
 }

gp_inline__location="../alternate.tex:25401";
 Wpyramid(n) = 1/30 * (n-1) * n * (n+1) * (11*n^2 + 1);

gp_inline__location="../alternate.tex:25409";
 Wpyramid_samples = {[0,0,9,80,354,1104,2779,6048]};

gp_inline__location="../alternate.tex:25443";
 WpyramidEnd(n) =  1/6 * (n-1) * n * (8*n - 1);

gp_inline__location="../alternate.tex:25453";
 WpyramidEnd_samples = {[0,0,5,23,62,130,235,385]};

gp_inline__location="../alternate.tex:25478";
 Wodd(n) = 1/30 * (n-1) * (11*n^4 + 11*n^3 - 39*n^2 + 126*n - 240);

gp_inline__location="../alternate.tex:25492";
 Wodd_samples = {[0,4,65,316,1022,2624,5783]};

gp_inline__location="../alternate.tex:25510";
 W_by_odd_even(k) = \
   if(k%2==0, Weven(2^floor(k/2)+1), Wodd(2^floor(k/2)+1));

gp_inline__location="../alternate.tex:25517";
 W_sep(k) = {
   if(k%2==0,
       1/15 * 4^k * 2^floor(k/2)
     + 1/2  * 4^k
     + 5/6  * 2^k * 2^floor(k/2)
     + 2    * 2^k
     - 12/5 * 2^floor(k/2)
   ,
       11/120 * 4^k * 2^floor(k/2)
     + 11/24  * 4^k
     +          2^k * 2^floor(k/2)
     + 25/12  * 2^k
     - 131/30 *       2^floor(k/2)
   );
 }

gp_inline__location="../alternate.tex:25543";
 Pairs(k) = binomial(P(k), 2);
 Pairs_samples = {[1,3,10,28,91,276,946]};

gp_inline__location="../alternate.tex:25557";
 W_mean_samples = {[1,4/3,2,(65)/(28),(272)/(91),(511)/(138)]};

gp_inline__location="../alternate.tex:25582";
 mean_path_length_even = {(4)/(15)};

gp_inline__location="../alternate.tex:25588";
 mean_path_length_even_decimal = {(2666/10000)};

gp_inline__location="../alternate.tex:25604";
 mean_path_length_odd = {(11)/(30)};

gp_inline__location="../alternate.tex:25609";
 mean_path_length_odd_decimal = {(3666/10000)};

gp_inline__location="../alternate.tex:25626";
 TriangleVertices(n) = (n+1)*(n+2)/2;

gp_inline__location="../alternate.tex:25630";
 \\ tri-triangular numbers
 TrianglePairs(n) = 1/8 * n * (n+1) * (n+2) * (n+3);

gp_inline__location="../alternate.tex:25637";
 TriangleDiameter(n) = 2*n;

gp_inline__location="../alternate.tex:25651";
 PyramidVertices(n) = (n+1)*(n+1);

gp_inline__location="../alternate.tex:25656";
 PyramidPairs(n) = 1/2 * n * (n+1)^2 * (n+2);

gp_inline__location="../alternate.tex:25662";
 PyramidDiameter(n) = 2*n;

gp_inline__location="../alternate.tex:25677";
 Triangle_geometric_line_mean = \
   1/30 * (2 + 4*sqrt(2) + (4+sqrt(2))*log(1+sqrt(2)));

gp_inline__location="../alternate.tex:25689";
 Triangle_z_to_t(z) = imag(z)*(imag(z)+1)/2 + real(z);

gp_inline__location="../alternate.tex:25697";
 Triangle_t_to_z(t) = {
   my(y=(sqrtint(8*t+1)-1)\2);
   t-y*(y+1)/2 + y*I;
 }

gp_inline__location="../alternate.tex:25705";
 Triangle_random_unit__side = 10000;
 Triangle_random_unit__t_limit = Triangle_z_to_t(I*Triangle_random_unit__side);
 Triangle_random_unit() = {
   Triangle_t_to_z(random(Triangle_random_unit__t_limit))
     / Triangle_random_unit__side;
 }

gp_inline__location="../alternate.tex:25720";
 Square_geometric_line_mean = \
   1/15 * (sqrt(2) + 2 + 5*log(1+sqrt(2)));

gp_inline__location="../alternate.tex:25737";
 random_on_square_3_sides() = {
   my(s=random(3),t=random(1.0));
   if(s==0,t, s==1,1+t*I, t+I);
 }

gp_inline__location="../alternate.tex:25746";
 WsquareTerm(n,x,y) = \
   sum(x2=0,n, sum(y2=0,n, abs(x-x2)+abs(y-y2)));
 Wsquare_by_sum(n) = \
   1/2 * sum(x=0,n, sum(y=0,n, WsquareTerm(n,x,y)));

gp_inline__location="../alternate.tex:25754";
 Wsquare(n) = n*(n+1)^3*(n+2)/3;

gp_inline__location="../alternate.tex:25760";
 \\ total path lengths at corner 0,0
 WsquareTerm00(n) = n*(n+1)^2;

gp_inline__location="../alternate.tex:25767";
 \\ total path lengths at middle
 WsquareTermMid_by_mods(n) = {
   1/2*( n^3 + 3*n^2 + vector_modulo([2,3],n)*n
                     + vector_modulo([0,1],n)  );
 }
 WsquareTermMid(n) = if(n%2==0, n*(n+1)*(n+2)/2, (n+1)^3/2 );

gp_inline__location="../alternate.tex:25780";
 WsquareVertices(n) = (n+1)*(n+1);  \\ same as pyramid

gp_inline__location="../alternate.tex:25784";
 WsquarePairs(n) = binomial(WsquareVertices(n), 2);

gp_inline__location="../alternate.tex:25788";
 SquareDiameter(n) = 2*n;

gp_inline__location="../alternate.tex:25801";
 WV_even_iterate(n,f) = {
   for(x=0,n,
       my(v=concat(vector(x+(x!=n),y,y--; y),
                     if(x==n,[],
                        vector(max(0,x-1),y, y))));
   \\ print(v);
   for(i=1,#v,
       my(y=v[i]);
       f(x,y)));
 }
 alternate_points_by_WV_even(k) = {
   alternate_points_by_WV_even__list=List([]);
   WV_even_iterate(2^k,
     (x,y)->listput(alternate_points_by_WV_even__list,x+I*y));
   my(v=Vec(alternate_points_by_WV_even__list));
   kill(alternate_points_by_WV_even__list);
   v;
 }

gp_inline__location="../alternate.tex:25826";
 WV_even_by_iterate(n) = {
   WV_even_by_iterate__total_x=0;
   WV_even_by_iterate__total_y=0;
   WV_even_iterate(n,
     (x1,y1)->WV_even_iterate(n,
     (x2,y2)->WV_even_by_iterate__total_x+=abs(x1-x2);
              WV_even_by_iterate__total_y+=abs(y1-y2)));
   1/2*(WV_even_by_iterate__total_x +
        WV_even_by_iterate__total_y*I);
 }

gp_inline__location="../alternate.tex:25842";
 WV_even_by_poly(n) = {
   n/15 * ( (2*n^4 + 10*n^2 + 3)
          + (n-1)*(n+1)*(2*n^2+7) *I );
 }

gp_inline__location="../alternate.tex:25855";
 WV_odd_iterate(n,f) = {
   for(x=0,2*n-1,
       my(v=concat(vector(min(x,2*n-x)+1,y,y--; y),
                   vector(max(0,min(x,2*n-x)-1),y, y)));
   \\ print(v);
   for(i=1,#v,
       my(y=v[i]);
       f(x,y)));
 }
 alternate_points_by_WV_odd(n) = {
   alternate_points_by_WV_odd__list=List([]);
   WV_odd_iterate(n,
     (x,y)->listput(alternate_points_by_WV_odd__list,x+I*y));
   my(v=Vec(alternate_points_by_WV_odd__list));
   kill(alternate_points_by_WV_odd__list);
   v;
 }

gp_inline__location="../alternate.tex:25880";
 WV_odd_by_iterate(n) = {
   WV_odd_by_iterate__total_x=0;
   WV_odd_by_iterate__total_y=0;
   WV_odd_iterate(n,
     (x1,y1)->WV_odd_iterate(n,
     (x2,y2)->WV_odd_by_iterate__total_x+=abs(x1-x2);
              WV_odd_by_iterate__total_y+=abs(y1-y2)));
   1/2*(WV_odd_by_iterate__total_x +
        WV_odd_by_iterate__total_y*I);
 }

gp_inline__location="../alternate.tex:25896";
 WV_odd_by_poly(n) = {
   n * (14*n^4  + 20*n^2 - 4) / 15
   +
   n * ( 8*n^4  + 20*n^2 + 2) / 15 *I;
 }

gp_inline__location="../alternate.tex:25909";
 WV_by_poly(k) = {
   if(k%2==0, WV_even_by_poly(2^(k\2)),
              WV_odd_by_poly (2^(k\2)));
 }

gp_inline__location="../alternate.tex:25937";
 pairwise_ReImDiff(v) = \
   sum(i=1,#v, sum(j=i+1,#v, ReImDiff(v[i],v[j])));
 WV_by_sum(k) = pairwise_ReImDiff(alternate_points(k));

gp_inline__location="../alternate.tex:25950";
 ReImDiff(z1,z2) = abs(real(z1-z2)) + I*abs(imag(z1-z2));

gp_inline__location="../alternate.tex:25955";
 WV_multiply_4 = {[(2)/(15)+(2)/(15)*I,(7)/(30)+(2)/(15)*I]};

gp_inline__location="../alternate.tex:25963";
 WV_multiply_2 = {[2/3+1/3*I,2/3+2/3*I]};

gp_inline__location="../alternate.tex:25971";
 WV_constant = {[1/5-(7)/(15)*I,-(4)/(15)+(2)/(15)*I]};

gp_inline__location="../alternate.tex:25979";
 WV(k) = {
   my(n=2^floor(k/2));
   (  vector_modulo(WV_multiply_4,k)*4^k
    + vector_modulo(WV_multiply_2,k)*2^k
    + vector_modulo(WV_constant,k)
   ) * 2^floor(k/2);
 }

gp_inline__location="../alternate.tex:25991";
 WV_samples = {[1,2+2*I,10+6*I,40+28*I,180+156*I,1040+632*I]};

gp_inline__location="../alternate.tex:26052";
 WVpairs(k) = binomial(2^k+1,2);
 WVpairs_samples = {[1,3,10,36,136,528,2080]};

gp_inline__location="../alternate.tex:26072";
 WV_mean_even = {(4)/(15)+(4)/(15)*I};

gp_inline__location="../alternate.tex:26089";
 WV_mean_odd = {(7)/(15)+(4)/(15)*I};

gp_inline__location="../alternate.tex:26216";
 WV_even_top_sum(k) = {
   my(top=2^(k/2)*(1+I));
   - sum(n=0,2^k, Leading(top-alternate_point(n)));
 }

gp_inline__location="../alternate.tex:26224";
 WV_even_Leading_samples = {[1,4,24,176,1376,10944]};

gp_inline__location="../alternate.tex:26265";
 Tend(k) = End(k) + I*End(k);

gp_inline__location="../alternate.tex:26664";
 TSquare(n) = {
   my(x=n_even_bits(n),y=n_odd_bits(n));
   2*y-x + x*I;
 }

gp_inline__location="../alternate.tex:26674";
 TSquareCentre(n) = {
   my(x=n_even_bits(n),y=n_odd_bits(n));
   (I-1)*x + 2*y + 1/2+1/2*I;
 }

gp_inline__location="../alternate.tex:26685";
 TSquare_samples = {[0,-1+I,2,1+I,-2+2*I,-3+3*I,2*I,-1+3*I]};

gp_inline__location="../alternate.tex:26725";
 n_even_bits(n) = fromdigits(apply(d->d%2,digits(n,4)),2);

gp_inline__location="../alternate.tex:26728";
 n_even_bits_samples = {[0,1,0,1,2,3,2,3,0]};

gp_inline__location="../alternate.tex:26740";
 n_odd_bits(n)  = fromdigits(apply(d->d\2,digits(n,4)),2);

gp_inline__location="../alternate.tex:26743";
 n_odd_bits_samples = {[0,0,1,1,0,0,1,1,2]};

gp_inline__location="../alternate.tex:26759";
 ZOrder_n_to_z(n) = n_even_bits(n) + n_odd_bits(n)*I;

gp_inline__location="../alternate.tex:26768";
 TB(k) = {
   k>=0 || error("TB is for k>0, got ",k);
   2*B(k);
 }
 TB_samples = {[4,8,16,24,40,56,88]};

gp_inline__location="../alternate.tex:26788";
 TBQ(k) = {
   k>=0 || error("TBQ is for k>0, got ",k);
   2*BQ(k);
 }
 TBQ_samples = {[4,6,10,14,22,30,46]};

gp_inline__location="../alternate.tex:26814";
 TP(k) = {
   k>=0 || error("TP is for k>0, got ",k);
   (2^floor((k+1)/2) + 1) * (2^floor((k+2)/2) + 1) - 2;
 }
 TP_by_points(k) = \
   #Set(apply(alternate_point, [3*2^k .. 7*2^k]));

gp_inline__location="../alternate.tex:26830";
 TP_samples = {[4,7,13,23,43,79,151,287]};

gp_inline__location="../alternate.tex:26841";
 A183977(n) = 2^n + vector_modulo([3,4],n) * 2^floor(n/2) - 2;

gp_inline__location="../alternate.tex:26853";
 matsum(m) = vecsum(apply(vecsum,Vec(m)));

gp_inline__location="../alternate.tex:26857";
 A183977_is_good_matrix(m) = {
   my(rows,cols); [rows,cols]=matsize(m);
   if(rows<2 || cols<2, return(1));
   my(t=matsum(m[1..2,1..2]));
   for(i=2,rows,
     for(j=2,cols,
       if(matsum(m[i-1..i, j-1..j]) != t, return(0))));
   1;
 }

gp_inline__location="../alternate.tex:26871";
 A183977_by_search(n) = {
   n++;
   my(count=0);
   forvec(v=vector(n^2,i,[0,1]),
     my(m=matrix(n,n,i,j, v[i + n*(j-1)]));
     if(A183977_is_good_matrix(m), count++));
   count/4;
 }

gp_inline__location="../alternate.tex:26882";
 A183977_by_descent_recurse(m,n,t,i,j,show=0) = {
   my(count=0,
      next_i=i,
      next_j=j,
      last=0);
   if(next_j++>n, next_j=1; if(next_i++>n, last=1));
   for(a=0,1,
     m[i,j]=a;
     if(i<2 || j<2 || a + m[i-1,j] + m[i,j-1] + m[i-1,j-1] == t,
       if(last,
          if(show,
             my(prev=[]);
             for(i=1,n,
                 print(m[i,],if(prev==apply(e->1-e,m[i,])," opp",""));
                 prev=m[i,]);
             print());
          count++;
          ,
         count += A183977_by_descent_recurse(m,n,t, next_i,next_j, show))));
   count;
 }
 A183977_of_t_by_descent(n,t,show=0) = {
   A183977_by_descent_recurse(matrix(n,n),n,t, 1,1, show);
 }
 A183977_by_descent(n) = {
   sum(t=0,4,
     A183977_of_t_by_descent(n+1,t)) / 4;
 }

gp_inline__location="../alternate.tex:26943";
 TW_generated_samples = {[8,40,212,936,4420,21552,104616,552928,
   2789712]};
 Tdiameter_generated_samples = {[2,4,6,10,14,22,30,46,62]};
 Wpar_generated_samples = {[
   0,1,4,10,20,35,56;
   0,10,28,60,110,182,280;
   0,35,88,176,308,493,740;
   0,84,202,388,658,1028,1514;
   0,165,388,728,1208,1853,2688
 ]};
 \\ rows h>=3, columns w>=2
 TWpar_generated_samples = {[
   10,40,107,212,372,588,877,1240;
   35,114,261,484,807,1238,1801,2504;
   84,248,527,936,1508,2260,3225,4420;
   165,460,937,1618,2545,3746,5265,7130;
   286,768,1523,2580,3990,5792,8043,10784
 ]};

gp_inline__location="../alternate.tex:26963";
 \\ width w many columns in total
 \\ height h many rows
 parallelogram_mat(n,w) = {
   my(rows=n+1,cols=2*n+w+2,m=matrix(rows,cols));
   for(x=1,cols,
     for(y=1,rows,
       if(y>x, next());
       if(x-y>2*n+w-n+1, m[y,x]=0;next());
       if(x==1, m[y,x]=1; next());
       m[y,x] += m[y,x-1];
       if(y>1, m[y,x] += m[y-1,x]);
       ));
   m;
 }

gp_inline__location="../alternate.tex:26988";
 Tdiameter(k) = vector_modulo([4,3],k) * 2^ceil(k/2) - 2;

gp_inline__location="../alternate.tex:27001";
 Tdiameter_samples = {[2,4,6,10,14,22,30]};

gp_inline__location="../alternate.tex:27035";
 TdiameterCount_formula(k) = {
   my(h=TdiameterCount_h(k));
   if(k%2==0,
      4* binomial(4*h-4, h-2) * (4*h^2 + 4*h + 6) / (3*h) / (3*h-1),
      4* binomial(3*h-4, h-2) * (h^2 + h + 6) / (2*h) / (2*h-1));
 }
 TdiameterCount(k) = if(k==0,2, TdiameterCount_formula(k));

gp_inline__location="../alternate.tex:27049";
 TdiameterCount_h(k) = 2^ceil(k/2);

gp_inline__location="../alternate.tex:27054";
 TdiameterCount_samples = {[2,4,4,52,172,50388,802620]};

gp_inline__location="../alternate.tex:27256";
 \\ Catalan triangle
 cat(x,y) = {
   if(0<=y && y<=x,
      binomial(x+y, x) * (x-y+1)/(x+1),
      0);
 }

gp_inline__location="../alternate.tex:27284";
 Tdiameter_C(n,w) = \
   sum(y=0,n, my(u=n-y); cat(n+w,y)*cat(n,u));

gp_inline__location="../alternate.tex:27287";
 Tdiameter_C_by_mat(n,w) = {
   my(m=parallelogram_mat(n,w),s=matsize(m));
   if(s[1]&&s[2], m[s[1],s[2]], 0);
 }

gp_inline__location="../alternate.tex:27540";
 Tdiameter_C_poly(n,w) = \
   ((n+w+2)*(n+w+3) - 2*n ) / (2*n+w+2) / (2*n+w+3);
 Tdiameter_C_formula(n,w) = \
   binomial(3*n+w+1, n) * Tdiameter_C_poly(n,w);

gp_inline__location="../alternate.tex:27564";
 TdiameterCount_dims(k) = {
   my(h=TdiameterCount_h(k));
   if(k%2==0, [ h-2, h+1 ],
              [ h-2, 1 ]);
 }

gp_inline__location="../alternate.tex:27616";
 TdiameterCount_mat(k) = {
   my(n,w); [n,w]=TdiameterCount_dims(k);
   parallelogram_mat(n,w);
 }

gp_inline__location="../alternate.tex:27625";
 TdiameterCount_by_mat(k) = {
   if(k==0,return(2));
   my(n,w); [n,w]=TdiameterCount_dims(k);
   4 * Tdiameter_C_by_mat(n,w);
 }

gp_inline__location="../alternate.tex:27639";
 Tdiameter_C_even(h) = \
   binomial(4*h-4, h-2) * (4*h^2 + 4*h + 6) / (3*h-1) / (3*h);

gp_inline__location="../alternate.tex:27649";
 Tdiameter_C_odd(h) = \
   binomial(3*h-4, h-2) * (h^2 + h + 6) / (2*h-1) / (2*h);

gp_inline__location="../alternate.tex:27654";
 TdiameterCount_by_even_odd(k) = {
   my(h=TdiameterCount_h(k));
   4 * if(k%2==0, Tdiameter_C_even(h), Tdiameter_C_odd(h));
 }

gp_inline__location="../alternate.tex:27711";
 Tdiameter_C_w_neg_2_samples = {[1,8,55,364,2380]};

gp_inline__location="../alternate.tex:27744";
 \\ like Felix Frohlich in A039599
 A039599(n,k) = binomial(2*n, n+k) * (2*k+1) / (n+k+1);

gp_inline__location="../alternate.tex:27907";
 A013698(n) = binomial(3*n+2, n-1);

gp_inline__location="../alternate.tex:27941";
 A013698_by_sum(n) = {      \\ wrong
   sum(y1=1,n-1,
       sum(y2=1,n-y1,
           \\ print(y1" "y2);
           cat(n,y1) * cat(n,y2) ));
 }

gp_inline__location="../alternate.tex:28148";
 A143388(n) = (n^2 + 3*n + 6)*(3*n + 1)! / (n! * (2*n + 3)!);

gp_inline__location="../alternate.tex:28204";
 delt(n,d) = {
   sum(m=0,n-d,
       \\ print("m="m" d="d" p="n-m-d,
       \\      " prod ",cat(n,m),"*",cat(n,n-m-d));
       cat(n,m) * cat(n,n-m-d)
       );
 }

gp_inline__location="../alternate.tex:28362";
 WrectTerm_by_sum(w,h,x,y) = \
   sum(y2=0,h-1, sum(x2=0,w-1, abs(x-x2)+abs(y-y2)));
 Wrect_by_sum(w,h) = \
   1/2 * sum(y=0,h-1, sum(x=0,w-1, WrectTerm_by_sum(w,h,x,y)));

gp_inline__location="../alternate.tex:28376";
 Wrect(w,h) = 1/6 * w*h * (w+h) * (w*h - 1);

gp_inline__location="../alternate.tex:28394";
 TW_factor_4_2floor = {[(43)/(20),(16)/(5)]};

gp_inline__location="../alternate.tex:28401";
 TW_factor_4 = {8};

gp_inline__location="../alternate.tex:28407";
 TW_factor_2_2floor = {(1)/(12)};
 TW_vector_2_2floor = {[31,32]};

gp_inline__location="../alternate.tex:28419";
 TW_vector_2 = {[2,-2]};

gp_inline__location="../alternate.tex:28424";
 TW_factor_2floor = {(1)/(15)};
 TW_vector_2floor = {[101,92]};

gp_inline__location="../alternate.tex:28431";
 TW(k) = {
     vector_modulo(TW_factor_4_2floor,k) * 4^k * 2^floor(k/2)
   + TW_factor_4                         * 4^k
   + TW_factor_2_2floor
     * vector_modulo(TW_vector_2_2floor,k) * 2^k * 2^floor(k/2)
   + vector_modulo(TW_vector_2,k) * 2^k
   - TW_factor_2floor
     * vector_modulo(TW_vector_2floor,k) * 2^floor(k/2);
 }

gp_inline__location="../alternate.tex:28442";
 TW_samples = {[8,40,212,936,4420,21552,104616]};

gp_inline__location="../alternate.tex:28533";
 WparTerm_by_sum(w,h,x,y) = {
   if(w<=1,return(0));
   sum(y2=0,h-1, sum(x2=-y2,w-1-y2, abs(x-x2)+abs(y-y2)));
 }
 Wpar_by_sum(w,h) = \
   1/2 * sum(y=0,h-1, sum(x=-y,w-1-y, WparTerm_by_sum(w,h,x,y)));

gp_inline__location="../alternate.tex:28576";
 Wpar_by_columns(w,h) = {
   my(debug=0);
   if(w<=1,return(0));
   my(m=min(w,h),M=max(w,h));
       sum(y=1,h-1, y*w * (h-y)*w)
   + 2*sum(x=1,m-1,
           if(debug,print("left x="x" "T(x)));
           T(x) * (w*h - T(x)))
   +   sum(x=0,M-m-1,
           if(debug,print("middle x="x" T="T(m)" R="x*m));
           (T(m)+x*m) * (w*h - (T(m)+x*m)));
 }

gp_inline__location="../alternate.tex:28639";
 Wpar(w,h) = {
   my(m=min(w,h),M=max(w,h));
   if(w<=1, return(0));
   1/60 * (
     5*w*h*m*( 2*M*(M+h) + m^2 - 3 )
     - 10*w^2*h
     - (m-2)*(m-1)*m*(m+1)*(m+2)
   );
 }

gp_inline__location="../alternate.tex:28660";
 Wpar_row_h1_samples = {[0,1,4,10,20,35,56]};

gp_inline__location="../alternate.tex:28682";
 Wpar_row_h2_samples = {[0,10,28,60,110,182,280]};

gp_inline__location="../alternate.tex:28703";
 Wpar_row_h3_samples = {[0,35,88,176,308,493,740]};

gp_inline__location="../alternate.tex:28733";
 Wpar_by_columns2(w,h) = {
   if(w<=1,return(0));
   my(m=min(w,h),M=max(w,h));
     1/6*h*w^2*( h^2 - 1 )
   + 2*1/60*( 10*w*h*(m^3 - m) + -3*m^5 + 5*m^3 - 2*m )
   + (1/2*m*h - 1/3*m^2)*w^3 + (m*h^2 - 5/2*m^2*h + 3/2*m^3)*w^2 + (1/2*m*h^3 - 5/2*m^2*h^2 + 4*m^3*h + (-9/4*m^4 + 1/12*m^2))*w + (-1/3*m^2*h^3 + 3/2*m^3*h^2 + (-9/4*m^4 + 1/12*m^2)*h + (7/6*m^5 - 1/6*m^3));
 }

gp_inline__location="../alternate.tex:28770";
 WparEnd(w,h) = 1/2*w*h*(w + 2*h - 3);

gp_inline__location="../alternate.tex:28796";
 TWpar(w,h) = \
   Wpar(w,h) + 2*Wextra(w-1) - 2*WparEnd(w,h) + (w-1) + 2*(h-1);

gp_inline__location="../alternate.tex:28836";
 TWpar_dimensions(k) =[ 2^ceil((k+1)/2) + 1, 2^floor((k+1)/2) + 1 ];
 TW_by_TWpar(k) = my(v=TWpar_dimensions(k)); TWpar(v[1],v[2]);

gp_inline__location="../alternate.tex:28867";
 WparSquare(n) = 1/15*(n-1)*n*(n+1)*(6*n^2 + 1);

gp_inline__location="../alternate.tex:28873";
 WparSquareEnd(n) = 3/2*n^2*(n-1);

gp_inline__location="../alternate.tex:28914";
 WparWide(n) = 1/60*n*(n-1)*(129*n^3 - 36*n^2 - 31*n + 14);

gp_inline__location="../alternate.tex:28920";
 WparWideEnd(n) = 2*n*(n-1)*(2*n-1);

gp_inline__location="../alternate.tex:28967";
 Tpairs(k) = binomial(TP(k), 2);
 Tpairs_samples = {[6,21,78,253,903,3081]};

gp_inline__location="../alternate.tex:28985";
 TW_mean_samples = {[4/3,(40)/(21),(106)/(39),(936)/(253),(4420)/(903)]};

gp_inline__location="../alternate.tex:29012";
 Tmean_path_length_even = {(43)/(160)};

gp_inline__location="../alternate.tex:29021";
 Tmean_path_length_even_decimal = {(26875/100000)};

gp_inline__location="../alternate.tex:29033";
 Tmean_path_length_odd = {(4)/(15)};

gp_inline__location="../alternate.tex:29042";
 Tmean_path_length_odd_decimal = {(2666/10000)};

gp_inline__location="../alternate.tex:29340";
 TAVertexToZ_of_xy(x,y) = y-x + y*I;
 TAVertexToZ(n) = {
   my(x=n_even_bits(n),y=n_odd_bits(n));
   TAVertexToZ_of_xy(x,y);
 }

gp_inline__location="../alternate.tex:29365";
 TAendZ(k) = TAVertexToZ(2^k-1);

gp_inline__location="../alternate.tex:29371";
 TA_z_to_n(z) = {
   my(x=imag(z)-real(z), y=imag(z));
   if(x<0 || y<0, error("TA_z_to_n() z=",z," not in tree"));
   Xnum(x) + Gnum(y);
 }

gp_inline__location="../alternate.tex:29733";
 TA_complex_s(k) = 0;

gp_inline__location="../alternate.tex:29738";
 TA_complex_e(k) = 2^k - 1;

gp_inline__location="../alternate.tex:29744";
 TA_complex_a_formula(k) = 2^(k-1);
 TA_complex_a(k) = if(k==0,0, TA_complex_a_formula(k));

gp_inline__location="../alternate.tex:29760";
 TA_complex_c_formula(k) = 2^(k-1) - 1;
 TA_complex_c(k) = if(k==0,0, TA_complex_c_formula(k));

gp_inline__location="../alternate.tex:29852";
 mask_lowest_one_and_below(n) = bitxor(n,n-1);
 TAVertexToLower(n) = {
   my(mask = mask_lowest_one_and_below(n));
   if(bitand(n,mask+1) != 0,
      n - mask - 2,  /* l */
      -1);
 }

gp_inline__location="../alternate.tex:29892";
 mask_lowest_zero_and_below(n) = bitxor(n,n+1);
 TAVertexToUpper(n) = {
   my(mask = mask_lowest_zero_and_below(n));
   if(bitand(n,mask+1) == 0,
      n + mask + 2,  /* u */
      -1);
 }

gp_inline__location="../alternate.tex:29911";
 dragon_TurnRpred(n) = if(n>=1, BitAboveLowestOne(n));
 dragon_TurnLpred(n) = if(n>=1, 1-BitAboveLowestOne(n));
 A014577(n) = dragon_TurnLpred(n);

gp_inline__location="../alternate.tex:29919";
 A014707(n) = dragon_TurnRpred(n);

gp_inline__location="../alternate.tex:29926";
 TAVertexToRight(n) = if(n%2==1, bitxor(n,1), -1);
 TAVertexToLeft(n)  = if(n%2==0, bitxor(n,1), -1);

gp_inline__location="../alternate.tex:29929";
 \\ n is a twin alternate area tree vertex number.
 \\ Return a vector of the neighbours of that vertex.
 \\ Every vertex has 1 to 3 neighbours so the vector returned
 \\ has length 1 to 3.
 \\ The order of the vertices in the return is unspecified.
 TA_n_to_neighbours(n) = {
   my(l = List([bitxor(n,1)])); /* horizontal */
   my(n2 = TAVertexToUpper(n));
   if(n2>=0, listput(l,n2));
   n2 = TAVertexToLower(n);
   if(n2>=0, listput(l,n2));
   Vec(l);
 }

gp_inline__location="../alternate.tex:29980";
 TA_n_to_edge_by_xor(n, direction) = {
   my(transitions = bitxor(n, 2*n + direction));
   my(mask = bitxor(transitions, transitions-1));
   if(bitand(transitions, mask+1) == 0,
      bitxor(n, 2*mask+1),
      -1);
 }

gp_inline__location="../alternate.tex:29999";
 TAVertexToUpperPredInf(n) = BitAboveLowestZero(n)==0;

gp_inline__location="../alternate.tex:30004";
 TAVertexToUpperPredInf_samples = {[1,1,0,1,1,0,0,1,1,1,0]};

gp_inline__location="../alternate.tex:30020";
 TAVertexToLowerPred(n) = n>=1 && BitAboveLowestOne(n)==1;

gp_inline__location="../alternate.tex:30057";
 TADegCount0(k) = if(k==0,1, 0);

gp_inline__location="../alternate.tex:30068";
 TADegCount1_formula(k) = 2^(k-2);
 TADegCount1(k) = if(k==0,0, k<=2,2, TADegCount1_formula(k));

gp_inline__location="../alternate.tex:30078";
 TADegCount1_samples = {[0,2,2,2,4,8,16,32,64,128]};

gp_inline__location="../alternate.tex:30097";
 TADegCount2_formula(k) = 2^(k-1) + 2;
 TADegCount2(k) = if(k<=1,0, k==2,2, TADegCount2_formula(k));

gp_inline__location="../alternate.tex:30103";
 TADegCount2_samples = {[0,0,2,6,10,18,34,66,130,258]};

gp_inline__location="../alternate.tex:30122";
 TADegCount3_formula(k) = 2^(k-2) - 2;
 TADegCount3(k) = if(k<=2,0, TADegCount3_formula(k));

gp_inline__location="../alternate.tex:30128";
 TADegCount3_samples = {[0,0,0,0,2,6,14,30,62,126]};

gp_inline__location="../alternate.tex:30140";
 TADegCount_vector = \
   [TADegCount0, TADegCount1, TADegCount2, TADegCount3];
 TADegCount(k,d) = \
   if(d<#TADegCount_vector, TADegCount_vector[d+1](k), 0);

gp_inline__location="../alternate.tex:30193";
 TAVertexToLeftPred(k,n)  = k>=1 && (n&1)==0;
 TAVertexToRightPred(k,n) = k>=1 && (n&1)==1;
 TAVertexToUpperPred(k,n) = n=TAVertexToUpper(n); 0<=n&&n<2^k;

gp_inline__location="../alternate.tex:30197";
 TA_n_to_degree(k,n) = {
   if(n>=2^k, error("TA_n_to_degree() n=",n," bigger than 2^",k));
   TAVertexToLeftPred(k,n) + TAVertexToRightPred(k,n)
   + TAVertexToUpperPred(k,n) + TAVertexToLowerPred(n);
 }
 TADegCount_by_n(k,d) = {
   my(count=[0,0,0,0]);
   for(n=0,2^k-1, count[1 + TA_n_to_degree(k,n)]++);
   count[d+1];
 }

gp_inline__location="../alternate.tex:30242";
 TADegCount1_by_bits(k) = 2*2^(k-3);

gp_inline__location="../alternate.tex:30269";
 TADegCount2_by_bits(k) = 2*( 2^(k-3) + 2 + sum(h=0,k-4,2^h) );

gp_inline__location="../alternate.tex:30273";
 TA_n_is_degree2(k,n) = \
   TAVertexToLowerPred(n) != TAVertexToUpperPred(k,n);

gp_inline__location="../alternate.tex:30325";
 TADegCount_by_bit_patterns(k,d) = {
   my(limit=2^k-1);
   sum(n=0,limit,
       my(h=bitxor(n,1));
       my(u=TAVertexToUpper(n));
       d==(  (0<=h&&h<=limit)
           + (0<=u&&u<=limit)
           + (TAVertexToLower(n)>=0)));
 }

gp_inline__location="../alternate.tex:30367";
 TAEdgeCount_by_degrees(k) = 1/2*sum(d=0,3, d*TADegCount(k,d));

gp_inline__location="../alternate.tex:30387";
 TADegree(k,n) = {
   if(n>=2^k, error("TADegree() n=",n," bigger than 2^",k));
   if(k>=1, 1)
   + TAVertexToLowerPred(n)
   + TAVertexToUpperPred(k,n);
 }

gp_inline__location="../alternate.tex:30422";
 TADegreeInf(n) = {
   if(n==0, return(2));
   2 - BitAboveLowestZero(n) + BitAboveLowestOne(n);
 }
 TA_n_to_degree_infinite(n) =
   TA_n_to_degree(length(binary(n))+3, n);

gp_inline__location="../alternate.tex:30436";
 TADegreeInf_samples = {[2,2,1,3,2,1,2,3,2,2,1,2,3,1,2,3,2,2,1]};

gp_inline__location="../alternate.tex:30461";
 TADegreeInf_by_delta(n) = {
   if(n==0, return(2));
   2 - dBitAboveLowestOne(n);
 }

gp_inline__location="../alternate.tex:30477";
 dBitAboveLowestOne(n) = {
   if(n<1, error("dBitAboveLowestOne() is for n >= 1"));
   BitAboveLowestZero(n) - BitAboveLowestOne(n);
 }

gp_inline__location="../alternate.tex:30489";
 dBitAboveLowestOne_by_increment(n) = \
   BitAboveLowestOne(n+1) - BitAboveLowestOne(n);

gp_inline__location="../alternate.tex:30496";
 dBitAboveLowestOne_samples = {[0,1,-1,0,1,0,-1,0,0,1,0,-1,1,0,-1,0]};

gp_inline__location="../alternate.tex:30596";
 dBitAboveLowestOne_by_cases(n) = {
   my(m = n % 4);
   if(m==0,   - BitAboveLowestOne(n),     \\ -1 or 0
      m==1, BitAboveLowestOne(n+1)  ,     \\ 0 or 1
      m==2, 1 - BitAboveLowestOne(n),     \\ 1 or 0
            BitAboveLowestOne(n+1) - 1);  \\ 0 or -1
 }

gp_inline__location="../alternate.tex:30773";
 gen_TAEdgeCount_values_11_samples = [0,1,0,0,0,0,0,0,0,0,0,0,0,0,0];
 gen_TAEdgeCount_values_12_samples = [0,0,2,2,2,4,8,16,32,64,128,256,512,1024,2048];
 gen_TAEdgeCount_values_22_samples = [0,0,1,5,8,12,22,42,82,162,322,642,1282,2562,5122];
 gen_TAEdgeCount_values_13_samples = [0,0,0,0,2,4,8,16,32,64,128,256,512,1024,2048];
 gen_TAEdgeCount_values_23_samples = [0,0,0,0,2,8,16,32,64,128,256,512,1024,2048,4096];
 gen_TAEdgeCount_values_33_samples = [0,0,0,0,1,3,9,21,45,93,189,381,765,1533,3069];

gp_inline__location="../alternate.tex:30844";
 TAEdgeCount11(k) = if(k==1,1, 0);

gp_inline__location="../alternate.tex:30849";
 TAEdgeCount12_initial = {[0,0,2,2]};

gp_inline__location="../alternate.tex:30855";
 TAEdgeCount12_formula(k) = 2^(k-3);
 TAEdgeCount12(k) = \
   if(k<=3,TAEdgeCount12_initial[k+1], TAEdgeCount12_formula(k));

gp_inline__location="../alternate.tex:30865";
 TAEdgeCount12_samples = {[0,0,2,2,2,4,8,16,32]};

gp_inline__location="../alternate.tex:30877";
 TAEdgeCount22_initial = {[0,0,1,5,8]};

gp_inline__location="../alternate.tex:30883";
 TAEdgeCount22_formula(k) = 5*2^(k-4) + 2;
 TAEdgeCount22(k) = \
   if(k<=4,TAEdgeCount22_initial[k+1], TAEdgeCount22_formula(k));

gp_inline__location="../alternate.tex:30891";
 TAEdgeCount22_samples = {[0,0,1,5,8,12,22,42,82]};

gp_inline__location="../alternate.tex:30907";
 TAEdgeCount13_formula(k) = 2^(k-3);
 TAEdgeCount13(k) = if(k<=3,0, TAEdgeCount13_formula(k));

gp_inline__location="../alternate.tex:30914";
 TAEdgeCount13_samples = {[0,0,0,0,2,4,8,16,32]};

gp_inline__location="../alternate.tex:30924";
 TAEdgeCount23_initial = {[0,0,0,0,2]};

gp_inline__location="../alternate.tex:30930";
 TAEdgeCount23_formula(k) = 2^(k-2);
 TAEdgeCount23(k) = \
   if(k<=4,TAEdgeCount23_initial[k+1], TAEdgeCount23_formula(k));

gp_inline__location="../alternate.tex:30938";
 TAEdgeCount23_samples = {[0,0,0,0,2,8,16,32,64]};

gp_inline__location="../alternate.tex:30954";
 TAEdgeCount33_initial = {[0,0,0,0,1]};

gp_inline__location="../alternate.tex:30960";
 TAEdgeCount33_formula(k) = 3*2^(k-4) - 3;
 TAEdgeCount33(k) = \
   if(k<=4,TAEdgeCount33_initial[k+1], TAEdgeCount33_formula(k));

gp_inline__location="../alternate.tex:30968";
 TAEdgeCount33_samples = {[0,0,0,0,1,3,9,21,45]};

gp_inline__location="../alternate.tex:30982";
 TAEdgeCount_vector = {[
   TAEdgeCount11, TAEdgeCount12, TAEdgeCount22,
   TAEdgeCount13, TAEdgeCount23, TAEdgeCount33
 ]};
 TAEdgeCount_by_parts(k) = \
   sum(i=1,#TAEdgeCount_vector, TAEdgeCount_vector[i](k));

gp_inline__location="../alternate.tex:31015";
 TAZagrebM2_by_degrees(k) = {
   1*1 * TAEdgeCount11(k)   \\ 1,1
 + 1*2 * TAEdgeCount12(k)   \\ 1,2
 + 2*2 * TAEdgeCount22(k)   \\ 2,2
 + 1*3 * TAEdgeCount13(k)   \\ 1,3
 + 2*3 * TAEdgeCount23(k)   \\ 2,3
 + 3*3 * TAEdgeCount33(k);  \\ 3,3
 }

gp_inline__location="../alternate.tex:31026";
 TAZagrebM2_initial = {[0,1,8,24,63]};

gp_inline__location="../alternate.tex:31033";
 TAZagrebM2_formula(k) = 81*2^(k-4) - 19;
 TAZagrebM2(k) = \
   if(k<=4,TAZagrebM2_initial[k+1], TAZagrebM2_formula(k));

gp_inline__location="../alternate.tex:31049";
 TAZagrebM2_samples = {[0,1,8,24,63,143,305,629,1277]};

gp_inline__location="../alternate.tex:31059";
 TAEdgeCount_matrix(k) = {[
   1,1, TAEdgeCount11(k);
   1,2, TAEdgeCount12(k);
   2,2, TAEdgeCount22(k);
   1,3, TAEdgeCount13(k);
   2,3, TAEdgeCount23(k);
   3,3, TAEdgeCount33(k)
 ]};

gp_inline__location="../alternate.tex:31070";
 TAZagrebM2_from_matrix(m) = {
   my(s = matsize(m));
   sum(i=1,s[1], m[i,1]*m[i,2] * m[i,3]);
 }

gp_inline__location="../alternate.tex:31083";
 TAdiameter_generated_samples = {[0,1,3,7,13,23,37,59,89]};
 TAdiameter_v1_n_generated_samples = {[0,0,1,2,5,10,21,42,85]};
 TAdiameter_v2_n_generated_samples = {[0,1,2,5,10,21,42,85,170]};
 TAcornerEcc_generated_samples = {[0,1,3,6,11,18,29,44,67]};
 TAheight_generated_samples = {[0,1,2,5,8,15,22,37,52]};
 TAdiameter_vertices_generated_samples = {[
   [0],
   [0,1],
   [1,0,3,2],
   [2,3,0,1,6,7,4,5],
   [5,4,7,6,1,0,3,12,15,14,9,8,11,10],
   [10,11,8,9,14,15,12,3,0,1,6,7,24,25,30,31,28,19,16,17,22,23,20,
   21],
   [21,20,23,22,17,16,19,28,31,30,25,24,7,6,1,0,3,12,15,48,51,60,
   63,62,57,56,39,38,33,32,35,44,47,46,41,40,43,42],
   [42,43,40,41,46,47,44,35,32,33,38,39,56,57,62,63,60,51,48,15,12,
   3,0,1,6,7,24,25,30,31,96,97,102,103,120,121,126,127,124,115,112,
   79,76,67,64,65,70,71,88,89,94,95,92,83,80,81,86,87,84,85],
   [85,84,87,86,81,80,83,92,95,94,89,88,71,70,65,64,67,76,79,112,
   115,124,127,126,121,120,103,102,97,96,31,30,25,24,7,6,1,0,3,12,
   15,48,51,60,63,192,195,204,207,240,243,252,255,254,249,248,231,
   230,225,224,159,158,153,152,135,134,129,128,131,140,143,176,179,
   188,191,190,185,184,167,166,161,160,163,172,175,174,169,168,171,
   170]
 ]};

gp_inline__location="../alternate.tex:31122";
 TAdiameter(k) = vector_modulo([7,10],k) * 2^floor(k/2) - 2*k - 7;

gp_inline__location="../alternate.tex:31135";
 TAdiameter_samples = {[0,1,3,7,13,23,37,59,89]};

gp_inline__location="../alternate.tex:31222";
 TAcornerEcc(k) = vector_modulo([5,7],k) * 2^floor(k/2) - k - 5;

gp_inline__location="../alternate.tex:31232";
 TAcornerEcc_samples = {[0,1,3,6,11,18,29,44,67]};

gp_inline__location="../alternate.tex:31395";
 LRQ(k) = if(k%2==0,LQ(k),RQ(k));

gp_inline__location="../alternate.tex:31447";
 TAdiameter_v1_n(k) = 1/3*2^k - 1/3*vector_modulo([1, 2],k);
 TAdiameter_v2_n(k) = 2/3*2^k - 1/3*vector_modulo([2, 1],k);
 TAdiameter_v1_z(k) = TAVertexToZ(TAdiameter_v1_n(k));
 TAdiameter_v2_z(k) = TAVertexToZ(TAdiameter_v2_n(k));

gp_inline__location="../alternate.tex:31461";
 TAdiameter_geom_z(k) =  TAdiameter_v2_z(k) - TAdiameter_v1_z(k);

gp_inline__location="../alternate.tex:31590";
 TAheight(k) = vector_modulo([4,6],k) * 2^floor(k/2) - k - 4;

gp_inline__location="../alternate.tex:31600";
 TAheight_samples = {[0,1,2,5,8,15,22,37,52]};

gp_inline__location="../alternate.tex:31628";
 RLQ(k) = if(k%2==0,RQ(k),LQ(k));

gp_inline__location="../alternate.tex:31753";
 gen_TAW_samples = [0,1,10,84,584,3984,24864,156224,926848];
 gen_TAW_count_samples = [1,3,10,36,136,528,2080,8256,32896];
 gen_TAW_count_distinct_samples = [0,1,6,28,120,496,2016,8128,32640];
 gen_TAwS_samples = [0,1,4,18,56,200,576,1888,5248];
 gen_TAwC_samples = [0,1,6,22,80,248,800,2336,7168];
 gen_TATW_samples = [0,1,3,7,46,300,1784,10736,61920];
 gen_TATW_count_samples = [0,3,3,3,10,36,136,528,2080];
 gen_TATW_count_distinct_samples = [0,1,1,1,6,28,120,496,2016];
 gen_TAtwS_samples = [0,1,3,7,18,58,160,504,1376];
 gen_TAtwC_samples = [0,1,3,7,24,70,216,616,1856];

gp_inline__location="../alternate.tex:31782";
 TAW(k) = {
  vector_modulo([15/14, 43/28],k) * 4^k * 2^floor(k/2)
  - (1/4*k + 1) * 4^k
  - 1/14 * 2^k;
 }

gp_inline__location="../alternate.tex:31789";
 TAW_samples = {[0,1,10,84,584,3984,24864]};

gp_inline__location="../alternate.tex:31816";
 TAwS_samples = {[0,1,4,18,56,200]};

gp_inline__location="../alternate.tex:31828";
 TAwC_samples = {[0,1,6,22,80,248]};

gp_inline__location="../alternate.tex:31857";
 TAwS(k) = {
   if(k==0,return(0));
   TAwS(k-1) + 2^(k-1)*RLQ(k-1) + TAwC(k-1);
 }
 TAwS = memoize(TAwS);

gp_inline__location="../alternate.tex:31866";
 TAwC(k) = {
   if(k==0,return(0));
   TAwS(k-1) + 2^(k-1)*LRQ(k-1) + TAwC(k-1);
 }
 TAwC = memoize(TAwC);

gp_inline__location="../alternate.tex:31881";
 TAwSC(k) = TAwS(k) + TAwC(k);

gp_inline__location="../alternate.tex:31891";
 TAwC_by_LRQ(k) = {
   if(k==0,return(0));
   TAwSC(k-1) + 2^(k-1)*LRQ(k-1);
 }

gp_inline__location="../alternate.tex:31902";
 TAwSC_by_recurrence(k) = {
   if(k==0,return(0));
   2*TAwSC(k-1) + 2^(k-1)*BQ(k-1);
 }

gp_inline__location="../alternate.tex:31912";
 TAwSC_by_BQ(k) = 2^(k-1) * sum(j=0,k-1, BQ(j));

gp_inline__location="../alternate.tex:31931";
 TAW_by_parts(k) = {
   if(k==0,return(0));
   2*TAW_by_parts(k-1) + 2*2^(k-1)*TAwC(k-1) + 4^(k-1);
 }

gp_inline__location="../alternate.tex:31941";
 TAW_by_sum(k) = 2^(k-1)*(2^k - 1) \
   + 2^k*sum(j=0,k-1, TAwC(j));

gp_inline__location="../alternate.tex:32286";
 TAW_count_distinct(k) = 1/2*(4^k - 2^k);

gp_inline__location="../alternate.tex:32307";
 TAW_even_mean_limit = {(15)/(49)};

gp_inline__location="../alternate.tex:32312";
 TAW_mean(k) = TAW(k)/(TAW_count_distinct(k)*TAdiameter(k));

gp_inline__location="../alternate.tex:32321";
 TAW_even_mean_sample = {(0306122/1000000)};

gp_inline__location="../alternate.tex:32338";
 TAW_odd_mean_limit = {(43)/(140)};

gp_inline__location="../alternate.tex:32347";
 TAW_odd_mean_sample = {(0307142/1000000)};

gp_inline__location="../alternate.tex:32366";
 TA_n_has_edge(n1,n2) = {
   n1>=0 && n2>=0
   && (   n2 == bitxor(n1, 1)
       || n2 == TAVertexToUpper(n1)
       || n2 == TAVertexToLower(n1) );
 }

gp_inline__location="../alternate.tex:32377";
 \\ Return the Laplacian matrix of twin alternate area tree k.
 \\ Rows and columns are numbered by the tree vertex numbering.
 TA_Laplacian_matrix(k) = vpar_Laplacian_matrix(TA_vpar(k));

gp_inline__location="../alternate.tex:32393";
 \\ m is a Laplacian matrix of a tree.
 \\ Return the Wiener index of the tree using the eigenvalues of m
 \\ (at floats).
 Wiener_of_tree_Laplacian_matrix(m) = {
   my(p = charpoly(m), n=poldegree(p));
   polcoeff(p,0) == 0
     || error("oops, expected low coeff ==0");
   p/=x;
   polcoeff(p,0) != 0
     || error("oops, expected second low coeff !=0");
   n * vecsum(apply(x->1/x, polroots(p)));
 }
 TAW_by_Laplacian(k) = \
   Wiener_of_tree_Laplacian_matrix(TA_Laplacian_matrix(k));

gp_inline__location="../alternate.tex:32412";
 \\ lex_by_abs(a,b) is lex(abs(a),abs(b)) comparing a,b by absolute
 \\ value, including complex numbers compared by magnitude.
 \\ If abs(a)==abs(b) then real(a),real(b) and imag(a),imag(b)
 \\ are compared, which means positives considered bigger.
 lex_by_abs(a,b) = \
   lex([abs(a),real(a),imag(a)],[abs(b),real(b),imag(b)]);
 lex_by_abs_descending(a,b) = - lex_by_abs(a,b);

gp_inline__location="../alternate.tex:32424";
 \\ Return polroots(p) sorted by magnitude per lex_by_abs().
 polroots_ascending(p) = vecsort(polroots(p),lex_by_abs);
 polroots_descending(p) = Vecrev(polroots_ascending(p));

gp_inline__location="../alternate.tex:32457";
 TA_algebraic_connectivity(k) = {
   if(k==0,return(0));
   simplify(polroots_ascending(charpoly(TA_Laplacian_matrix(k)))[2]);
 }

gp_inline__location="../alternate.tex:32480";
 TATW_initial = {[0,1,3,7]};

gp_inline__location="../alternate.tex:32495";
 TATW_formula(k) = 1/16*TAW(k) + 1/16*4^k - 13/32*2^k;
 TATW(k) = if(k<4,TATW_initial[k+1],TATW_formula(k));

gp_inline__location="../alternate.tex:32506";
 TATW_samples = {[0,1,3,7,46,300,1784,10736]};

gp_inline__location="../alternate.tex:32525";
 TAtwS_samples = {[0,1,3,7,18,58]};

gp_inline__location="../alternate.tex:32539";
 TAtwC_samples = {[0,1,3,7,24,70]};

gp_inline__location="../alternate.tex:32568";
 TAtwS_formula(k) = {
   TAtwS(k-1)                      \\ lower
   + TADegCount1(k-1) * RLQ(k-1)   \\ S to c2
   + TAtwC(k-1);                   \\ c2 into upper
 }
 TAtwS(k) = if(k>=4, TAtwS_formula(k), gen_TAtwS_samples[k+1]);
 TAtwS = memoize(TAtwS);

gp_inline__location="../alternate.tex:32597";
 TAtwC_formula(k) = {
   TAtwS(k-1)                       \\ upper except c2
    + TADegCount1(k-1)*LRQ(k-1)     \\ C to c1
    + TAtwC(k-1);                   \\ c1 into lower
 }
 TAtwC(k) = if(k>=4, TAtwC_formula(k), gen_TAtwC_samples[k+1]);
 TAtwC = memoize(TAtwC);

gp_inline__location="../alternate.tex:32621";
 TAtwSC(k) = TAtwS(k) + TAtwC(k);

gp_inline__location="../alternate.tex:32634";
 TAtwSC_by_recurrence(k) = {
   if(k<=3,return(TAtwSC(k)));
   2*TAtwSC(k-1) + 2^(k-3)*BQ(k-1);
 }

gp_inline__location="../alternate.tex:32651";
 TAtwSC_by_sum(k) = \
   7*2^(k-2) + 2^(k-3)*sum(j=3,k-1, BQ(j));

gp_inline__location="../alternate.tex:32662";
 TAtwC_by_LRQ(k) = {
   if(k<4,error("TAtwC_by_LRQ() is for k>=4"));
   TAtwSC(k-1) + 2^(k-3)*LRQ(k-1);
 }

gp_inline__location="../alternate.tex:32690";
 TATW_by_parts(k) = {
   if(k<4,error("TATW_by_parts() is for k>=4"));
   if(k==4, return(46));
   2*TATW_by_parts(k-1)                     \\ halves
   + 2 * TADegCount1(k-1) * TAtwC(k-1)      \\ c1,c2 into halves
   + TADegCount1(k-1)^2;                    \\ across c1,c2
 }

gp_inline__location="../alternate.tex:32712";
 TATW_by_sum(k) = {
   2*4^(k-3) + 5*2^(k-3) + 2^(k-2) * sum(j=3,k-1, TAtwC(j));
 }

gp_inline__location="../alternate.tex:32742";
 TATW_count_distinct(k) = binomial(TADegCount1(k), 2);

gp_inline__location="../alternate.tex:32750";
 TATW_mean(k) = TATW(k) / (TATW_count_distinct(k) * TAdiameter(k));

gp_inline__location="../alternate.tex:32766";
 TAparent_generated_samples = {[0,3,0,7,4,1,6,9,14,11,8,3,12,15,12,
   19,16,19,28,23,20,17,22,7,24,27,24,31,28,25,30,33,38,35,32,39,
   36,39,56,41,46,43,40,35,44,47,44,15,48,51,48,55,52,49,54,57,62,
   59,56,51,60,63,60,67,64,67,76,71,68,65,70,73,78,75,72,79,76,79,
   112,83,80,83,92,87,84,81,86,71,88,91,88,95,92,89,94,31,96,99,96,
   103,100,97,102,105,110,107,104,99,108,111,108,115,112,115,124,
   119,116,113,118,103,120,123,120,127,124,121,126,129,134,131,128,
   135,132,135,152,137,142,139,136,131,140,143,140,147,144,147,156,
   151,148,145,150,153,158,155,152,159,156,159,224,161,166,163,160,
   167,164,167,184,169,174,171,168,163,172,175,172,143,176,179,176,
   183,180,177,182,185,190,187,184,179,188,191,188,63,192,195,192,
   199,196,193,198,201,206,203,200,195,204,207,204,211,208,211,220,
   215,212,209,214,199,216,219,216,223,220,217,222,225,230,227,224,
   231,228,231,248,233,238,235,232,227,236,239,236,207,240,243,240,
   247,244,241,246,249,254,251,248,243,252,255,252]};

gp_inline__location="../alternate.tex:32783";
 TAtospine_generated_samples = {[6,3,12,7,4,7,24,9,14,11,8,15,12,
   15,48,19,16,19,28,23,20,17,22,25,30,27,24,31,28,31,96,33,38,35,
   32,39,36,39,56,41,46,43,40,35,44,47,44,51,48,51,60,55,52,49,54,
   57,62,59,56,63,60,63,192,67,64,67,76,71,68,65,70,73,78,75,72,79,
   76,79,112,83,80,83,92,87,84,81,86,71,88,91,88,95,92,89,94,97,
   102,99,96,103,100,103,120,105,110,107,104,99,108,111,108,115,
   112,115,124,119,116,113,118,121,126,123,120,127,124,127,384,129,
   134,131,128,135,132,135,152,137,142,139,136,131,140,143,140,147,
   144,147,156,151,148,145,150,153,158,155,152,159,156,159,224,161,
   166,163,160,167,164,167,184,169,174,171,168,163,172,175,172,143,
   176,179,176,183,180,177,182,185,190,187,184,179,188,191,188,195,
   192,195,204,199,196,193,198,201,206,203,200,207,204,207,240,211,
   208,211,220,215,212,209,214,199,216,219,216,223,220,217,222,225,
   230,227,224,231,228,231,248,233,238,235,232,227,236,239,236,243,
   240,243,252,247,244,241,246,249,254,251,248,255,252,255,768]};

gp_inline__location="../alternate.tex:32828";
 TAparentDir_matrix = {[ 2, 3;     \\ 0=right
                         2, 1;     \\ 1=up
                         1, 0;     \\ 2=left
                         3, 0 ]};  \\ 3=down
 TAparentDir_transition(state,bit) = \
   TAparentDir_matrix[state+1,bit+1];
 TAparentDir_transitions(state,v) = {
   for(i=1,#v,  /* high to low */
       state=TAparentDir_transition(state,v[i]));
   state;
 }
 TAparentDir_initial_state = 3;
 TAparentDir(n) = {
   n>=1 || error("TAparentDir() is for n>=1, got ",n);
   TAparentDir_transitions(TAparentDir_initial_state,
                           binary(n));
 }
 TA_n_in_direction(n,d) = {
   if(d==1,TAVertexToUpper(n),
      d==3,TAVertexToLower(n),
      bitxor(n,1));
 }
 TAparent(n) = TA_n_in_direction(n, TAparentDir(n));

gp_inline__location="../alternate.tex:32852";
 \\ return vpar[1..n] tree k
 TA_vpar(k) = vector(2^k,n,n--; if(n,TAparent(n)+1));

gp_inline__location="../alternate.tex:32970";
 TAparentDir_samples = {[0,2,3,1,0,3,0,2,1,2,3,3,0,2,3,1,0]};

gp_inline__location="../alternate.tex:32997";
 TAparent_samples = {[0,3,0,7,4,1,6,9,14,11,8,3,12,15,12,19,16]};

gp_inline__location="../alternate.tex:33181";
 Flip1110_xor_mask(n) = {
   my(v=binary(n),ret=vector(#v));
   for(i=2,#v, if(v[i-1]==1 && v[i]==1,
                  for(j=i,#v, ret[j]=1-ret[j]),
                  v[i-1]==1 && v[i]==0,
                  ret[i]=1-ret[i]));
   fromdigits(ret,2);
 }
 Flip1110(n) = bitxor(n,Flip1110_xor_mask(n));

gp_inline__location="../alternate.tex:33194";
 Flip1110_samples = {[0,1,3,2,6,7,4,5,12,13,15,14,9,8,11,10,24]};

gp_inline__location="../alternate.tex:33201";
 Flip1110_binary_samples = {[0,1,11,10,110,111,100,101,1100,1101]};

gp_inline__location="../alternate.tex:33248";
 UnFlip1110(n) = {
   my(v=binary(n));
   for(i=2,#v, if(v[i-1]==1 && v[i]==0,
                  for(j=i,#v, v[j]=1-v[j]),
                  v[i-1]==1 && v[i]==1,
                  v[i]=1-v[i]));
   fromdigits(v,2);
 }

gp_inline__location="../alternate.tex:33260";
 UnFlip1110_samples = {[0,1,3,2,6,7,4,5,13,12,15,14,8,9,11,10,26]};

gp_inline__location="../alternate.tex:33269";
 UnFlip1110_binary_samples = {[0,1,11,10,110,111,100,101,1101,1100]};

gp_inline__location="../alternate.tex:33301";
 \\ count how many n of k many bits have
 \\ Flip1110(n) == UnFlip1110(n)
 Flip1110_eq_UnFlip1110_k_by_pred(k) = \
   if(k==0,0, sum(n=2^(k-1),2^k-1, Flip1110(n) == UnFlip1110(n)));

gp_inline__location="../alternate.tex:33308";
 \\ count how many n of k many bits have
 \\ Flip1110(n) != UnFlip1110(n)
 Flip1110_ne_UnFlip1110_k_by_pred(k) = \
   if(k==0,0, sum(n=2^(k-1),2^k-1, Flip1110(n) != UnFlip1110(n)));

gp_inline__location="../alternate.tex:33331";
 UnFlip1110_xor_mask(n) = bitxor(n,UnFlip1110(n));

gp_inline__location="../alternate.tex:33370";
 TA_to_root(n) = while(n>=2,n=TAparent(n)); n;

gp_inline__location="../alternate.tex:33381";
 TAparentDir2_pred_by_runs(n) = {
   n>0 || return(0);
   my(l=CountLowZeros(n));    \\ odd 0s
   l%2==1 || return(0);
   n>>=l;
   while(1,
         l=CountLowOnes(n);
         if(l%2==1,return(1));  \\ odd 1s yes
         n>>=l;                 \\ even 1s continue
         if(n==0,return(0));
         l=CountLowZeros(n);    \\ even 0s
         l%2==0 || return(0);
         n>>=l);
 }

gp_inline__location="../alternate.tex:33398";
 TAparentDir2_pred_by_pairs(n) = {
   n>0 || return(0);
   n%2==0 || return(0);
   n\=2;
   while(n && (n%4==0 || n%4==3), n>>=2);
   n%4 == 1;
 }

gp_inline__location="../alternate.tex:33412";
 n_1bit_positions(n) = {
   my(pos=0,l=List([]));
   while(n, if(n%2,listput(l,pos)); pos++;n\=2);
   Vecrev(l);
 }

gp_inline__location="../alternate.tex:33425";
 \\ v=TA_parents_vector(k) returns a vector v where v[n] is the
 \\ parent vertex of n, for n=1 to 2^k-1 inclusive.
 TA_parents_vector(k) = {
   my(limit=2^k-1, parents=vector(limit,i,-1), pending=List([0]));
   while(#pending,
         my(p=pending[#pending]);
         listpop(pending);
         my(neighbours=TA_n_to_neighbours(p));
         for(i=1,#neighbours,
             my(c=neighbours[i]);
             if(c<1||c>limit,next());
             if(parents[c]>=0,next());
             parents[c]=p;
             listput(pending,c)));
   parents;
 }

gp_inline__location="../alternate.tex:33446";
 TAparentDir_LtoH_matrix = {[ 1, 2;     \\ s1
                              7, 3;     \\ s2
                              4, 2;     \\ s3
                              3, 6;     \\ s4
                              4, 5;     \\ s5
                              6, 6;     \\ 6=yes
                              7, 7 ]};  \\ 7=non
 TAparentDir_LtoH_accepting_set = Set([3,4,5,6]);
 TAparentDir_LtoH_state_is_accepting(state) = \
   setsearch(TAparentDir_LtoH_accepting_set,state) != 0;
 TAparentDir_LtoH_transition(state,bit) = \
   TAparentDir_LtoH_matrix[state,bit+1];
 TAparentDir_LtoH_transitions(state,v) = {
   for(i=1,#v, state=TAparentDir_LtoH_transition(state,v[i]));
   state;
 }
 TAparentDir_LtoH(n,state) = {
   n>=1 || error("TAparentDir_LtoH() is for n>=0, got ",n);
   state=TAparentDir_LtoH_transitions(state, Vecrev(binary(n)));
   TAparentDir_LtoH_state_is_accepting(state);
 }
 TAparentDir_LtoH_initial_state_vector = [2,5,4,1];
 TAparentDir_LtoH_initial_state(d) = \
   TAparentDir_LtoH_initial_state_vector[(d%4)+1];

gp_inline__location="../alternate.tex:33600";
 TAparentDir_pred0_by_base4(n) = {
   n%2==1 || return(0);
   my(v=digits(floor(n/2),4));
   forstep(i=#v,1,-1, if(v[i]==1,return(0),  \\ lowest non-0,3 != 2
                         v[i]==2,return(1))); \\ lowest non-0,3 = 2
   1;  \\ entirely 0,3
 }

gp_inline__location="../alternate.tex:33610";
 TAparentDir_not_pred0_by_base4(n) = {
   if(n%2==0,return(1));
   my(v=digits(floor(n/2),4));
   forstep(i=#v,1,-1, if(v[i]==1,return(1),
                         v[i]==2,return(0)));
   0;
 }

gp_inline__location="../alternate.tex:33620";
 TAparentDir_pred2_by_base4(n) = {
   if(n%2,return(0));
   my(v=digits(n/2,4));
   forstep(i=#v,1,-1, if(v[i]==1,return(1),
                         v[i]==2,return(0)));
   0;
 }

gp_inline__location="../alternate.tex:33630";
 \\ Return the lowest base-4 digit which is not 0 or 3.
 \\ If entirely 0s and 3s then return 0, reckoned as the next
 \\ digit above the top of n.
 LowestNon03(n) = {
   while(n>0 && (n%4==0 || n%4==3), n\=4);
   n%4;
 }
 LowestNon03_ne1(n) = LowestNon03(n)!=1;

gp_inline__location="../alternate.tex:33732";
 gen_TA_spines_n_list = [0,1,3,6,7,12,15,24,25,30,31,48,51,60,63];

gp_inline__location="../alternate.tex:33775";
 TAspineV(m) = 3*Xnum(m);

gp_inline__location="../alternate.tex:33777";
 TAspineV_samples = {[0,3,12,15,48,51,60,63,192,195]};

gp_inline__location="../alternate.tex:33786";
 A001196(n) = 3*fromdigits(binary(n),4);

gp_inline__location="../alternate.tex:33796";
 TAspineNW(m) = floor(3/2*Xnum(m));

gp_inline__location="../alternate.tex:33798";
 TAspineNW_samples = {[0,1,6,7,24,25,30,31,96,97]};

gp_inline__location="../alternate.tex:33829";
 TA_n_to_root(n) = while(n>1,n=TAparent(n)); n;

gp_inline__location="../alternate.tex:33835";
 TA_vertical_spine_vertices_samples = {[0,2,3,8,9,10,11,12,13,14]};

gp_inline__location="../alternate.tex:33845";
 is_A053754(n) = bitlength(n)%2==0;

gp_inline__location="../alternate.tex:33849";
 \\ blocks lengths 2*4^k, to which add enough
 \\ A053754(n) = if(n--, n + (4^logint(6*n,4)-1)/3, 0);
 A053754(n) = n + if(n==1,-1, (4^logint(6*(n-1),4) - 4)/3);

gp_inline__location="../alternate.tex:33869";
 TA_NW_spine_vertices_samples = {[1,4,5,6,7,16,17,18,19,20]};

gp_inline__location="../alternate.tex:33879";
 is_A053738(n) = bitlength(n)%2==1;

gp_inline__location="../alternate.tex:33886";
 \\ blocks lengths 4^k, to which add enough
 A053738(n) = n + (4^logint(3*n,4) - 1)*2/3;

gp_inline__location="../alternate.tex:34008";
 TAtospineDir_initial_state = 1;
 TAtospineDir_formula(n) = {
   TAparentDir_transitions(TAtospineDir_initial_state,
                           binary(n)) % 4;
 }
 TAtospineDir(n) = {
   n>=0 || error("TAtospineDir() is for n>=0, got ",n);
   TAtospineDir_formula(n);
 }

gp_inline__location="../alternate.tex:34026";
 TA_n_edge_to_dir(u,v) = {
   if(TAVertexToRight(u)==v,0,
      TAVertexToUpper(u)==v,1,
      TAVertexToLeft(u)==v,2,
      TAVertexToLower(u)==v,3,
      error("vertices ",u," and ",v," not adjacent"));
 }

gp_inline__location="../alternate.tex:34039";
 TAtospineDir_samples = {[1,1,2,1,1,0,2,1,2,1,2,3,1,0]};

gp_inline__location="../alternate.tex:34052";
 TAtospine(n) = TA_n_in_direction(n, TAtospineDir(n));

gp_inline__location="../alternate.tex:34055";
 TAtospine_samples = {[3,6,3,12,7,4,7,24,9,14,11,8,15,12]};

gp_inline__location="../alternate.tex:34073";
 TAspine_by_repeat(m,n) = for(i=1,m,n=TAtospine(n)); n;

gp_inline__location="../alternate.tex:34100";
 TAtospineDir_to_c(n) = \
   TAparentDir_transitions(2, binary(n)) % 4;
 TAtospine_to_c(n) = TA_n_in_direction(n, TAtospineDir_to_c(n));

gp_inline__location="../alternate.tex:34118";
 dTAspine(m) = TAspine(m+1) - TAspine(m);

gp_inline__location="../alternate.tex:34122";
 xdTAspine(m) = bitxor(TAspine(m+1), TAspine(m));

gp_inline__location="../alternate.tex:34124";
 xdTAspineLen(m) = length(binary(xdTAspine(m))); \\ num bits flip

gp_inline__location="../alternate.tex:34133";
 \\ Return a vector of the binary exponents of n.
 \\ So vector v = [k1,k2,...] for n == 2^k1 + 2^k2 + ...
 \\ The exponents are high to low k1 > k2 > ... like binary() gives.
 binary_exponents(n) = {
   my(v=binary(n));
   apply(i->#v-i, Vec(select(bit->bit,v, 1)));
 }

gp_inline__location="../alternate.tex:34224";
 TAdepth(n) = {
   my(v=binary(n),i=1,depth=0,want=1);
   while(i<=#v,

     if(i<=#v,                    \\ 1010...
        v[i]==want || error();
        depth += RLQ(#v-i); i++; want=1-want;
        while(i<=#v && v[i]==want,
          depth += LRQ(#v-i); i++; want=1-want));

     i++; \\ skip 1000 or 0111   first is !=want, rest ==want
     while(i<=#v && v[i]==want, i++);

     want=1-want
   );
   depth;
 }

gp_inline__location="../alternate.tex:34251";
 TAdepth_samples = {[0,1,2,1,4,5,2,3,6,5,8,7,2,3,4,3,10]};

gp_inline__location="../alternate.tex:34304";
 TAdepth_by_UnFlip1110(n) = {
   my(v=binary(UnFlip1110(n)),i=1,depth=0);
   while(i<=#v,

     if(i<=#v && v[i]==1,             \\ run 1s
        depth += RLQ(#v-i); i++;
        while(i<=#v && v[i]==1,
          depth += LRQ(#v-i); i++));

     while(i<=#v && v[i]==0, i++);    \\ run 0s
   );
   depth;
 }

gp_inline__location="../alternate.tex:34335";
 TAdepthStates_matrix = {[ 3, 4;     \\ 1=a
                           3, 2;     \\ 2=e
                           2, 1;     \\ 3=c
                           4, 1 ]};  \\ 4=s

gp_inline__location="../alternate.tex:34341";
 TAdepthStates_outfunc = {[ LRQ, 0;
                            RLQ, 0;
                            0,   LRQ;
                            0,   RLQ ]};
 TAdepthStates_transition(state,bit) = \
   TAdepthStates_matrix[state,bit+1];

gp_inline__location="../alternate.tex:34348";
 TAdepthStates_initial = 4; \\ to s
 TAdepth_by_states(n) = {
   my(debug=0);
   my(v=binary(n),depth=0,state=TAdepthStates_initial);
   for(i=1,#v,  /* bits high to low */
       my(bit=v[i],
          outfunc=TAdepthStates_outfunc[state,bit+1]);
       if(debug,print("state="state" bit="bit"  "outfunc));
       if(outfunc,
          if(debug,print("  add index ",#v-i,
                         " depth "outfunc(#v-i)));
          depth+=outfunc(#v-i));
       state=TAdepthStates_transition(state,bit));
   depth;
 }

gp_inline__location="../alternate.tex:34451";
 TAancestors(n) = {
   my(l=List([n]));
   while(n, n=TAparent(n); listput(l,n));
   Vec(l);
 }

gp_inline__location="../alternate.tex:34459";
 UnFlip1110_by_path_to_n(n) = {
   my(debug=1);
   my(v=TAancestors(n),ret=0);
   v=select(a->a!=0,v);
   while(#v > 1,
     my(m=vecmax(v));
     if(!m,break());
     my(bit=highbit(m));
     if(debug, print(v"  bit="bit));
     ret+=bit;
     v=select(a->a<bit,v);
     );
   if(debug, print("final ",v));
   ret;
 }

gp_inline__location="../alternate.tex:34486";
 \\ d is a depth in the twin alternate area tree, starting root d=0.
 \\ Return a vector of point numbers n which are vertices
 \\  at depth d.
 TA_depth_to_n_list(d) = {
   my(seen=List([0]), vertices=List([0]));
   for(i=1,d,
       \\ print("i="i" vertices=",vertices);
       my(new_vertices = List([]));
       for(p=1,#vertices,
          my(n = vertices[p],
             neighbours = TA_n_to_neighbours(n));
          \\ print("  n="n" neighbours=",neighbours);
          for(j=1,#neighbours,
             my(n2 = neighbours[j]);
             my(pos=setsearch(seen,n2,1));
             if(pos, listput(new_vertices,n2);
                     listinsert(seen,n2, pos))));
       vertices = new_vertices;
      );
   vecsort(Vec(vertices));
 }

gp_inline__location="../alternate.tex:34531";
 WidthS_formula(k,d) = \
   WidthS(k-1,d) + WidthC(k-1,d-RLQ(k-1));

gp_inline__location="../alternate.tex:34540";
 WidthC_formula(k,d) = \
   WidthS(k-1,d) + WidthC(k-1,d-LRQ(k-1));

gp_inline__location="../alternate.tex:34550";
 WidthS(k,d) = {
   if(k<0,error("WidthS() is for k>=0, got ",k),
      d<0,0, k==0,d==0, WidthS_formula(k,d));
 }
 WidthC(k,d) = {
   if(k<0,error("WidthC() is for k>=0, got ",k),
      d<0,0, k==0,d==0, WidthC_formula(k,d));
 }

gp_inline__location="../alternate.tex:34559";
 WidthS_list(k) = vector(TAheight(k)+1,   d,d--; WidthS(k,d));
 WidthC_list(k) = vector(TAcornerEcc(k)+1,d,d--; WidthC(k,d));

gp_inline__location="../alternate.tex:34567";
 WidthS_0_samples = {[1]};

gp_inline__location="../alternate.tex:34574";
 WidthS_1_samples = {[1,1]};

gp_inline__location="../alternate.tex:34581";
 WidthS_2_samples = {[1,2,1]};

gp_inline__location="../alternate.tex:34588";
 WidthS_3_samples = {[1,2,2,1,1,1]};

gp_inline__location="../alternate.tex:34595";
 WidthS_4_samples = {[1,2,3,3,2,2,1,1,1]};

gp_inline__location="../alternate.tex:34602";
 WidthS_5_samples = {[1,2,3,3,3,4,3,2,2,2,2,1,1,1,1,1]};

gp_inline__location="../alternate.tex:34613";
 WidthS_maximum_max_and_depth(k) = {
   my(v = WidthS_list(k),
      m = vecmax(v),
      d = select(i->v[i]==m, [1..#v]));
   if(#d==1, d=d[1]);
   [m,d];
 }
 WidthS_maximum_max_and_depth = memoize(WidthS_maximum_max_and_depth);
 WidthS_maximum(k)          = WidthS_maximum_max_and_depth(k)[1];
 WidthS_maximum_at_depth(k) = WidthS_maximum_max_and_depth(k)[2];

gp_inline__location="../alternate.tex:34703";
 \\ Make a vector of vectors which are all the WidthS runs.
 \\ Each element vector is  values RQ(i) or LQ(i).  The RQ values
 \\ are indicated by being negative.  vecsum(abs(e)) == d.
 \\
 WidthS_make_runs(k,d) = {
   my(l = List([vector(k+1)]));
   forstep(p=k,1,-1,
     \\ print("p="p" for RLQ="RLQ(p-1)" LRQ="LRQ(p-1));
     my(new_l = List([]));
     for(i=1,#l,
         my(v=l[i], t=vecsum(abs(v)));
         \\ print("  consider v="v"  sum t="t);
         if(v[p+1]==0,
            \\ print("below gap, try RLQ");
            if(t+RLQ(p-1) <= d,
               v[p] = -RLQ(p-1); listput(new_l,v)));
         if(v[p+1],
            \\ print("below RLQ or LRQ, try an LRQ");
            if(t+LRQ(p-1) <= d,
               v[p] = LRQ(p-1); listput(new_l,v)));
         v[p] = 0;
         listput(new_l,v);   \\ always add a gap
      );
      l = new_l;
   );
   l = Vec(l);
   \\ print("final l="l);
   l = select((v)->vecsum(abs(v))==d, l);
   l = apply((v)->vector_shorten_to(v,k), l); \\ strip top sentinels
   l = apply(Vecrev, l);           \\ high to low
   l;
 }
 WidthS_from_runs(k,d) = length(WidthS_make_runs(k,d));

gp_inline__location="../alternate.tex:34782";
 WidthS_descents(k,d) = {
   my(debug=0);
   if(debug,print("WidthS("k","d")"));
   if(k==0, return(if(d==0,[[]],[])));
   my(v=[],sub=RLQ(k-1));
   if(debug,print("  sub "sub));
   if(d-sub>=0,
      if(debug,print("  descend to "d-sub));
      v=concat(v,apply(v->concat(sub,v),
                       WidthC_descents(k-1,d-sub))));
   v=concat(v,apply(v->concat(0,v),WidthS_descents(k-1,d)));
   v;
 }
 WidthC_descents(k,d) = {
   my(debug=0);
   if(debug,print("WidthC("k","d")"));
   if(k==0, return(if(d==0,[[]],[])));
   my(v=[],sub=LRQ(k-1));
   if(d-sub>=0,v=concat(v,apply(v->concat(sub,v),
                          WidthC_descents(k-1,d-sub))));
   v=concat(v,apply(v->concat(0,v),WidthS_descents(k-1,d)));
   if(debug,print("  WidthC("k","d") result "v));
   v;
 }

gp_inline__location="../alternate.tex:34946";
 \\ Return the k to use in WidthS(k,d) for infinite tree.
 \\ This is RLQ(k) > d >= RLQ(k-1).
 WidthS_infinity_k(d) = \
   for(k=0,oo, if(RLQ(k)>d, return(k)));

gp_inline__location="../alternate.tex:34955";
 WidthS_infinity(d) = WidthS(WidthS_infinity_k(d), d);
 WidthC_infinity(d) = \
   my(k=1); while(d >= LRQ(k-1), k++); WidthC(k+5,d);

gp_inline__location="../alternate.tex:34959";
 WidthS_infinity_by_list(d) = length(TA_depth_to_n_list(d));

gp_inline__location="../alternate.tex:34963";
 WidthS_infinity_samples = {[1,2,3,3,4,6,6,5,6,8,9,9,11,13,11,9,10,12,12,12]};

gp_inline__location="../alternate.tex:35038";
 WidthS_infinity_generated_samples = [1,2,3,3,4,6,6,5,6,8,9,9,11,13,11,9,10];

gp_inline__location="../alternate.tex:35074";
 dWidthS_infinity(d) = WidthS_infinity(d+1) - WidthS_infinity(d);

gp_inline__location="../alternate.tex:35162";
 TAindnum(k) = if(k==0,1, 2^(k-1));

gp_inline__location="../alternate.tex:35175";
 TAindRatio(k) = if(k==0,1,1/2);

gp_inline__location="../alternate.tex:35205";
 TAdomnum_initial = {[1,1,2]};

gp_inline__location="../alternate.tex:35213";
 TAdomnum_formula(k) = 3*2^(k-3);
 TAdomnum(k) = if(k<=2,TAdomnum_initial[k+1], TAdomnum_formula(k));

gp_inline__location="../alternate.tex:35219";
 TAdomnum_samples = {[1,1,2,3,6,12,24,48,96,192]};

gp_inline__location="../alternate.tex:35237";
 TAdomnumCount_initial = {[1,2,4]};

gp_inline__location="../alternate.tex:35245";
 TAdomnumCount_formula(k) = 2^(2^(k-2));
 TAdomnumCount(k) = \
   if(k<=2,TAdomnumCount_initial[k+1], TAdomnumCount_formula(k));

gp_inline__location="../alternate.tex:35258";
 TAdomnumCount_samples = {[1,2,4,4,16,256,65536,4294967296]};

gp_inline__location="../alternate.tex:35396";
 TAdomRatio_initial = {[1,1/2,1/2]};

gp_inline__location="../alternate.tex:35401";
 TAdomRatio_limit = {3/8};

gp_inline__location="../alternate.tex:35406";
 TAdomRatio(k) = if(k<=2,TAdomRatio_initial[k+1], TAdomRatio_limit);

gp_inline__location="../alternate.tex:35425";
 TAdomnum2_is_dominating(set) = {
      (set[1] || set[2])                       \\ 1
   && (set[1] || set[2] || set[3])             \\ 2
   && (          set[2] || set[3] || set[4])   \\ 3
   && (                    set[3] || set[4]);  \\ 4
 }

gp_inline__location="../alternate.tex:35443";
 TAdomnum2_one_type_is_ok(t,v,neighbours) = {
   if(t=="with",         v==1,
      t=="dom",          v==1 || vecsum(neighbours),
      t=="without_dom",  v==0 && vecsum(neighbours),
      t=="without_undom",v==0 && !vecsum(neighbours),
      error("unrecognised type: ",t));
 }
 TAdomnum2_is_ok(set,typ) = {
    TAdomnum2_one_type_is_ok(typ[3],set[1],[set[2]])
 && TAdomnum2_one_type_is_ok(typ[1],set[2],[set[1],set[3]])
 && TAdomnum2_one_type_is_ok(typ[4],set[3],[set[2],set[4]])
 && TAdomnum2_one_type_is_ok(typ[2],set[4],[set[3]]);
 }

gp_inline__location="../alternate.tex:35459";
 \\ return the number of dominating sets in area tree k=1
 \\ with the constraint typ
 TAdomnum_and_count2_of_type(typ) = {
   my(domnum=-1,count=0);
   forvec(j=[[0,1],[0,1],[0,1],[0,1]],
          if(TAdomnum2_is_ok(j,typ),
             my(n=vecsum(j));
             if(domnum==-1||n<domnum, domnum=n;count=0);
             if(n==domnum, count++)));
   [domnum,count];
 }

gp_inline__location="../alternate.tex:35477";
 TAdomnum_and_count_types_seen = Map();

gp_inline__location="../alternate.tex:35483";
 TAdomnum_and_count_choices = {[
   ["with",          "without_dom"],
   ["with",          "without_undom"],
   ["without_dom",   "with"],
   ["without_undom", "with"],
   ["without_dom",   "without_dom"],
   ["with",          "with"]
 ]};

gp_inline__location="../alternate.tex:35492";
 domnum_and_count_best(x,y) = {
   if(x[2]==0, y,
      y[2]==0, x,
      x[1]<y[1], x,
      y[1]<x[1], y,
      x[1]==y[1] || error();
      [x[1], x[2]+y[2]]);  \\ x,y equal domnum, sum counts
 }
 domnum_and_count_connect(x,y) = [x[1]+y[1], x[2]*y[2]];

gp_inline__location="../alternate.tex:35503";
 TAdomnum_and_count_of_type(k,typ) = {
   \\ print("k="k" typ "typ);
   if(k==3,mapput(TAdomnum_and_count_types_seen,typ,1));
   if(k==2,return(TAdomnum_and_count2_of_type(typ)));

   my(ret=[-9999999,0]);
   my(S,A,C,E); [S,A,C,E]=typ;
   for(i=1,#TAdomnum_and_count_choices,
     my(choice=TAdomnum_and_count_choices[i],
        this_x=TAdomnum_and_count_of_type
                 (k-1,[S,"dom",choice[1],C]),
        this_y=TAdomnum_and_count_of_type
                 (k-1,[E,"dom",choice[2],A]),
        this=domnum_and_count_connect(this_x,this_y));
     ret=domnum_and_count_best(ret,this);
     if(0&&k==3,print(choice"  "this_x" + "this_y" = "this"  giving "ret));
   );
   ret;
 }
 TAdomnum_and_count_of_type = memoize(TAdomnum_and_count_of_type);

gp_inline__location="../alternate.tex:35529";
 TAdomnum_and_count_by_type(k) = {
   if(k==0,return([1,1]));
   if(k==1,return([1,2]));
   TAdomnum_and_count_of_type(k,["dom","dom","dom","dom"]);
 }

gp_inline__location="../alternate.tex:35589";
 TAindomnum(k) = TAdomnum(k);

gp_inline__location="../alternate.tex:35597";
 TAindomnumCount_initial = {[1,2,3,4]};

gp_inline__location="../alternate.tex:35606";
 TAindomnumCount_formula(k) = 7^(2^(k-4));
 TAindomnumCount(k) = \
  if(k<=3,TAindomnumCount_initial[k+1], TAindomnumCount_formula(k));

gp_inline__location="../alternate.tex:35614";
 TAindomnumCount_samples = {[1,2,3,4,7,49,2401,5764801]};

gp_inline__location="../alternate.tex:35668";
 \\ with +1 for 1-based vpar
 gen_TAindomnum_k4_set1 = Set([2,3,5,12,14,15]);

gp_inline__location="../alternate.tex:35721";
 \\ Set() of vertex numbers start,end, C, A, in 1-based numbering
 \\ for use with TA_vpar().
 TA_vpar_sace(k) = Set([1,TA_complex_c(k)+1,TA_complex_a(k)+1,2^k]);

gp_inline__location="../alternate.tex:35725";
 \\ "set" is a set of vertex numbers.
 \\ Return the set which they dominate, being the set itself
 \\ and all its neighbours.
 dominated(vpar,set) = \
   setunion(set,vpar_neighbours_of_set(vpar,set));

gp_inline__location="../alternate.tex:35732";
 \\ "undoms" is a vector of vertex numbers.
 \\ Return the size of the smallest dominating set, with undoms
 \\ optionally allowed to be undominated.
 flags_to_set(flags) = Vec(select(f->f, flags, 1));
 domnum_with_optional_undoms(vpar,undoms) = {
   my(domnum=#vpar);
   undoms=Set(undoms);
   forvec(flags=vector(#vpar,i,[0,1]),
          my(set=flags_to_set(flags),
             dom=dominated(vpar,set));
          dom=setunion(dom,undoms);
          if(#dom == #vpar,
             domnum=min(domnum,#set)));
   domnum;
 }

gp_inline__location="../alternate.tex:35870";
 TAtotdomsets_initial = {[0,1,4,25]};

gp_inline__location="../alternate.tex:35879";
 TAtotdomsets_formula(k) = 30^(2^(k-3));
 TAtotdomsets(k) = {
   if(k<#TAtotdomsets_initial,TAtotdomsets_initial[k+1],
      TAtotdomsets_formula(k));
 }

gp_inline__location="../alternate.tex:35889";
 TAtotdomsets_samples = {[0,1,4,25,900,810000,656100000000]};

gp_inline__location="../alternate.tex:35998";
 TAtotdomnum_formula(k) = 2^(k-1);
 TAtotdomnum(k) = if(k==0,-1, k==1, 2, TAtotdomnum_formula(k));

gp_inline__location="../alternate.tex:36007";
 TAtotdomnum_samples = {[2,2,4,8,16,32]};

gp_inline__location="../alternate.tex:36030";
 TAtotdomnumCount_formula(k) = 2^(2^(k-3));
 TAtotdomnumCount(k) = \
   if(k==0,0, k<=3,1, k==4,4, TAtotdomnumCount_formula(k));

gp_inline__location="../alternate.tex:36041";
 TAtotdomnumCount_samples = {[0,1,1,1,4,16,256,65536,4294967296]};

gp_inline__location="../alternate.tex:36109";
 TAtotdompoly_formula(k) = \
   (x^4 * (x+1) * (x+2) * (x^2+3*x+1))^(2^(k-3));
 TAtotdompoly(k) = {
   if(k==0,return(0));   \\ single vertex
   if(k==1,return(x^2)); \\ path-2, both
   if(k==2,return(x^2*(x+1)^2));  \\ path-4
   if(k==3,return(x^4*(x^2+3*x+1)^2));  \\ path-4
   TAtotdompoly_formula(k);
 }

gp_inline__location="../alternate.tex:36124";
 phi = (1 + geom_sqrt_as_quad(5))/2;

gp_inline__location="../alternate.tex:36199";
 TAsemitotdomnum_initial = [-1, 2, 2, 4];

gp_inline__location="../alternate.tex:36202";
 TAsemitotdomnum(k) = \
   if(k<=3, TAsemitotdomnum_initial[k+1], TAdomnum(k));

gp_inline__location="../alternate.tex:36211";
 TAsemitotdomnumCount_initial = {[0,1,3,11]};

gp_inline__location="../alternate.tex:36218";
 TAsemitotdomnumCount(k) = \
  if(k<=3,TAsemitotdomnumCount_initial[k+1], 1);

gp_inline__location="../alternate.tex:36253";
 \\ with +1 for 1-based vpar
 gen_TAsemitotdomnum_k4_set1 = Set([5,7,4,13,10,12]);

gp_inline__location="../alternate.tex:36287";
 TA_vpar_sace_neighbours(k) = \
   vpar_neighbours_of_set(TA_vpar(k), TA_vpar_sace(k));
 TA_vpar_sace_and_neighbours(k) = \
   setunion(TA_vpar_sace(k), TA_vpar_sace_neighbours(k));

gp_inline__location="../alternate.tex:36300";
 semitotdominated(vpar,set) = {
   my(dom=dominated(vpar,set),
      neighbours=vpar_neighbours_of_set(vpar,set));
   neighbours=vpar_neighbours_of_set(vpar,neighbours);
   neighbours=setintersect(neighbours,set);
   setunion(dom,neighbours);
 }
 semitotdomnum_with_optional_undoms(vpar,undoms=[],with_undoms=[])={
   my(semitotdomnum=#vpar);
   undoms=Set(undoms);
   forvec(flags=vector(#vpar,i,[0,1]),
          my(set=flags_to_set(flags),
             dom=semitotdominated(vpar,set));
          dom=setunion(dom, undoms);
          dom=setunion(dom, setintersect(with_undoms,set));
          if(#dom == #vpar,
             semitotdomnum=min(semitotdomnum,#set);
             if(#set==4,print(set));
            ));
   semitotdomnum;
 }

gp_inline__location="../alternate.tex:36369";
 TAperfdomnum(k) = TAdomnum(k);

gp_inline__location="../alternate.tex:36377";
 TAperfdomnumCount_initial = {[1,2,2,2]};

gp_inline__location="../alternate.tex:36386";
 TAperfdomnumCount_formula(k) = 2^(2^(k-4));
 TAperfdomnumCount(k) = {
  if(k<=3,TAperfdomnumCount_initial[k+1],
     TAperfdomnumCount_formula(k));
 }

gp_inline__location="../alternate.tex:36394";
 TAperfdomnumCount_samples = {[1,2,2,2,2,4,16,256,65536]};

gp_inline__location="../alternate.tex:36434";
 \\ with +1 for 1-based vpar
 gen_TAperfdomnum_k4_set1_A = Set([5,2,3,12,15,14]);

gp_inline__location="../alternate.tex:36472";
 \\ with +1 for 1-based vpar
 gen_TAperfdomnum_k4_set1_B = Set([6,7,4,11,10,13]);

gp_inline__location="../alternate.tex:36591";
 TAdisdomnum_formula(k) = 2*TAdomnum(k);
 TAdisdomnum(k) = if(k==0,-1, TAdisdomnum_formula(k));

gp_inline__location="../alternate.tex:36596";
 TAdisdomnum_samples = {[2,4,6,12,24,48,96]};

gp_inline__location="../alternate.tex:36616";
 TAdisdomnumCount_initial = {[0,1,2]};

gp_inline__location="../alternate.tex:36624";
 TAdisdomnumCount_formula(k) = 2^(2^(k-3) - 1);
 TAdisdomnumCount(k) = {
   if(k<=2,TAdisdomnumCount_initial[k+1],
           TAdisdomnumCount_formula(k));
 }

gp_inline__location="../alternate.tex:36632";
 TAdisdomnumCount_samples = {[0,1,2,1,2,8,128,32768]};

gp_inline__location="../alternate.tex:36708";
 TAtotdomsets_base = 30^(1/8);
 thirty_pow_1_8_sample = {(1529819/1000000)};

gp_inline__location="../alternate.tex:36725";
 TAdomnumCount_base = 2^(1/4);
 two_pow_1_4_sample = {(1189207/1000000)};

gp_inline__location="../alternate.tex:36749";
 TAindomnumCount_base = 7^(1/16);
 seven_pow_1_16_sample = {(1129324/1000000)};

gp_inline__location="../alternate.tex:36775";
 TAtotdomnumCount_base = 2^(1/8);
 two_pow_1_8_sample = {(1090507/1000000)};

gp_inline__location="../alternate.tex:36803";
 TAdisdomnumCount_base = 2^(1/8);

gp_inline__location="../alternate.tex:36811";
 TAperfdomnumCount_base = 2^(1/16);
 two_pow_1_16_sample = {(1044273/1000000)};

gp_inline__location="../alternate.tex:36837";
 TAsemitotdomnumCount_base = 1;

gp_inline__location="../alternate.tex:37384";
 fpoint_by_limit(f,k) = \
   unexpand_k(k,alternate_point(floor(f * 2^k)));

gp_inline__location="../alternate.tex:37407";
 unexpand_k(k,z) = expand_k(-k,z);

gp_inline__location="../alternate.tex:37553";
 KM_sum(k) = sum(i=0,k,1/2^2^i);

gp_inline__location="../alternate.tex:37555";
 \\ Return KM vector of first n bits below the binary point.
 KM_vector(n) = vector(n,i,is_power_of_2(i));

gp_inline__location="../alternate.tex:37563";
 \\ Return KM fraction with n bits below the binary point.
 KM_sum_for_bits(n) = fromdigits(KM_vector(n),2)/2^n;

gp_inline__location="../alternate.tex:37596";
 KM_decimal_sample = {(081642150/100000000)};

gp_inline__location="../alternate.tex:37608";
 KM_binary_sample = {(011010001/100000000)};

gp_inline__location="../alternate.tex:37640";
 fpoint_of_KM_sum(k) = 3/4+1/2*I - sum(i=2,k-1, 1/2^2^i);

gp_inline__location="../alternate.tex:37647";
 fpoint_KM_re_sample = {(0683578/1000000)};

gp_inline__location="../alternate.tex:37666";
 fpoint_KM_re_binary_sample = {(1010111011111/10000000000000)};

gp_inline__location="../alternate.tex:37762";
 fpoint_of_Shallit_C_sum(k) = \
   1/2+1/2*I + sum(j=0,k-1, I^(j-1) * 1/2^2^j);

gp_inline__location="../alternate.tex:37785";
 fpoint_of_Shallit_C_sum_Re(k) = \
   1/2 + sum(j=0,floor(k/2)-1, (-1)^j * 1/4^(4^j));

gp_inline__location="../alternate.tex:37797";
 fpoint_of_Shallit_C_sum_Im(k) = \
   1/2 - sum(j=0,ceil(k/2)-1, (-1)^j * 1/2^(4^j));

gp_inline__location="../alternate.tex:37808";
 fpoint_Shallit_re_sample = {(0746093/1000000)};

gp_inline__location="../alternate.tex:37816";
 fpoint_Shallit_im_sample = {(0062484/1000000)};

gp_inline__location="../alternate.tex:37917";
 fXpred(f) = my(z=alternate_fpoint(f)); imag(z)==0;
 fGpred(f) = my(z=alternate_fpoint(f)); real(z)==imag(z);
 fVpred(f) = my(z=alternate_fpoint(f)); real(z)==1;

gp_inline__location="../alternate.tex:38138";
 fBpred_state_table = {[ 2,8;      \\ x
                         1,6;      \\ g
                         9,5;      \\ v
                         7,5;      \\ x*
                         3,4;      \\ g*
                         2,10;     \\ v*
                         7,11;     \\ 0
                         11,8;     \\ 1
                         11,10;    \\ t0
                         9,11;     \\ t1
                         11,11 ]}; \\ non
 fBpred_X        = 1;
 fBpred_G        = 2;
 fBpred_V        = 3;
 fBpred_X_tilde  = 4;
 fBpred_G_tilde  = 5;
 fBpred_V_tilde  = 6;
 fBpred_zeros    = 7;
 fBpred_ones     = 8;
 fBpred_t0       = 9;
 fBpred_t1       = 10;
 fBpred_non      = 11;
 fBpred_transition(state,bit) = fBpred_state_table[state,bit+1];
 fBpred_transitions(state,v) = \
   for(i=1,#v, state=fBpred_transition(state,v[i])); state;
 fBpred_by_states_of_vecper(fv,state) = {
   state=fBpred_transitions(state, vecper_fixed(fv));
   fv=vecper_periodic(fv);
   if(fv==[],fv=[0]);
   for(rep=1,4, state=fBpred_transitions(state,fv));
   state!=fBpred_non;
 }
 fBpred_by_states_of_frac(f,state) = \
   fBpred_by_states_of_vecper(vecper_frac_digits(f,2),state);

gp_inline__location="../alternate.tex:38536";
 z_exact_binary_k(z) = {
   is_power_of_2(denominator(z)) || error();
   my(k=0);
   while(denominator(z)>1,z=expand(z);k++);
   k;
 }
 z_exact_binary_to_f_list(z) = {
   is_power_of_2(denominator(z)) || error();
   my(k=z_exact_binary_k(z));
   z=expand_k(k,z);
   my(ret=List([]));
   concat(vector(2,s,my(an=alternate_unpoint(z,if(s==1,1,-1)));
                     if(an[1]!=0,[],
                        my(n=an[2]); [n-2/3, n, n+2/3]/2^k)));
 }

gp_inline__location="../alternate.tex:38819";
 fraction_transform(f) = if(f<=1/2, 2*f, 2*(1-f));
 fraction_transform_list(f,len) = {
   my(l=List([]));
   for(i=1,len, listput(l,f); f=fraction_transform(f));
   Vec(l);
 }

gp_inline__location="../alternate.tex:43179";
 \\ is_variable(str) returns true if str is the name of a variable,
 \\ meaning a "foo" not equal to its own symbol 'foo.
 is_variable(str) = eval(str)!=eval(Str("'",str));

gp_inline__location="../alternate.tex:43184";
 \\ exceptions b=1+I, p(k), r, s(m).
 char_variables_allowed = Set(["b"]);
 check_char_variables() = {
   my(char_variables_ok = 1);
   for(ch=Vecsmall("a")[1], Vecsmall("z")[1],
       my(str = Strchr(ch));
       if(is_variable(str) && ! setsearch(char_variables_allowed,str),
          print("Variable left: ",str," = ",eval(str));
          char_variables_ok = 0));
   char_variables_ok;
 }
